#include <stdarg.h>
#include <ctype.h>

#include "log.h"
#include "console.h"
#include "common.h"


#define	BLNKW	(2)	/* ̗] */
#define	BLNKH	(2)	/* c̗] */


VSurface *JFont::ZFont = NULL;	// SptHgf[^T[tFXւ̃|C^
VSurface *JFont::HFont = NULL;	// ptHgf[^T[tFXւ̃|C^
int JFont::zWidth  = 0;			// Sp̕
int JFont::zHeight = 0;			//           
int JFont::hWidth  = 0;			// p̕
int JFont::hHeight = 0;			//           


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
JFont::JFont( void ){}

////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
JFont::~JFont( void ){}


////////////////////////////////////////////////////////////////
// tHgt@CJ
////////////////////////////////////////////////////////////////
bool JFont::OpenFont( char *zfilename, char *hfilename )
{
	VRect ff;
	
	// ɓǍ܂Ăj
	CloseFont();
	
	// Ƃ肠TCYw
	hWidth  = FSIZE;
	hHeight = FSIZE * 2;
	zWidth  = FSIZE * 2;
	zHeight = FSIZE * 2;
	
	// tHgt@Cǂݍ
	// tHgt@C΃_~[쐬
	if( !(HFont = LoadImg( hfilename )) ){
		HFont = new VSurface;
		HFont->InitSurface( hWidth*192, hHeight*2, 8 );
		HFont->Fill( 0 );
		for( int y=0; y<2; y++ )
			for( int x=0; x<192; x++ ){
				ff.x = hWidth*x+1;
				ff.y = hHeight*y+1;
				ff.w = hWidth-1;
				ff.h = hHeight-1;
				HFont->Fill( 15, &ff );
			}
	}
	if( !(ZFont = LoadImg( zfilename )) ){
		ZFont = new VSurface;
		ZFont->InitSurface( zWidth*96, zHeight*96, 8 );
		ZFont->Fill( 0 );
		for( int y=0; y<96; y++ )
			for( int x=0; x<96; x++ ){
				ff.x = zWidth*x+1;
				ff.y = zHeight*y+1;
				ff.w = zWidth-1;
				ff.h = zHeight-1;
				ZFont->Fill( 15, &ff );
			}
	}
	
	// pƑSpŃTCYقȂꍇ͏قɍ킹(R\Y)
	hWidth  = min( HFont->Width(), ZFont->Width() ) / 96 / 2;
	hHeight = min( HFont->Height() / 2, ZFont->Height() / 96 );
	zWidth  = hWidth * 2;
	zHeight = hHeight;
	
	return true;
}


////////////////////////////////////////////////////////////////
// tHgj
////////////////////////////////////////////////////////////////
void JFont::CloseFont( void )
{
	if( HFont ){
		delete HFont;
		HFont = NULL;
	}
	if( ZFont ){
		delete ZFont;
		ZFont = NULL;
	}
}


////////////////////////////////////////////////////////////////
// p`
////////////////////////////////////////////////////////////////
void JFont::PutCharh( VSurface *dst, int dx, int dy, BYTE txt, BYTE fg, BYTE bg )
{
	PRINTD( GRP_LOG, "[JFont][PutCharh]\n" );
	
	int index = txt;
	
	// NbsO
	VRect sr,dr;
	sr.x = ( index % 128 ) * hWidth;
	sr.y = ( index / 128 ) * hHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = hWidth;
	sr.h = dr.h = hHeight;
	
	// ]
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			dst->PSet( dr.x + x, dr.y + y, (DWORD)( HFont && HFont->PGet( sr.x + x, sr.y + y ) ? fg : bg ) );
}


////////////////////////////////////////////////////////////////
// Sp`
////////////////////////////////////////////////////////////////
void JFont::PutCharz( VSurface *dst, int dx, int dy, WORD txt, BYTE fg, BYTE bg )
{
	PRINTD( GRP_LOG, "[JFont][PutCharz]\n" );
	
	BYTE high = (txt>>8) & 0xff;
	BYTE low  =  txt     & 0xff;
	
	Convert2Jis( &high, &low );
	int index = ( high - 0x20 ) * 96 + low - 0x20;
	
	// NbsO
	VRect sr,dr;
	sr.x = ( index % 96 ) * zWidth;
	sr.y = ( index / 96 ) * zHeight;
	dr.x = dx;
	dr.y = dy;
	sr.w = dr.w = zWidth;
	sr.h = dr.h = zHeight;
	
	// ]
	for( int y=0; y<sr.h; y++ )
		for( int x=0; x<sr.w; x++ )
			dst->PSet( dr.x + x, dr.y + y, (DWORD)( ZFont && ZFont->PGet( sr.x + x, sr.y + y ) ? fg : bg ) );
}







////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
ZCons::ZCons( void ) : Xmax(0), Ymax(0), x(0), y(0), fgc(FC_WHITE), bgc(FC_BLACK)
{
	INITARRAY( Caption, '\0' );
}

////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
ZCons::~ZCons( void ){}



////////////////////////////////////////////////////////////////
// R\[쐬(ŃTCYw)
////////////////////////////////////////////////////////////////
bool ZCons::Init( int winx, int winy, const char *caption, int fcol, int bcol )
{
	int winxr = winx * hWidth  + BLNKW * 2;
	int winyr = winy * hHeight + BLNKH * 2;
	
	return InitRes( winxr, winyr, caption, fcol, bcol );
}


////////////////////////////////////////////////////////////////
// R\[쐬(𑜓xŃTCYw)
////////////////////////////////////////////////////////////////
bool ZCons::InitRes( int winx, int winy, const char *caption, int fcol, int bcol )
{
	// T[tFX쐬
	if( !VSurface::InitSurface( winx, winy, 8 ) ) return false;
	
	// T[tFXŜwiFœhԂ
	VSurface::Fill( bcol );
	
	// cő啶ݒ
	Xmax = ( winx - BLNKW * 2 ) / hWidth;
	Ymax = ( winy - BLNKH * 2 ) / hHeight;
	
	// `͈͐ݒ
	con.x = BLNKW;
	con.y = BLNKH;
	con.w = Xmax * hWidth;
	con.h = Ymax * hHeight;
	
	if( caption ){	// LvV(t[)̏ꍇ
		// LvVۑ
		strncpy( Caption, caption, min( Xmax-2, (int)sizeof(Caption)-1 ) );
		
		// t[`
		DrawFrame();
		
		// cő啶ݒ
		Xmax -= 2;
		Ymax -= 2;
		
		// `͈͐ݒ
		con.x += hWidth;
		con.y += hHeight;
		con.w  = Xmax * hWidth;
		con.h  = Ymax * hHeight;
	}
	
	x = y = 0;
	
	return true;
}


////////////////////////////////////////////////////////////////
// J[\ʒuݒ
////////////////////////////////////////////////////////////////
void ZCons::Locate( int xx, int yy )
{
	// E[C[`FbN
	// E[C[
	if( ( xx >= 0 )&&( xx < Xmax ) ) x = xx;
	else if( ( xx < 0 )&&( (Xmax-xx)>=0 ) ) x = Xmax + xx;
	
	if( ( yy >= 0 )&&( yy < Ymax ) ) y = yy;
	else if( ( yy < 0 )&&( (Ymax-yy)>=0 ) ) y = Ymax + yy;
}


////////////////////////////////////////////////////////////////
// J[\ʒuݒ(ԐڍW)
////////////////////////////////////////////////////////////////
void ZCons::LocateR( int xx, int yy )
{
	x += xx;
	if( x < 0 ) x = 0;
	if( x >= Xmax ) x = Xmax;
	
	y += yy;
	if( y < 0 ) y = 0;
	if( y >= Ymax ) y = Ymax;
}


////////////////////////////////////////////////////////////////
// `Fݒ
////////////////////////////////////////////////////////////////
void ZCons::SetColor( BYTE fg, BYTE bg )
{
	fgc = fg;
	bgc = bg;
}

void ZCons::SetColor( BYTE fg )
{
	fgc = fg;
}


////////////////////////////////////////////////////////////////
// ʏ
////////////////////////////////////////////////////////////////
void ZCons::Cls( void )
{
	// `͈͂wiFœhԂ
	if( VSurface::pixels ) VSurface::Fill( bgc, &con );
	// J[\z[ɖ߂
	x = y = 0;
}


////////////////////////////////////////////////////////////////
// p1`
////////////////////////////////////////////////////////////////
void ZCons::PutCharH( BYTE c )
{
	JFont::PutCharh( this, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// ̃J[\ݒ
	x++;
}


////////////////////////////////////////////////////////////////
// Sp1`
////////////////////////////////////////////////////////////////
void ZCons::PutCharZ( WORD c )
{
	JFont::PutCharz( this, x * hWidth + con.x, y * hHeight + con.y, c, fgc, bgc );
	
	// ̃J[\ݒ
	x += 2;
}


////////////////////////////////////////////////////////////////
// t`(䕶Ή)
////////////////////////////////////////////////////////////////
void ZCons::Print( const char *text, ... )
{
	BYTE buf[1024];
	int num = 0;
	va_list ap;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// t`(䕶Ή)
////////////////////////////////////////////////////////////////
void ZCons::Printf( const char *text, ... )
{
	BYTE buf[1024];
	int num = 0;
	va_list ap;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( (char *)buf, text, ap );
	
	for( int i=0; i<num; i++ ){
		switch( buf[i] ){
		case '\n':	// s
			x = 0;
			y++;
			break;
			
		default:	// ʂ̕
			if( isprint( buf[i] ) )
				PutCharH( buf[i] );
			else{
				PutCharZ( buf[i]<<8 | buf[i+1] );
				i++;
			}
			
			// ̃J[\ݒ
			if( x >= Xmax ){
				x = 0;
				y++;
			}
		}
		
		// XN[?
		if( y >= Ymax){
			y = Ymax - 1;
			ScrollUp();
		}
	}
}


////////////////////////////////////////////////////////////////
// t`(El)
////////////////////////////////////////////////////////////////
void ZCons::Printfr( const char *text, ... )
{
	char buf[1024];
	int num = 0;
	va_list ap;
	
	// ϒWJiɕϊj
	va_start( ap, text );
	num = vsprintf( buf, text, ap );
	
	if( num > Xmax ) num = Xmax;
	Locate( -num, y );
	
	for( int i=0; i<num; i++ ){
		if( isprint( buf[i] ) )
			PutCharH( buf[i] );
		else{
			PutCharZ( buf[i]<<8 | buf[i+1] );
			i++;
		}
	}
}


////////////////////////////////////////////////////////////////
// ő啶擾
////////////////////////////////////////////////////////////////
int ZCons::GetXline( void )
{
	return Xmax;
}


////////////////////////////////////////////////////////////////
// cő啶擾
////////////////////////////////////////////////////////////////
int ZCons::GetYline( void )
{
	return Ymax;
}


////////////////////////////////////////////////////////////////
// g`
////////////////////////////////////////////////////////////////
void ZCons::DrawFrame( void )
{
	VRect frm;
	
	frm.x = con.x;
	frm.y = con.y + 4;
	frm.w = con.w;
	frm.h = con.h - 8;
	VSurface::Fill( fgc, &frm );
	
	frm.x += 1;
	frm.y += 1;
	frm.w -= 2;
	frm.h -= 2;
	VSurface::Fill( bgc, &frm );
	
	// LvV
	if( strlen( Caption ) > 0 ){
		Locate( 1, 0 );
		Print( " %s ", Caption );
	}
}


////////////////////////////////////////////////////////////////
// XN[Abv
////////////////////////////////////////////////////////////////
void ZCons::ScrollUp( void )
{
	VRect SPos,DPos;
	
	// ]
	SPos.x = con.x;
	SPos.y = con.y + hHeight;
	SPos.w = con.w;
	SPos.h = con.h - hHeight;
	
	// ]
	DPos.x = con.x;
	DPos.y = con.y;
	
	// XN[
	VSurface::Blit( &SPos, this, &DPos );
	
	
	// `͈͂wiFœhԂ
	DPos.x = con.x;
	DPos.y = con.y + con.h - hHeight;
	DPos.w = con.w;
	DPos.h = hHeight;
	VSurface::Fill( bgc, &DPos );
}
