#ifndef CPUS_H_INCLUDED
#define CPUS_H_INCLUDED

#include "typedef.h"
#include "p6device.h"


// CMTXe[^X
#define	CMTCLOSE	(0)
#define	LOADOPEN	(1)
#define	SAVEOPEN	(2)

// I/O|[gԍ
#define	IO8049_BUS	(0x00)	/* oX|[g */
#define	IO8049_P1	(0x01)	/* Port1 */
#define	IO8049_P2	(0x02)	/* Port2 */
#define	IO8049_T0	(0x03)	/* T0(OUT) */
#define	IO8049_INT	(0x04)	/* ~INT(IN) */


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class SUB6 : public P6DEVICE, public IDoko {
protected:
	int CmtStatus;						// CMTXe[^X
	int Status8049;						// 8049Xe[^X
	
	DWORD IntrFlag;						// ݗvtO
	
	BYTE KeyCode;						// L[R[h(ݗp)
	BYTE JoyCode;						// Q[pL[R[h(ݗp)
	BYTE CmtData;						// CMT[hf[^(ݗp)
	BYTE SioData;						// RS232CMf[^(ݗp)
	
	BYTE ReadIO( int );					// I/O|[gANZX Read
	void WriteIO( int, BYTE );			// I/O|[gANZX Write
	
	void WriteExt( BYTE );				// Oo(8255PortA)
	BYTE ReadExt();						// O(8255PortA)
	
	bool GetT0();						// eXg0Xe[^X擾
	bool GetT1();						// eXg1Xe[^X擾
	bool GetINT();						// O݃Xe[^X擾
	
	void OutVector();					// ݃xN^o
	void OutData()	;					// ݃f[^o
	
	virtual void ExtIntrExec( BYTE ) = 0;	// Oݏ
	
public:
	SUB6( VM6 *, const P6ID& );			// RXgN^
	virtual ~SUB6();					// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	void Reset();						// Zbg
	
	// L[{[h֘A
	void ReqKeyIntr( int, BYTE );		// L[ݗv
	void ReqJoyIntr();					// Q[pL[ݗv
	
	// CMT֘A
	void ReqCmtIntr( BYTE );			// CMT READݗv
	int GetCmtStatus();					// CMTXe[^X擾
	bool IsCmtIntrReady();				// CMTݔ?
	
	void ExtIntr();						// Oݗv
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class SUB60 : public SUB6 {
protected:
	void ExtIntrExec( BYTE );			// Oݏ
	
public:
	SUB60( VM6 *, const P6ID& );		// RXgN^
	~SUB60();							// fXgN^
};


class SUB62 : public SUB6 {
protected:
	void ExtIntrExec( BYTE );			// Oݏ
	
public:
	SUB62( VM6 *, const P6ID& );		// RXgN^
	~SUB62();							// fXgN^
};



#endif	// CPUS_H_INCLUDED
