#include <string.h>

#include "log.h"
#include "d88.h"
#include "common.h"
#include "osd.h"


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cD88::cD88( void ) : Protected(false)
{
	PRINTD( D88_LOG, "[D88][cD88]\n" )
	
	INITARRAY( FileName, '\0' );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cD88::~cD88( void )
{
	if( d88.fp ) fclose( d88.fp );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
bool cD88::Init( char *fname )
{
	PRINTD( D88_LOG, "[D88][Init] %s\n", fname )
	
	strncpy( FileName, fname, PATH_MAX );
	
	// ǎpȂveNgԂŊJ
	if( OSD_FileReadOnly( FileName ) ){
		d88.fp = FOPENEN( FileName, "rb" );
		Protected = true;	// veNgV[
	}else{
		d88.fp = FOPENEN( FileName, "rb+" );
		Protected = false;	// veNgV[Ȃ
	}
	
	if( !d88.fp ){
		*FileName = 0;
		Protected = false;
		return false;
	}
	
	ReadHeader88();	// D88 wb_Ǎ
	
	return true;
}


////////////////////////////////////////////////////////////////
// D88 wb_Ǎ
////////////////////////////////////////////////////////////////
void cD88::ReadHeader88( void )
{
	PRINTD( D88_LOG, "[D88][ReadHeader88]\n" )
	
	if( d88.fp ){
		// DISK
		fread( d88.name, sizeof(BYTE), 17, d88.fp );
		d88.name[16] = '\0';
		
		// U[uǂ
		fread( d88.reserve, sizeof(BYTE), 9, d88.fp );
		
		// CgveNg
		d88.protect = fgetc( d88.fp );
		if( d88.protect ) Protected = true;
		else if( Protected ) d88.protect = 0x10;
		
		// DISK̎
		d88.type = fgetc( d88.fp );
		
		// DISK̃TCY
		d88.size = FGETDWORD( d88.fp );
		
		// gbÑItZbge[u
		for( int i=0; i<164; i++ )
			d88.table[i] = FGETDWORD( d88.fp );
		
		// ANZX̃gbNNo
		d88.trkno = 0;
		
		PRINTD( D88_LOG, " FileName : %s\n", d88.name )
		PRINTD( D88_LOG, " Protect  : %s\n", d88.protect ? "ON" : "OFF" )
		PRINTD( D88_LOG, " Format   : %d\n", d88.type )
		PRINTD( D88_LOG, " Size     : %d\n", (int)d88.size )
	}
}


////////////////////////////////////////////////////////////////
// D88 ZN^Ǎ
////////////////////////////////////////////////////////////////
void cD88::ReadSector88( void )
{
	PRINTD( D88_LOG, "[D88][ReadSector88]\n" );
	
	if( d88.fp && d88.table[d88.trkno] ){
		d88.secinfo.c = fgetc( d88.fp );			// ID  C (V_No Жʂ̏ꍇ=gbNNo)
		d88.secinfo.h = fgetc( d88.fp );			// ID  H (wb_AhX Жʂ̏ꍇ=0)
		d88.secinfo.r = fgetc( d88.fp );			// ID  R (gbÑZN^No)
		d88.secinfo.n = fgetc( d88.fp );			// ID  N (ZN^TCY 0:256 1:256 2:512 3:1024)
		d88.secinfo.sec_nr  = FGETWORD( d88.fp );	// ̃gbNɑ݂ZN^̐
		d88.secinfo.density = fgetc( d88.fp );		// L^x     0x00:{x   0x40:Px
		d88.secinfo.deleted = fgetc( d88.fp );		// DELETED MARK 0x00:m[} 0x10:DELETED
		d88.secinfo.status  = fgetc( d88.fp );		// Xe[^X
		fread( d88.secinfo.reserve, sizeof(BYTE), 5, d88.fp );	// U[uǂ
		d88.secinfo.size   = FGETWORD( d88.fp );	// ̃ZN^̃f[^TCY
		d88.secinfo.data   = ftell( d88.fp );		// f[^ւ̃ItZbg
		d88.secinfo.offset = 0;						// ɓǍރf[^̃ZN^擪̃ItZbg
		d88.secinfo.secno++;						// ANZX̃ZN^No
		
		PRINTD( D88_LOG, " C      : %d\n", d88.secinfo.c )
		PRINTD( D88_LOG, " H      : %d\n", d88.secinfo.h )
		PRINTD( D88_LOG, " R      : %d\n", d88.secinfo.r )
		PRINTD( D88_LOG, " N      : %d\n", d88.secinfo.n )
		PRINTD( D88_LOG, " SectNum: %d/%d\n", d88.secinfo.secno, d88.secinfo.sec_nr )
		PRINTD( D88_LOG, " Density: %s\n", d88.secinfo.density&0x40 ? "S" : "D" )
		PRINTD( D88_LOG, " Del    : %s\n", d88.secinfo.deleted&0x10 ? "DELETED" : "NORMAL" )
		PRINTD( D88_LOG, " Stat   : %02X\n", d88.secinfo.status )
		PRINTD( D88_LOG, " Size   : %d\n", d88.secinfo.size )
		PRINTD( D88_LOG, " Offset : %d\n", (int)d88.secinfo.data )
	}
}


////////////////////////////////////////////////////////////////
// 1byte Ǎ
////////////////////////////////////////////////////////////////
BYTE cD88::Get8( void )
{
	BYTE dat;
	
	PRINTD( D88_LOG, "[D88][Get8] -> " )
	
	if( d88.fp && d88.table[d88.trkno] ){
		// ZN^̏IɓB玟̃ZN^V[N
		// ŏIZN^͓̎gbN̐擪ZN^Ɉړ
		// G[ZN^̏ꍇ͎̃ZN^ɈړȂ(Ditt!̃G[Ή)
		if( d88.secinfo.offset >= d88.secinfo.size && !d88.secinfo.status ){
			if( d88.secinfo.secno > d88.secinfo.sec_nr ) Seek( d88.trkno );
			else										 ReadSector88();
		}
		dat = fgetc( d88.fp );
		d88.secinfo.offset++;
		
		PRINTD( D88_LOG, "%02X\n", dat );
		
		return dat;
	}
	PRINTD( D88_LOG, "false(0xff)\n" );
	
	return 0xff;
}


////////////////////////////////////////////////////////////////
// 1byte 
////////////////////////////////////////////////////////////////
bool cD88::Put8( BYTE dat )
{
	PRINTD( D88_LOG, "[D88][Put8] -> %02X(%02d:%02d:%02d:%02d)", dat, d88.secinfo.c, d88.secinfo.h, d88.secinfo.r, d88.secinfo.n );
	
	if( d88.fp && d88.table[d88.trkno] && !d88.protect ){
		// ZN^̏IɓB玟̃ZN^V[N
		// ŏIZN^͓̎gbN̐擪ZN^Ɉړ
		if( d88.secinfo.offset >= d88.secinfo.size ){
			if( d88.secinfo.secno > d88.secinfo.sec_nr ) Seek( d88.trkno );
			else										 ReadSector88();
		}
		
		// r+,w+,a+ ŊJt@Cɑ΂ēǍ݂Ə݂؂ւꍇ
		// K fsetpos,fseek,rewind ̂ꂩ̊֐sKv炵
		fseek( d88.fp, 0, SEEK_CUR );
		fputc( dat, d88.fp );
		fseek( d88.fp, 0, SEEK_CUR );
		
		d88.secinfo.offset++;
		
		PRINTD( D88_LOG, " ->OK\n" );
		
		return true;
	}
	PRINTD( D88_LOG, " ->NG\n" );
	
	return false;
}


////////////////////////////////////////////////////////////////
// V[N
////////////////////////////////////////////////////////////////
bool cD88::Seek( int trackno, int sectno )
{
	PRINTD( D88_LOG, "[D88][Seek] Track : %d Sector : %d ", trackno, sectno );
	
	if( d88.fp ){
		d88.trkno = trackno;
		d88.secinfo.secno = 0;
		
		// gbNȂUnformat
		if( !d88.table[d88.trkno] ){
			PRINTD( D88_LOG, "-> Unformat\n" );
			return false;
		}
		PRINTD( D88_LOG, "-> Track:%d\n", d88.trkno );
		
		// gbN̐擪V[N
		fseek( d88.fp, d88.table[d88.trkno], SEEK_SET );
		
		// ŏ̃ZN^Ǎ
		ReadSector88();
		
		// ړĨZN^𓪏o
		if( sectno > 1 ){
			fseek( d88.fp, (long)d88.secinfo.size, SEEK_CUR );
			ReadSector88();
		}
		
		PRINTD( D88_LOG, "-> OK\n" );
		
		return true;
	}
	PRINTD( D88_LOG, "-> false\n" );
	
	return false;
}


////////////////////////////////////////////////////////////////
// ZN^T
////////////////////////////////////////////////////////////////
bool cD88::SearchSector( BYTE c, BYTE h, BYTE r, BYTE n )
{
	PRINTD( D88_LOG, "[D88][SearchSector] C:%02X H:%02X R:%02X N:%02X ", c, h, r, n );
	
	if( Seek( d88.trkno ) ){
		// ړĨZN^܂ŋǂ
		while( d88.secinfo.secno <= d88.secinfo.sec_nr ){
			// ID`FbN
			if( ( d88.secinfo.c == c ) && ( d88.secinfo.h == h )
			 && ( d88.secinfo.r == r ) && ( d88.secinfo.n == n ) ){
				PRINTD( D88_LOG, "-> Found\n" );
				return true;
			}
			// vȂΎ̃ZN^Ǎ
			fseek( d88.fp, (long)d88.secinfo.size, SEEK_CUR );
			ReadSector88();
		}
	}
	PRINTD( D88_LOG, "-> false\n" );
	
	return false;
}


////////////////////////////////////////////////////////////////
// ݂CHRN擾
////////////////////////////////////////////////////////////////
void cD88::GetID( BYTE *C, BYTE *H, BYTE *R, BYTE *N )
{
	PRINTD( D88_LOG, "[D88][GetID] %02X %02X %02X %02X\n", d88.secinfo.c, d88.secinfo.h, d88.secinfo.r, d88.secinfo.n );
	
	if( C ) *C = d88.secinfo.c;
	if( H ) *H = d88.secinfo.h;
	if( R ) *R = d88.secinfo.r;
	if( N ) *N = d88.secinfo.n;
}


////////////////////////////////////////////////////////////////
// ݂̃ZN^TCY擾
////////////////////////////////////////////////////////////////
WORD cD88::GetSecSize( void )
{
	PRINTD( D88_LOG, "[D88][GetSecSize]\n" );
	
	return d88.secinfo.size;
}


////////////////////////////////////////////////////////////////
// ݂̃gbNԍ擾
////////////////////////////////////////////////////////////////
BYTE cD88::Track( void )
{
	PRINTD( D88_LOG, "[D88][Track]\n" );
	
	return d88.trkno;
}


////////////////////////////////////////////////////////////////
// ݂̃ZN^ԍ擾
////////////////////////////////////////////////////////////////
BYTE cD88::Sector( void )
{
	PRINTD( D88_LOG, "[D88][Sector]\n" );
	
	return d88.secinfo.secno;
}


////////////////////////////////////////////////////////////////
// ݂̃gbNɑ݂ZN^擾
////////////////////////////////////////////////////////////////
WORD cD88::SecNum( void )
{
	PRINTD( D88_LOG, "[D88][SecNum]\n" );
	
	return d88.secinfo.sec_nr;
}


////////////////////////////////////////////////////////////////
// ݂̃Xe[^X擾
////////////////////////////////////////////////////////////////
BYTE cD88::GetSecStatus( void )
{
	PRINTD( D88_LOG, "[D88][GetStatus]\n" );
	
	return d88.secinfo.status;
}


////////////////////////////////////////////////////////////////
// t@C擾
////////////////////////////////////////////////////////////////
char *cD88::GetFileName( void )
{
	return FileName;
}


////////////////////////////////////////////////////////////////
// DISKC[W擾
////////////////////////////////////////////////////////////////
char *cD88::GetDiskImgName( void )
{
	return (char *)d88.name;
}


////////////////////////////////////////////////////////////////
// veNgV[Ԏ擾
////////////////////////////////////////////////////////////////
bool cD88::IsProtect( void )
{
	return Protected;
}
