#ifndef DEBUG_H_INCLUDED
#define DEBUG_H_INCLUDED

#include "typedef.h"
#include "console.h"
#include "p6device.h"


#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#define	REGWINW	(40)
#define	REGWINH	( 8)
#define	MEMWINW	(40)
#define	MEMWINH	(15)
#define	MONWINW	(100)
#define	MONWINH	(30)

#define MAX_ARGS	(8)
#define	MAX_CHRS	(256)
#define	MAX_HIS		(11)
#define	PROMPT		"P6V>"

//------------------------------------------------------
//  _vEBhENX
//------------------------------------------------------
class cWndMem : public P6DEVICE, public ZCons {
private:
	WORD Addr;							// \AhX
	
public:
	cWndMem( VM6 *, const P6ID& );		// RXgN^
	~cWndMem();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
	
	void SetAddress( WORD addr ){ Addr = addr & 0xfff8; }	// \AhXݒ
	WORD GetAddress(){ return Addr; }						// \AhX擾
};


//------------------------------------------------------
//  WX^EBhENX
//------------------------------------------------------
class cWndReg : public P6DEVICE, public ZCons {
private:
	
public:
	cWndReg( VM6 *, const P6ID& );		// RXgN^
	~cWndReg();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
};


//------------------------------------------------------
//  j^EBhENX
//------------------------------------------------------
class cWndMon : public P6DEVICE, public ZCons {
private:
	char KeyBuf[MAX_CHRS];				// L[̓obt@
	char HisBuf[MAX_HIS][MAX_CHRS];		// L[̓qXgobt@
	char *Argv[MAX_ARGS];				// ւ̃|C^z
	int Argc;							// ̌
	int ArgvCounter;					// Shift()pJE^
	
	struct argv{						// p
		int Type;	// ̎		ARGV_xxx
		int Val;	// ̒l			ARG_xxx ܂́A
		char *Str;	// ̕		Argv[xxx]Ɠ
		argv() : Type(0), Val(0), Str(NULL) {}
	} argv;
	
	int GetArg();						// 
	void Shift();						// zVtg
	void Exec( int );					// R}hs
	void Help( int );					// wv\
	
public:
	cWndMon( VM6 *, const P6ID& );		// RXgN^
	~cWndMon();							// fXgN^
	
	bool Init();						// 
	void Update();						// EBhEXV
	
	void KeyIn( int, bool, int );		// L[͏
	
	void BreakIn( WORD );				// u[N|CgB
};
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#endif	// DEBUG_H_INCLUDED
