#ifndef MC6847_H_INCLUDED
#define MC6847_H_INCLUDED

#include "../typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cMC6847core {
protected:
	BYTE COL_AN[5];			// J[R[h(At@j[bN)
	BYTE COL_SG[9];			// J[R[h(Z~OtBbN)
	BYTE COL_CG[10][4];		// J[R[h(J[OtBbN)
	BYTE COL_RG[2][2];		// J[R[h(mNOtBbN)
	
	bool CrtDisp;			// CRT\ true:\ false:\
	bool N60Win;			// EBhETCY true:N60 false:N60m
	int Mode4Col;			// [h4J[[h 0:m 1:/ 2:/ 3:sN/ 4:/sN
	
	WORD VAddr;				// AhXJE^
	WORD HAddr;				// AhXJE^
	int RowCntA;			// \CJE^(At@j[bN,Z~O)
	int RowCntG;			// \CJE^(OtBbN)
	
	// Agr[gf[^
	BYTE AT_AG;
	BYTE AT_AS;
	BYTE AT_IE;
	BYTE AT_GM;
	BYTE AT_CSS;
	BYTE AT_INV;
	
	int GetW();									// obNobt@擾(Kl)
	int GetH();									// obNobt@擾(Kl)
	
	virtual BYTE *GetBufAddr() = 0;				// obt@AhX擾
	virtual int GetBufPitch() = 0;				// obt@sb`(1LineoCg)擾
	virtual int GetBufHeight() = 0;				// obt@擾
	
	virtual void LatchGMODE() = 0;				// Agr[gf[^b`(OtBbN[ĥ)
	virtual void LatchAttr() = 0;				// Agr[gf[^b`
	virtual BYTE GetAttr() = 0;					// Agr[gf[^擾
	virtual BYTE GetVram() = 0;					// VRAMf[^擾
	virtual BYTE GetFont1( WORD ) = 0;			// Font1f[^擾
	
public:
	cMC6847core();								// RXgN^
	virtual ~cMC6847core();						// fXgN^
	
	virtual void UpdateBackBuf() = 0;			// obNobt@XV
	
	void SetCrtDisp( bool );					// CRT\Ԑݒ
	
	bool GetWinSize();							// EBhETCY擾
	
	int GetMode4Color();						// [h4J[[h擾
	void SetMode4Color( int );					// [h4J[[hݒ
};


class cMC6847_1 : public virtual cMC6847core {
protected:
	virtual BYTE GetFont0( WORD ) = 0;			// Font0(VDG Font)f[^擾
	BYTE GetBcol();								// {[_[J[擾
	
	void Draw1line1( int );						// 1C`(N60)
	
public:
	cMC6847_1();								// RXgN^
	virtual ~cMC6847_1();						// fXgN^
	
	void UpdateBackBuf();						// obNobt@XV
};


class cMC6847_2 : public virtual cMC6847core {
protected:
	BYTE COL_AN2[16];		// J[R[h(At@j[bN 60m)
	BYTE COL_CG3[2][16];	// J[R[h(J[OtBbN 60m [h3)
	BYTE COL_CG4[2][16];	// J[R[h(J[OtBbN 60m [h4)
	
	bool Mk2CharMode;		// mk2 \[h true:LN^ false:OtBbN
	bool Mk2GraphMode;		// mk2 OtBbN𑜓x true:160*200 false:320*200
	
	int Css1;				// F̑gݍ킹
	int Css2;
	int Css3;
	
	virtual BYTE GetFont2( WORD ) = 0;			// Font2f[^擾
	BYTE GetBcol();								// {[_[J[擾
	
	void Draw1line1( int );						// 1C`(N60)
	void Draw1line2( int );						// 1C`(N60m)
	
public:
	cMC6847_2();								// RXgN^
	virtual ~cMC6847_2();						// fXgN^
	
	void UpdateBackBuf();						// obNobt@XV
};


#endif	// MC6847_H_INCLUDED
