#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED

#include "../typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cZ80 {
public:
	// yAWX^ f[^^`
	typedef union {
	#if BYTEORDER == BIG_ENDIAN
	 	struct { BYTE h,l; } B;
	#else
		struct { BYTE l,h; } B;
	#endif
				 WORD        W;
	} PAIR;
	
	// WX^Q \̒`
	struct Register {
		PAIR AF, BC, DE, HL;	// ėpWX^
		PAIR IX, IY, PC, SP;	// pWX^
		PAIR AF1,BC1,DE1,HL1;	//   WX^
		BYTE I, R;				// ꃌWX^
		BYTE R_saved;			// R reg ۑp
		BYTE IFF,IFF2;			// IFF,IFF2
		BYTE IM;				// [h
		BYTE Halt;				// HALT tO
	};
	
protected:
	typedef int8_t	offset;
	
	PAIR AF, BC, DE, HL;	// ėpWX^
	PAIR IX, IY, PC, SP;	// pWX^
	PAIR AF1,BC1,DE1,HL1;	//   WX^
	BYTE I, R;				// ꃌWX^
	BYTE R_saved;			// R reg ۑp
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// [h
	BYTE Halt;				// HALT tO
	
	int mstate;				// ANZXEFCg Xe[g
	
	// tFb`(M1)
	virtual BYTE Fetch( WORD, int * )   = 0;
	
	// ANZX(EFCgȂ)
	virtual BYTE ReadMemNW( WORD )      = 0;
	
	// ANZX(EFCg)
	virtual BYTE ReadMem( WORD )        = 0;
	virtual void WriteMem( WORD, BYTE ) = 0;
	
	// I/O|[gANZX
	virtual BYTE ReadIO( int )          = 0;
	virtual void WriteIO( int, BYTE )   = 0;
	
	// ݃xN^擾
	virtual int GetIntrVector()         = 0;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void PrintfHead( char *, WORD, int );	// AhX/CXgNVR[h̕\
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	cZ80();						// RXgN^
	virtual ~cZ80();			// fXgN^
	
	void Reset();				// Zbg
	int Exec();					// 1ߎs
	
	virtual bool IsBUSREQ();	// BUSREQ擾
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// fobOp
	int Disasm( char *, WORD );		// 1CtAZu
	void GetRegister( Register * );	// WX^l擾
	void SetRegister( Register * );	// WX^lݒ
	WORD GetPC();					// PCWX^l擾
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
};


#endif		// Z80_H_INCLUDED
