#include <stdlib.h>
#include <string.h>
#include <new>

#include "p6el.h"
#include "log.h"
#include "disk.h"
#include "error.h"
#include "schedule.h"

// CxgID
// --- mini FDD ---
#define EID_INIT1	(1)		// 00h CjVCY(hCu1)
#define EID_INIT2	(2)		// 00h CjVCY(hCu2)
#define EID_WRDATEX	(21)	// 01h Cg f[^s
#define EID_RDDATEX	(22)	// 02h [h f[^s
#define EID_GETPAR	(30)	// p[^M


// --- FDC ---
#define	EID_SEEK1	(101)
#define	EID_SEEK2	(102)
#define	EID_SEEK3	(103)
#define	EID_SEEK4	(104)
#define	EID_EXWAIT	(105)


//************* Wait (us) *************
// --- mini FDD ---
// ̕ 悭Ȃ̂ŒĂƁ[
#define WFDD_INIT			(500000)	// 00h CjVCY
#define WFDD_WRDAT			(100)		// 01h Cg f[^
#define WFDD_RDDAT			(100)		// 02h [h f[^
#define WFDD_SDDAT			(100)		// 03h Zh f[^
#define WFDD_COPY			(100)		// 04h Rs[
#define WFDD_FORMAT			(100)		// 05h tH[}bg
#define WFDD_SDRES			(100)		// 06h Zh Ug Xe[^X
#define WFDD_SDDRV			(100)		// 07h Zh hCu Xe[^X
#define WFDD_TRN			(100)		// 11h gX~bg
#define WFDD_RCV			(100)		// 12h V[u
#define WFDD_LOAD			(100)		// 14h [h
#define WFDD_SAVE			(100)		// 15h Z[u
#define WFDD_GETPAR			(100)		// p[^M
#define WFDD_SEEK			(13000)		// Ƃ肠SRT=13


// --- FDC ---
#define WAIT_SEEK			(1000*2)	// NbN4MHzȂ̂2{
#define WAIT_BYTE			(32)
#define WAIT_TRACK			(WAIT_BYTE*6250)
#define WAIT_2MS			(2000)

static const int Gap3size[] = {  26,  54,  84, 116,  150,  186,  224,  264 };
static const int Gap4size[] = { 488, 152, 182,  94, 1584, 1760, 2242, 4144 };

#define WAIT_GAP0			(WAIT_BYTE*( 80+12+(3+1)+50 ))

#define WAIT_ID				(WAIT_BYTE*( 12+(3+1)+4+2+22 ))
#define WAIT_DATA(n)		(WAIT_BYTE*( 12+(3+1)+(128<<(n))+2+Gap3size[(n)&7] ))
#define WAIT_SECTOR(n)		(WAIT_ID + WAIT_DATA(n))

#define WAIT_RID_ID			(WAIT_BYTE*( 12+(3+1)+4+2 ))
#define WAIT_RID_DATA(n)	(WAIT_BYTE*( 22 + 12+(3+1)+(128<<(n))+2+Gap3size[(n)&7] ))

#define WAIT_RDT_ID			(WAIT_BYTE*( 12+(3+1)+4+2+22 + 12+(3+1) ))
#define WAIT_RDT_DATA(n)	(WAIT_BYTE*( (128<<(n))+2+Gap3size[(n)&7] ))

#define WAIT_GAP3(n)		(WAIT_BYTE*( Gap3size[(n)&7] ))
#define WAIT_GAP4(n)		(WAIT_BYTE*( Gap4size[(n)&7] ))




////////////////////////////////////////////////////////////////
// fBXN NX
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DSK6::DSK6( VM6 *vm, const P6ID& id ) : P6DEVICE(vm,id), DrvNum(0)
{
	for( int i=0; i<MAXDRV; i++ ){
		ZeroMemory( FilePath[i], PATH_MAX );
		Dimg[i] = NULL;
		Sys[i]  = false;
	}
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSK6::~DSK6( void )
{
	for( int i=0; i<DrvNum; i++ )
		if( Dimg[i] ) Unmount( i );
}


////////////////////////////////////////////////////////////////
// CxgR[obN֐
//
// :	id		CxgID
//			clock	NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSK6::EventCallback( int id, int clock ){}


////////////////////////////////////////////////////////////////
// EFCgݒ
////////////////////////////////////////////////////////////////
bool DSK6::SetWait( int eid, int wait )
{
	PRINTD( DISK_LOG, "[DISK][SetWait] %dus ->", wait );
	
	if( vm->evsc->Add( this, eid, wait, EV_US ) ){
		PRINTD( DISK_LOG, "OK\n" );
		return true;
	}else{
		PRINTD( DISK_LOG, "FALSE\n" );
		return false;
	}
}


////////////////////////////////////////////////////////////////
// DISK }Eg
////////////////////////////////////////////////////////////////
bool DSK6::Mount( int drvno, char *filename )
{
	PRINTD( DISK_LOG, "[DISK][Mount] Drive : %d\n", drvno );
	
	if( drvno >= DrvNum ) return false;
	
	// }Egς݂ł΃A}Eg
	if( Dimg[drvno] ) Unmount( drvno );
	
	// fBXNC[WIuWFNgm
	try{
		Dimg[drvno] = new cD88;
		if( !Dimg[drvno]->Init( filename ) ) throw Error::DiskMountFailed;
	}
	catch( std::bad_alloc ){	// new Ɏsꍇ
		Error::SetError( Error::MemAllocFailed );
		return false;
	}
	catch( Error::Errno i ){	// O
		Error::SetError( i );
		
		Unmount( drvno );
		return false;
	}
	
	// t@CpXۑ
	strncpy( FilePath[drvno], filename, PATH_MAX );
	
	// VXefBXN`FbN
	Dimg[drvno]->Seek( 0 );
	if( Dimg[drvno]->Get8() == 'S' &&
		Dimg[drvno]->Get8() == 'Y' &&
		Dimg[drvno]->Get8() == 'S' )
			Sys[drvno] = true;
	else
			Sys[drvno] = false;
	Dimg[drvno]->Seek( 0 );	// Ô
	
	return true;
}


////////////////////////////////////////////////////////////////
// DISK A}Eg
////////////////////////////////////////////////////////////////
void DSK6::Unmount( int drvno )
{
	PRINTD( DISK_LOG, "[DISK][Unmount] Drive : %d\n", drvno );
	
	if( drvno >= DrvNum ) return;
	
	if( Dimg[drvno] ){
		// fBXNC[WIuWFNgJ
		delete Dimg[drvno];
		Dimg[drvno] = NULL;
		*FilePath[drvno] = '\0';
		Sys[drvno] = false;
	}
}


////////////////////////////////////////////////////////////////
// hCu擾
////////////////////////////////////////////////////////////////
int DSK6::GetDrives( void )
{
	return DrvNum;
}


////////////////////////////////////////////////////////////////
// }Egς?
////////////////////////////////////////////////////////////////
bool DSK6::IsMount( int drvno )
{
	if( drvno < DrvNum ) return Dimg[drvno] ? true : false;
	else                 return false;
}


////////////////////////////////////////////////////////////////
// VXefBXN?
////////////////////////////////////////////////////////////////
bool DSK6::IsSystem( int drvno )
{
	return Sys[drvno];
}


////////////////////////////////////////////////////////////////
// veNg?
////////////////////////////////////////////////////////////////
bool DSK6::IsProtect( int drvno )
{
	if( !IsMount( drvno ) ) return false;
	
	return Dimg[drvno]->IsProtect();
}


////////////////////////////////////////////////////////////////
// t@CpX擾
////////////////////////////////////////////////////////////////
const char *DSK6::GetFile( int drvno )
{
	return FilePath[drvno];
}


////////////////////////////////////////////////////////////////
// DISK擾
////////////////////////////////////////////////////////////////
const char *DSK6::GetName( int drvno )
{
	if( !IsMount( drvno ) ) return "";
	
	return Dimg[drvno]->GetDiskImgName();
}









////////////////////////////////////////////////////////////////
// ~jtbs[fBXNNX
////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DSK60::DSK60( VM6 *vm, const ID& id ) :
	DSK6(vm,id), Device(id), io_D1H(0), io_D2H(0x08)
{
	INITARRAY( RBuf, 0 );
	INITARRAY( WBuf, 0 );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSK60::~DSK60( void ){}


////////////////////////////////////////////////////////////////
// CxgR[obN֐
//
// :	id		CxgID
//			clock	NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSK60::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_INIT1:		// 00h CjVCY(hCu1)
		PRINTD( DISK_LOG, "<< [DISK][EventCallback] EID_INIT1 >>\n" );
		if( DrvNum > 1 ){
			mdisk.busy = 2;
			DSK6::SetWait( EID_INIT2, WFDD_INIT );
			break;
		}
	case EID_INIT2:		// 00h CjVCY(hCu2)
		PRINTD( DISK_LOG, "<< [DISK][EventCallback] EID_INIT2 >>\n" );
		if( !(io_D2H&0x10) ){
			// DAVĂȂΑ҂
			DSK6::SetWait( EID_INIT2, WFDD_INIT );
		}else{
			mdisk.busy = 0;
			mdisk.RFD  = 1;
			mdisk.DAC  = 1;
		}
		break;
		
	case EID_WRDATEX:	// 01h Cg f[^s
		PRINTD( DISK_LOG, "<< [DISK][EventCallback] EID_WRDATEX >>\n" );
		mdisk.busy = 0;
		mdisk.RFD  = 1;
		mdisk.DAC  = 1;
		break;
		
	case EID_RDDATEX:	// 02h [h f[^s
		PRINTD( DISK_LOG, "<< [DISK][EventCallback] EID_RDDATEX >>\n" );
		mdisk.busy = 0;
		mdisk.RFD  = 1;
		mdisk.DAC  = 1;
		break;
		
	case EID_GETPAR:	// p[^M
		PRINTD( DISK_LOG, "<< [DISK][EventCallback] EID_GETPAR >>\n" );
		mdisk.RFD = 1;
		mdisk.DAC = 1;
		break;
		
	default:;
	}
}


////////////////////////////////////////////////////////////////
// DISK 
////////////////////////////////////////////////////////////////
bool DSK60::Init( int num )
{
	PRINTD( DISK_LOG, "[DISK][Init]\n" );
	
	DrvNum = max( min( num, MAXDRV ) , 0 );
	Reset();
	
	return true;
}


////////////////////////////////////////////////////////////////
// Zbg
////////////////////////////////////////////////////////////////
void DSK60::Reset( void )
{
	ZeroMemory( &mdisk, sizeof( DISK60 ) );
	mdisk.command = IDLE;	// 󂯎R}h
	mdisk.retdat  = 0xff;	// port D0H Ԃl
	
	io_D1H = 0;
	io_D2H = 0x08;
}


////////////////////////////////////////////////////////////////
// ANZX?
////////////////////////////////////////////////////////////////
bool DSK60::InAccess( int drvno )
{
	return ( mdisk.busy == ( drvno + 1 ) ) ? true : false;
}


////////////////////////////////////////////////////////////////
// DISKjbg̃f[^ (port D0H)
////////////////////////////////////////////////////////////////
BYTE DSK60::FddIn( void )
{
	PRINTD( DISK_LOG, "[DISK][FddIn]  <- " );
	
	if( mdisk.DAV && mdisk.step != 0 ){		// R}hŃf[^Lȏꍇ
		switch( mdisk.command ){
		case SEND_DATA:				// 03h Zh f[^
			PRINTD( DISK_LOG, "SEND_DATA" );
			// obt@ǂ
			mdisk.retdat = RBuf[mdisk.ridx++];
			if( mdisk.ridx >= mdisk.rsize ){
				mdisk.rsize   = 0;
				mdisk.ridx    = 0;
				mdisk.command = IDLE;
				mdisk.step    = 0;
			}
			break;
			
		case SEND_RESULT_STATUS:	// 06h Zh Ug Xe[^X
			PRINTD( DISK_LOG, "SEND_RESULT_STATUS" );
			//	Bit7:I/OItO
			//	Bit6:Ǎ݃obt@Ƀf[^ L:1 :0
			//	Bit5-1:-
			//	Bit0:G[L:1 :0
			mdisk.retdat = mdisk.rsize ? 0x40 : 0;
			break;
			
		case SEND_DRIVE_STATUS:		// 07h Zh hCu Xe[^X
			PRINTD( DISK_LOG, "SEND_DRIVE_STATUS" );
			mdisk.retdat = 0xf0;
			for( int i=DrvNum; i>0; i-- )
				mdisk.retdat |= 1<<(4+i);
			break;
			
		default:
			mdisk.retdat = 0xff;
		}
		PRINTD( DISK_LOG, "%02X\n", mdisk.retdat );
		
		return mdisk.retdat;
	}
	else{			// f[^ȏꍇ
		
		PRINTD( DISK_LOG, "FF\n" );
		
		return 0xff;
	}
}


////////////////////////////////////////////////////////////////
// DISKjbgւ̃R}hCf[^o (port D1H)
////////////////////////////////////////////////////////////////
void DSK60::FddOut( BYTE dat )
{
	PRINTD( DISK_LOG, "[DISK][FddOut]    -> %02X ", dat );
	
	int eid  = EID_GETPAR;
	int wait = WFDD_GETPAR;
	
	io_D1H = dat;
	mdisk.RFD = 0;
	
	if( mdisk.command == IDLE ){	// R}h̏ꍇ
		mdisk.command = dat;
		switch( mdisk.command ){
		case INIT:					// 00h CjVCY
			PRINTD( DISK_LOG, "INIT" );
			eid  = EID_INIT1;
			wait = WFDD_INIT;
			
			mdisk.busy = 1;
			break;
			
		case WRITE_DATA:			// 01h Cg f[^
			PRINTD( DISK_LOG, "WRITE_DATA" );
			mdisk.step  = 1;
			mdisk.wsize = 0;
			break;
			
		case READ_DATA:				// 02h [h f[^
			PRINTD( DISK_LOG, "READ_DATA" );
			mdisk.step  = 1;
			mdisk.rsize = 0;
			mdisk.ridx  = 0;
			break;
			
		case SEND_DATA:				// 03h Zh f[^
			PRINTD( DISK_LOG, "SEND_DATA" );
			mdisk.step = 1;
			break;
			
		case COPY:					// 04h Rs[
			PRINTD( DISK_LOG, "COPY" );
			break;
			
		case FORMAT:				// 05h tH[}bg
			PRINTD( DISK_LOG, "FORMAT" );
			break;
			
		case SEND_RESULT_STATUS:	// 06h Zh Ug Xe[^X
			PRINTD( DISK_LOG, "SEND_RESULT_STATUS" );
			mdisk.step = 1;
			break;
			
		case SEND_DRIVE_STATUS:		// 07h Zh hCu Xe[^X
			PRINTD( DISK_LOG, "SEND_DRIVE_STATUS" );
			mdisk.step = 1;
			break;
			
		case TRANSMIT:				// 11h gX~bg
			PRINTD( DISK_LOG, "TRANSMIT" );
			break;
			
		case RECEIVE:				// 12h V[u
			PRINTD( DISK_LOG, "RECEIVE" );
			break;
			
		case LOAD:					// 14h [h
			PRINTD( DISK_LOG, "LOAD" );
			break;
			
		case SAVE:					// 15h Z[u
			PRINTD( DISK_LOG, "SAVE" );
			break;
			
		default:
			eid = 0;
		}
	}else{					// f[^̏ꍇ
		switch( mdisk.command ){
		case WRITE_DATA:			// 01h Cg f[^
			switch( mdisk.step ){
			case 1:	// 01h:]ubN
				mdisk.blk   = max( dat, 16 );
				mdisk.size  = mdisk.blk*256;
				mdisk.step++;
				break;
				
			case 2:	// 02h:hCuԍ-1
				mdisk.drv = dat;
				mdisk.step++;
				break;
				
			case 3:	// 03h:gbNԍ
				mdisk.trk = dat;
				mdisk.step++;
				break;
				
			case 4:	// 04h:ZN^ԍ
				mdisk.sct = dat;
				mdisk.step++;
				break;
				
			case 5:	// 05h:f[^
				eid  = EID_WRDATEX;
				wait = 0;
				mdisk.busy = mdisk.drv + 1;
				
				WBuf[mdisk.wsize++] = dat;
				if( mdisk.wsize >= mdisk.size ){
					if( Dimg[mdisk.drv] ){
						// gbNNo2{(1D->2D)
						wait += abs( Dimg[mdisk.drv]->Track() - mdisk.trk*2 ) / 2;
						Dimg[mdisk.drv]->Seek( mdisk.trk*2 );
						Dimg[mdisk.drv]->SearchSector( mdisk.trk, 0, mdisk.sct, 1 );
						// obt@珑
						for( int i=0; i < mdisk.wsize; i++ )
							Dimg[mdisk.drv]->Put8( WBuf[i] );
						wait += mdisk.blk * WAIT_SECTOR(1);
					}
					mdisk.step = 0;
				}
				break;
			}
			break;
			
		case READ_DATA:				// 02h [h f[^
			switch( mdisk.step ){
			case 1:	// 01h:]ubN
				mdisk.blk  = max( dat, 16 );
				mdisk.size = mdisk.blk*256;
				mdisk.step++;
				break;
				
			case 2:	// 02h:hCuԍ-1
				mdisk.drv = dat;
				mdisk.step++;
				break;
				
			case 3:	// 03h:gbNԍ
				mdisk.trk = dat;
				mdisk.step++;
				break;
				
			case 4:	// 04h:ZN^ԍ
				mdisk.sct = dat;
				
				eid  = EID_RDDATEX;
				wait = 0;
				mdisk.busy = mdisk.drv + 1;
				
				if( Dimg[mdisk.drv] ){
					// gbNNo2{(1D->2D)
					wait += abs( Dimg[mdisk.drv]->Track() - mdisk.trk*2 ) / 2;
					Dimg[mdisk.drv]->Seek( mdisk.trk*2 );
					Dimg[mdisk.drv]->SearchSector( mdisk.trk, 0, mdisk.sct, 1 );
					// obt@ɓǍ
					for( mdisk.rsize = 0; mdisk.rsize < mdisk.size; mdisk.rsize++ )
						RBuf[mdisk.rsize] = Dimg[mdisk.drv]->Get8();
					wait += mdisk.blk * WAIT_SECTOR(1);
					mdisk.ridx = 0;
				}
				mdisk.step = 0;
				break;
			}
		}
	}
	
	PRINTD( DISK_LOG, "\n" );
	
	// EFCgݒ
	if( eid ) DSK6::SetWait( eid, wait );
}


////////////////////////////////////////////////////////////////
// DISKjbg̐M (port D2H)
////////////////////////////////////////////////////////////////
BYTE DSK60::FddCntIn( void )
{
	PRINTD( DISK_LOG, "[DISK][FddCntIn]  <- %02X %s %s %s\n",
						(io_D2H&0xf0) | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV,
						mdisk.DAC ? "DAC" : "", mdisk.RFD ? "RFD" : "", mdisk.DAV ? "DAV" : "" );
	
	io_D2H = (io_D2H&0xf0) | 0x08 | (mdisk.DAC<<2) | (mdisk.RFD<<1) | mdisk.DAV;
	return io_D2H;
}


////////////////////////////////////////////////////////////////
// DISKjbgւ̐Mo (port D3H)
////////////////////////////////////////////////////////////////
void DSK60::FddCntOut( BYTE dat )
{
	PRINTD( DISK_LOG, "[DISK][FddCntOut] -> %02X ", dat );
	
	if( dat&0x80 ){		// ŏbit`FbN
						// 1̏ꍇ8255̃[hݒȂ̂Ŗ(K[h0Ɖ肷)
		PRINTD( DISK_LOG, "8255 mode set\n" );
		return;
	}
	
	switch( (dat>>1)&0x07 ){
	case 7:	// bit7 ATN
		PRINTD( DISK_LOG, "ATN:%d", dat&1 );
		if( (dat&1) && !(io_D2H&0x80) ){
			mdisk.RFD = 1;
			mdisk.command = IDLE;
		}
		break;
		
	case 6:	// bit6 DAC
		PRINTD( DISK_LOG, "DAC:%d", dat&1 );
		if( (dat&1) && !(io_D2H&0x40) ) mdisk.DAV = 0;
		break;
		
	case 5:	// bit5 RFD
		PRINTD( DISK_LOG, "RFD:%d", dat&1 );
		if( (dat&1) && !(io_D2H&0x20) ) mdisk.DAV = 1;
		break;
		
	case 4:	// bit4 DAV
		PRINTD( DISK_LOG, "DAV:%d", dat&1 );
		if( !(dat&1) ) mdisk.DAC = 0;
		break;
	}
	
	if( dat&1 ) io_D2H |=   1<<((dat>>1)&0x07);
	else		io_D2H &= ~(1<<((dat>>1)&0x07));
	
	PRINTD( DISK_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// I/OANZX֐
////////////////////////////////////////////////////////////////
void DSK60::OutD1H( int, BYTE data ){ FddOut( data ); }
void DSK60::OutD2H( int, BYTE data ){ io_D2H = (data&0xf0) | (io_D2H&0x0f); }
void DSK60::OutD3H( int, BYTE data ){ FddCntOut( data ); }

BYTE DSK60::InD0H( int ){ return FddIn(); }
BYTE DSK60::InD1H( int ){ return io_D1H; }
BYTE DSK60::InD2H( int ){ return FddCntIn(); }

	









////////////////////////////////////////////////////////////////
// 66fBXNNX
////////////////////////////////////////////////////////////////

//************ FDC Status *******************
#define FDC_BUSY_D0					(0x01)
#define FDC_BUSY_D1					(0x02)
#define FDC_BUSY_D2					(0x04)
#define FDC_BUSY_D3					(0x08)
#define FDC_BUSY					(0x10)
#define FDC_NON_DMA					(0x20)
#define FDC_FD2PC					(0x40)
#define FDC_DATA_READY				(0x80)

//************* Result Status 0 *************
#define ST0_NOT_READY				(0x08)
#define ST0_EQUIP_CHK				(0x10)
#define ST0_SEEK_END				(0x20)
#define ST0_IC_NT					(0x00)
#define ST0_IC_AT					(0x40)
#define ST0_IC_IC					(0x80)
#define ST0_IC_AI					(0xc0)

//************* Result Status 1 *************
#define ST1_MISSING_ADDRESS_MARK	(0x01)
#define ST1_NOT_WRITABLE			(0x02)

//************* Result Status 2 *************
#define ST2_MISSING_ADDRESS_MARK_IN_DATA_FIELD	(0x01)

//************* Result Status 3 *************
#define ST3_TRACK0					(0x10)
#define ST3_READY					(0x20)
#define ST3_WRITE_PROTECT			(0x40)
#define ST3_FAULT					(0x80)

//************* Disk Bios Status *************
#define BIOS_READY					(0x00)
#define BIOS_WRITE_PROTECT			(0x70)
#define BIOS_ERROR					(0x80)
#define BIOS_ID_CRC_ERROR			(0xa0)
#define BIOS_DATA_CRC_ERROR			(0xb0)
#define BIOS_NO_DATA				(0xc0)
#define BIOS_MISSING_IAM			(0xe0)
#define BIOS_MISSING_DAM			(0xf0)






////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DSK66::DSK66( VM6 *vm, const ID& id ) : DSK6(vm,id), Device(id),
	SendBytes(0), DIO(false), B2Dir(false)
{
	INITARRAY( FDDBuf, 0 );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSK66::~DSK66( void ){}


////////////////////////////////////////////////////////////////
// CxgR[obN֐
//
// :	id		CxgID
//			clock	NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSK66::EventCallback( int id, int clock )
{
	int Drv = 0xff;
	
	switch( id ){
	case EID_SEEK1: Drv = 0; PRINTD( FDC_LOG, "[DSK66][EventCallback] EID_SEEK Drv:%d\n", Drv ); break;
	case EID_SEEK2: Drv = 1; PRINTD( FDC_LOG, "[DSK66][EventCallback] EID_SEEK Drv:%d\n", Drv ); break;
	case EID_SEEK3: Drv = 2; PRINTD( FDC_LOG, "[DSK66][EventCallback] EID_SEEK Drv:%d\n", Drv ); break;
	case EID_SEEK4: Drv = 3; PRINTD( FDC_LOG, "[DSK66][EventCallback] EID_SEEK Drv:%d\n", Drv ); break;
	case EID_EXWAIT:
		fdc.intr    = true;
		fdc.status |= FDC_DATA_READY;
		break;
		
	default:;
	}
	
	if( Drv < 4 ){
		fdc.SeekSta[Drv] = SK_END;
		fdc.PCN[Drv]     = fdc.NCN[Drv];
		fdc.intr         = true;
		fdc.status      |= 1<<Drv;
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
bool DSK66::Init( int num )
{
	DrvNum = max( min( num, MAXDRV ) , 0 );
	
	fdc.SRT = 5;		// Step Rate Time
	fdc.HUT = 240;		// Head Unloaded Time
	fdc.HLT = 38;		// Head Load Time
	fdc.ND  = false;	// true:Non DMA[h false:DMA[h
	
	Reset();
	
	return true;
}


////////////////////////////////////////////////////////////////
// Zbg
////////////////////////////////////////////////////////////////
void DSK66::Reset( void )
{
	ZeroMemory( &CmdIn,  sizeof( CmdBuffer ) );
	ZeroMemory( &CmdOut, sizeof( CmdBuffer ) );
	for( int i=0; i < 4; i++ ){
		fdc.NCN[i]     = 0;
		fdc.PCN[i]     = 0;
		fdc.SeekSta[i] = SK_STOP;
	}
	fdc.US     = 0;
	fdc.status = FDC_DATA_READY;
	fdc.intr   = false;
	
	SendBytes  = 0;
	DIO        = false;
	B2Dir      = false;
}


////////////////////////////////////////////////////////////////
// ANZX?
////////////////////////////////////////////////////////////////
bool DSK66::InAccess( int drvno )
{
	return ( (fdc.SeekSta[drvno] == SK_SEEK) ||
			((fdc.status & FDC_BUSY) && (fdc.US == drvno)) ) ? true : false;
}


////////////////////////////////////////////////////////////////
// FDDobt@
////////////////////////////////////////////////////////////////
void DSK66::BufWrite( int addr, BYTE data )
{
	FDDBuf[addr&0x3ff] = data;
}


////////////////////////////////////////////////////////////////
// FDDobt@Ǎ
////////////////////////////////////////////////////////////////
BYTE DSK66::BufRead( int addr )
{
	return FDDBuf[addr&0x3ff];
}


////////////////////////////////////////////////////////////////
// Xe[^Xobt@Ƀf[^
////////////////////////////////////////////////////////////////
void DSK66::PushStatus( BYTE data )
{
	PRINTD( FDC_LOG, "[DSK66][PushStatus] Index:%d ->%02X\n", CmdOut.Index, data );
	
	CmdOut.Data[CmdOut.Index++] = data;
}

////////////////////////////////////////////////////////////////
// Xe[^Xobt@f[^o
////////////////////////////////////////////////////////////////
BYTE DSK66::PopStatus( void )
{
	PRINTD( FDC_LOG, "%02X\n", (BYTE)CmdOut.Data[CmdOut.Index-1] );
	
	if( CmdOut.Index ) --CmdOut.Index;
	return CmdOut.Data[CmdOut.Index];
}


////////////////////////////////////////////////////////////////
// FDC ɏ
////////////////////////////////////////////////////////////////
void DSK66::OutFDC( BYTE data )
{
	PRINTD( FDC_LOG, "[DSK66][OutFDC] Index:%d ->%02X\n", CmdIn.Index, data );
	
	const int CmdLength[] = { 0,0,9,3,2,9,9,2,1,0,0,0,0,6,0,3 };
	
	fdc.intr = false;	// ǂݏƃLZ悤?
	
	if( !(fdc.status & FDC_FD2PC) ){
		CmdIn.Data[CmdIn.Index++] = data;
		
		// R}h̃R}h R}hs
		if( CmdLength[CmdIn.Data[0]&0xf] == CmdIn.Index ){
			fdc.status = FDC_FD2PC | FDC_BUSY | ( fdc.status & 0x0f );
			Exec();
		}else{
			fdc.status = FDC_DATA_READY | FDC_BUSY | ( fdc.status & 0x0f );
		}
	}
}


////////////////////////////////////////////////////////////////
// FDC Ǎ
////////////////////////////////////////////////////////////////
BYTE DSK66::InFDC( void )
{
	PRINTD( FDC_LOG, "[DSK66][InFDC] Index:%d ->", CmdOut.Index-1 );
	
	fdc.intr = false;	// ǂݏƃLZ悤?
	
	if( fdc.status & FDC_FD2PC ){
		if( CmdOut.Index == 1 ) fdc.status = FDC_DATA_READY | ( fdc.status & 0x0f );
		else					fdc.status = FDC_DATA_READY | FDC_FD2PC | FDC_BUSY | ( fdc.status & 0x0f );
		return PopStatus();
	}else{
		return 0xff;
	}
}


////////////////////////////////////////////////////////////////
// FDC R}hs
////////////////////////////////////////////////////////////////
void DSK66::Exec( void )
{
	PRINTD( FDC_LOG, "[DSK66][Exec] Command:%02X", CmdIn.Data[0]&0x1f );
	
	CmdOut.Index = 0;
	
	switch( CmdIn.Data[0] & 0x1f ){
	case 0x02:	// Read Diagnostic
		PRINTD( FDC_LOG, " Read Diagnostic\n" );
		ReadDiagnostic();
		break;
	case 0x03:	// Specify
		PRINTD( FDC_LOG, " Specify\n" );
		Specify();
		break;
		
	case 0x04:	// Sence Device Status
		PRINTD( FDC_LOG, " Sence Device Status\n" );
		break;
		
	case 0x05:	// Write Data
		PRINTD( FDC_LOG, " Write Data\n" );
		WriteData();
		break;
		
	case 0x06:	// Read Data
		PRINTD( FDC_LOG, " Read Data\n" );
		ReadData();
		break;
		
	case 0x07:	// Recalibrate
		PRINTD( FDC_LOG, " Recalibrate\n" );
		Recalibrate();
		break;
		
	case 0x08:	// Sense Interrupt Status
		PRINTD( FDC_LOG, " Sense Interrupt Status\n" );
		SenseInterruptStatus();
		break;
		
	case 0x09:	// Write Deleted Data
		PRINTD( FDC_LOG, " Write Deleted Data\n" );
		break;
		
	case 0x0a:	// Read ID
		PRINTD( FDC_LOG, " Read ID\n" );
		break;
		
	case 0x0c:	// Read Deleted Data
		PRINTD( FDC_LOG, " Read Deleted Data\n" );
		break;
		
	case 0x0d:	// Write ID
		PRINTD( FDC_LOG, " Write ID\n" );
		// Format is Not Implimented
		break;
		
	case 0x0f:	// Seek
		PRINTD( FDC_LOG, " Seek\n" );
		Seek();
		break;
		
	case 0x11:	// Scan Equal
		PRINTD( FDC_LOG, " Scan Equal\n" );
		break;
		
	case 0x19:	// Scan Low or Equal
		PRINTD( FDC_LOG, " Scan Low or Equal\n" );
		break;
		
	case 0x1d:	// Scan High or Equal
		PRINTD( FDC_LOG, " Scan High or Equal\n" );
		break;
		
	default:	// Invalid
		PRINTD( FDC_LOG, " Invalid!!\n" );
	}
	CmdIn.Index = 0;
}


////////////////////////////////////////////////////////////////
// Read Diagnostic
//  Ƃ肠bdl
////////////////////////////////////////////////////////////////
void DSK66::ReadDiagnostic( void )
{
	PRINTD( FDC_LOG, "[DSK66][ReadDiag] Drv:%d C:%d H:%d R:%d N:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2], CmdIn.Data[3], CmdIn.Data[4], CmdIn.Data[5] );
	
	WORD secsize = 0, gap3size, bufad;
	int wait = 0;
	
	// Command phase
	fdc.MT  = (CmdIn.Data[0]&0x80)>>7;	// Multi-track
	fdc.MF  = (CmdIn.Data[0]&0x40)>>6;	// MFM/FM Mode
	fdc.SK  = (CmdIn.Data[0]&0x20)>>5;	// Skip
	fdc.HD  = (CmdIn.Data[1]&0x04)>>2;	// Head (0-1)
	fdc.US  =  CmdIn.Data[1]&0x03;		// Unit Select (0-3)
	fdc.C   =  CmdIn.Data[2];			// Cylinder Number
	fdc.H   =  CmdIn.Data[3];			// Head Address
	fdc.R   =  CmdIn.Data[4];			// Record
	fdc.N   =  CmdIn.Data[5];			// Number
	fdc.EOT =  CmdIn.Data[6];			// End of Track
	fdc.GPL =  CmdIn.Data[7];			// Gap Length
	fdc.DTL =  CmdIn.Data[8];			// Data length
	fdc.st0 = fdc.st1 = fdc.st2 = 0;
	
	// Execution phase
	if( IsMount( fdc.US ) ){
		// CfbNXM̒̃ZN^ǂ
		Dimg[fdc.US]->Seek( Dimg[fdc.US]->Track() );
		wait = WAIT_GAP0 + WAIT_ID;
		
		secsize = Dimg[fdc.US]->GetSecSize();
		
		// gap3: WIȕtH[}bg
		gap3size = Gap3size[(secsize>>8)&7];
		
		bufad = 0;
		// f[^Ǎ
		for( int i=0; i<secsize; i++ ){
			BufWrite( bufad, Dimg[fdc.US]->Get8() );
			bufad++;
		}
		
		bufad += 2;		//CRC2oCg΂
		
		// gap3Ǎ(̐U)
		for( int i=0; i<gap3size; i++ ){
			BufWrite( bufad, 0x4e);
			bufad++;
		}
		wait += WAIT_DATA((secsize>>8)&7);
		
		// syncǍ(̐U)
		for( int i=0; i<12; i++ ){
			BufWrite( bufad, 0x00);
			bufad++;
		}
		wait += WAIT_BYTE*12;
		
		Dimg[fdc.US]->GetID( &fdc.C, &fdc.H, &fdc.R, &fdc.N );
		
	}else{
		fdc.st0  = ST0_NOT_READY;	// st0  bit3 : media not ready
		wait     = WAIT_TRACK * 2;
	}
	
	// Result phase
	fdc.st0 |= fdc.US;
	
	PushStatus( fdc.N );	// N
	PushStatus( fdc.R );	// R
	PushStatus( fdc.H );	// H
	PushStatus( fdc.C );	// C
	PushStatus( fdc.st2 );	// st2
	PushStatus( fdc.st1 );	// st1
	PushStatus( fdc.st0 );	// st0
	
	fdc.status = FDC_FD2PC | FDC_BUSY | ( fdc.status & 0x0f );
	fdc.intr   = false;
	
	// EFCgݒ
	DSK6::SetWait( EID_EXWAIT, wait );
}


////////////////////////////////////////////////////////////////
// Specify
////////////////////////////////////////////////////////////////
void DSK66::Specify( void )
{
	PRINTD( FDC_LOG, "[DSK66][Specify] SRT:%dms HUT:%dms HLT:%dms %s\n", 16-((CmdIn.Data[1]>>4)&0x0f), (CmdIn.Data[1]&0x0f)*16, (CmdIn.Data[2]>>1)*2, CmdIn.Data[2]&1 ? "NonDMA" : "DMA" );
	
	// Command phase
	fdc.SRT = 16-((CmdIn.Data[1]>>4)&0x0f);		// Step Rate Time
	fdc.HUT = (CmdIn.Data[1]&0x0f)*16;			// Head Unloaded Time
	fdc.HLT = (CmdIn.Data[2]>>1)*2;				// Head Load Time
	fdc.ND  =  CmdIn.Data[2]&1 ? true : false;	// Non DMA Mode  true:Non DMA false:DMA
	
	fdc.status = FDC_DATA_READY | ( fdc.status & 0x0f );
}


////////////////////////////////////////////////////////////////
// Read Data
////////////////////////////////////////////////////////////////
void DSK66::ReadData( void )
{
	PRINTD( FDC_LOG, "[DSK66][Read] Drv:%d C:%d H:%d R:%d N:%d size:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2], CmdIn.Data[3], CmdIn.Data[4], CmdIn.Data[5], SendBytes );
	
	BYTE imgsta = 0;
	int wait    = 0;
	
	// Command phase
	fdc.MT  = (CmdIn.Data[0]&0x80)>>7;	// Multi-track
	fdc.MF  = (CmdIn.Data[0]&0x40)>>6;	// MFM/FM Mode
	fdc.SK  = (CmdIn.Data[0]&0x20)>>5;	// Skip
	fdc.HD  = (CmdIn.Data[1]&0x04)>>2;	// Head (0-1)
	fdc.US  =  CmdIn.Data[1]&0x03;		// Unit Select (0-3)
	fdc.C   =  CmdIn.Data[2];			// Cylinder Number
	fdc.H   =  CmdIn.Data[3];			// Head Address
	fdc.R   =  CmdIn.Data[4];			// Record
	fdc.N   =  CmdIn.Data[5];			// Number
	fdc.EOT =  CmdIn.Data[6];			// End of Track
	fdc.GPL =  CmdIn.Data[7];			// Gap Length
	fdc.DTL =  CmdIn.Data[8];			// Data length
	fdc.st0 = fdc.st1 = fdc.st2 = 0;
	
	// Execution phase
	if( IsMount( fdc.US ) ){
		int i       = 0;				// ]ς݃f[^
		int secbyte = 0;				// ZN^̎cf[^
		
		// ZN^T[`
		Dimg[fdc.US]->SearchSector( fdc.C, fdc.H, fdc.R, fdc.N );
		
		// f[^Ǎ
		while( SendBytes > i ){
			if( secbyte == 0 ){
				wait += WAIT_SECTOR( fdc.N );
				if( (imgsta = Dimg[fdc.US]->GetSecStatus()) ) break;
				secbyte = Dimg[fdc.US]->GetSecSize();
				Dimg[fdc.US]->GetID( &fdc.C, &fdc.H, &fdc.R, &fdc.N );
			}
			BufWrite( i, Dimg[fdc.US]->Get8() );
			i++;
			secbyte--;
		}
		
		switch( imgsta ){
		case BIOS_MISSING_DAM:
			fdc.st0 = ST0_IC_AT;
			fdc.st1 = ST1_MISSING_ADDRESS_MARK;
			fdc.st2 = ST2_MISSING_ADDRESS_MARK_IN_DATA_FIELD;
			break;
			
		default:
			fdc.st0 = ST0_IC_NT;
		}
		
	}else{
		fdc.st0 = ST0_NOT_READY;	// st0  bit3 : media not ready
	}
	
	// Result phase
	fdc.st0 |= fdc.US;
	
	PushStatus( fdc.N );	// N
	PushStatus( fdc.R );	// R
	PushStatus( fdc.H );	// H
	PushStatus( fdc.C );	// C
	PushStatus( fdc.st2 );	// st2
	PushStatus( fdc.st1 );	// st1
	PushStatus( fdc.st0 );	// st0
	
	fdc.status = FDC_FD2PC | FDC_BUSY | ( fdc.status & 0x0f );
	fdc.intr   = false;
	
	// EFCgݒ
	DSK6::SetWait( EID_EXWAIT, wait );
}


////////////////////////////////////////////////////////////////
// Write Data
////////////////////////////////////////////////////////////////
void DSK66::WriteData( void )
{
	PRINTD( FDC_LOG, "[DSK66][Write] Drv:%d C:%d H:%d R:%d N:%d size:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2], CmdIn.Data[3], CmdIn.Data[4], CmdIn.Data[5], SendBytes );
	
	int wait = 0;
	
	// Command phase
	fdc.MT  = (CmdIn.Data[0]&0x80)>>7;	// Multi-track
	fdc.MF  = (CmdIn.Data[0]&0x40)>>6;	// MFM/FM Mode
	fdc.SK  = (CmdIn.Data[0]&0x20)>>5;	// Skip
	fdc.HD  = (CmdIn.Data[1]&0x04)>>2;	// Head (0-1)
	fdc.US  =  CmdIn.Data[1]&0x03;		// Unit Select (0-3)
	fdc.C   =  CmdIn.Data[2];			// Cylinder Number
	fdc.H   =  CmdIn.Data[3];			// Head Address
	fdc.R   =  CmdIn.Data[4];			// Record
	fdc.N   =  CmdIn.Data[5];			// Number
	fdc.EOT =  CmdIn.Data[6];			// End of Track
	fdc.GPL =  CmdIn.Data[7];			// Gap Length
	fdc.DTL =  CmdIn.Data[8];			// Data length
	fdc.st0 = fdc.st1 = fdc.st2 = 0;
	
	// Execution phase
	if( IsMount( fdc.US ) ){
		int i       = 0;				// ]ς݃f[^
		int secbyte = 0;				// ZN^̎cf[^
		
		// ZN^T[`
		Dimg[fdc.US]->SearchSector( fdc.C, fdc.H, fdc.R, fdc.N );
		
		// f[^
		while( SendBytes > i ){
			if( secbyte == 0 ){
				wait += WAIT_SECTOR( fdc.N );
				secbyte = Dimg[fdc.US]->GetSecSize();
				Dimg[fdc.US]->GetID( &fdc.C, &fdc.H, &fdc.R, &fdc.N );
			}
			Dimg[fdc.US]->Put8( BufRead( i ) );
			i++;
			secbyte--;
		}
	}else{
		fdc.st0 = ST0_NOT_READY;	// st0  bit3 : media not ready
	}
	
	// Result phase
	fdc.st0 |= fdc.US;
	
	PushStatus( fdc.N );	// N
	PushStatus( fdc.R );	// R
	PushStatus( fdc.H );	// H
	PushStatus( fdc.C );	// C
	PushStatus( fdc.st2 );	// st2
	PushStatus( fdc.st1 );	// st1
	PushStatus( fdc.st0 );	// st0
	
	fdc.status = FDC_FD2PC | FDC_BUSY | ( fdc.status & 0x0f );
	fdc.intr   = false;
	
	// EFCgݒ
	DSK6::SetWait( EID_EXWAIT, wait );
}


////////////////////////////////////////////////////////////////
// Recalibrate
////////////////////////////////////////////////////////////////
void DSK66::Recalibrate( void )
{
	PRINTD( FDC_LOG, "[DSK66][Recalibrate]\n" );
	
	CmdIn.Data[2] = 0;	// gbN0V[N
	Seek();
}


////////////////////////////////////////////////////////////////
// Seek
////////////////////////////////////////////////////////////////
void DSK66::Seek( void )
{
	PRINTD( FDC_LOG, "[DSK66][Seek] Drv:%d C:%d\n", CmdIn.Data[1]&3, CmdIn.Data[2] );
	
	// Command phase
	fdc.US          = CmdIn.Data[1]&3;		// Unit Select (0-3)
	fdc.NCN[fdc.US] = CmdIn.Data[2];		// New Cylinder Number
	
	// Execution phase
	// hCu or V[Nsv or fBXN}EgĂȂ?
	if( ( fdc.US >= DrvNum ) || fdc.NCN[fdc.US] == fdc.PCN[fdc.US] || !IsMount( fdc.US ) ){
		fdc.SeekSta[fdc.US] = SK_END;
		fdc.intr            = true;
	}else{										// V[Ns
		// EFCgݒ
		int eid = EID_SEEK1;
		switch( fdc.US ){
		case 0: eid = EID_SEEK1; break;
		case 1: eid = EID_SEEK2; break;
		case 2: eid = EID_SEEK3; break;
		case 3: eid = EID_SEEK4; break;
		}
		DSK6::SetWait( eid, (abs((int)(fdc.NCN[fdc.US]-fdc.PCN[fdc.US]))*fdc.SRT+fdc.HUT+fdc.HLT)*WAIT_SEEK );	// K
		
		fdc.SeekSta[fdc.US] = SK_SEEK;
		fdc.intr            = false;
		fdc.status         &= ~(1<<fdc.US);
	}
	fdc.status = FDC_DATA_READY | ( fdc.status & 0x0f );
}


////////////////////////////////////////////////////////////////
// Sense Interrupt Status
////////////////////////////////////////////////////////////////
void DSK66::SenseInterruptStatus( void )
{
	PRINTD( FDC_LOG, "[DSK66][SenseInterruptStatus] " );
	
	int Drv;
	
	// Result phase
	// V[NhCuT
	for( Drv=0; Drv<4; Drv++ )
		if( fdc.SeekSta[Drv] == SK_END ) break;
	
	if( Drv >= 4 ){	// V[NhCuȂ
		PRINTD( FDC_LOG, "None\n" );
		PushStatus( ST0_IC_IC );
	}else{			// V[NhCu
		if( Drv < DrvNum && IsMount( Drv ) ){
			fdc.st0 = ST0_IC_NT | ST0_SEEK_END | Drv;
			// gbNNo2{(1D->2D)
			Dimg[fdc.US]->Seek( fdc.PCN[Drv]*2 );
			PRINTD( FDC_LOG, "Drv:%d ST0:%02X C:%d\n", Drv, fdc.st0, fdc.PCN[Drv] );
		}else{
			PRINTD( FDC_LOG, "Drv:%d NotReady\n", Drv );
			fdc.st0 = ST0_IC_AT | ST0_SEEK_END | ST0_NOT_READY | Drv;
		}
		fdc.SeekSta[Drv] = SK_STOP;
		fdc.status      &= ~(1<<Drv);
		
		PushStatus( fdc.PCN[Drv] );
		PushStatus( fdc.st0 );
	}
	
	fdc.status = FDC_DATA_READY | FDC_FD2PC | ( fdc.status & 0x0f );
}


////////////////////////////////////////////////////////////////
// I/OANZX֐
////////////////////////////////////////////////////////////////
void DSK66::OutB1H( int, BYTE data ){ DIO   = data&4 ? true : false; }	// FDCI[hݒ
void DSK66::OutB3H( int, BYTE data ){ B2Dir = data&1 ? true : false; }	// PortB2h̓o͐


void DSK66::OutD0H( int port, BYTE data ){ if( !DIO ) BufWrite( ((port&0xff)<<8)|((port>>8)&0xff), data ); }	// Buffer
void DSK66::OutD1H( int port, BYTE data ){ if( !DIO ) BufWrite( ((port&0xff)<<8)|((port>>8)&0xff), data ); }	// Buffer
void DSK66::OutD2H( int port, BYTE data ){ if( !DIO ) BufWrite( ((port&0xff)<<8)|((port>>8)&0xff), data ); }	// Buffer
void DSK66::OutD3H( int port, BYTE data ){ if( !DIO ) BufWrite( ((port&0xff)<<8)|((port>>8)&0xff), data ); }	// Buffer

void DSK66::OutD6H( int, BYTE data ){}									// FDD[^
void DSK66::OutD8H( int, BYTE data ){}									// ݕ⏞ ???
void DSK66::OutDAH( int, BYTE data ){ SendBytes = ~( data - 0x10 ) * 256; }	// ]ʎw
void DSK66::OutDDH( int, BYTE data ){ OutFDC( data ); }					// FDC f[^WX^
void DSK66::OutDEH( int, BYTE data ){}									// ?


BYTE DSK66::InB2H( int ){ return !B2Dir && fdc.intr ? 1 : 0; }			// FDC INT

BYTE DSK66::InD0H( int port ){ return DIO ? 0xff : BufRead( ((port&0xff)<<8)|((port>>8)&0xff) ); }			// Buffer
BYTE DSK66::InD1H( int port ){ return DIO ? 0xff : BufRead( ((port&0xff)<<8)|((port>>8)&0xff) ); }			// Buffer
BYTE DSK66::InD2H( int port ){ return DIO ? 0xff : BufRead( ((port&0xff)<<8)|((port>>8)&0xff) ); }			// Buffer
BYTE DSK66::InD3H( int port ){ return DIO ? 0xff : BufRead( ((port&0xff)<<8)|((port>>8)&0xff) ); }			// Buffer


BYTE DSK66::InD4H( int ){ return 0; }									// FDD[^̏
BYTE DSK66::InDCH( int ){ return fdc.status; }							// FDC Xe[^XWX^
BYTE DSK66::InDDH( int ){ return InFDC(); }								// FDC f[^WX^


////////////////////////////////////////////////////////////////
// ǂłSAVE
////////////////////////////////////////////////////////////////
bool DSK60::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16],strva[256];
	int i,j;
	
	e.device = this;
	
	if( !Ini ) return false;
	
	// DSK6
	Ini->PutEntry( "P60DISK", NULL, "DrvNum", "%d", DrvNum );
	
	// DSK60
	Ini->PutEntry( "P60DISK", NULL, "mdisk_DAC",		"%d",		mdisk.DAC );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_RFD",		"%d",		mdisk.RFD );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_DAV",		"%d",		mdisk.DAV );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_command",	"%d",		mdisk.command );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_step",		"%d",		mdisk.step );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_blk",		"%d",		mdisk.blk );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_drv",		"%d",		mdisk.drv );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_trk",		"%d",		mdisk.trk );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_sct",		"%d",		mdisk.sct );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_rsize",		"%d",		mdisk.rsize );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_wsize",		"%d",		mdisk.wsize );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_ridx",		"%d",		mdisk.ridx );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_size",		"%d",		mdisk.size );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_retdat",		"0x%02X",	mdisk.retdat );
	Ini->PutEntry( "P60DISK", NULL, "mdisk_busy",		"%d",		mdisk.busy );
	
	Ini->PutEntry( "P60DISK", NULL, "io_D1H",		"0x%02X",	io_D1H );
	Ini->PutEntry( "P60DISK", NULL, "io_D2H",		"0x%02X",	io_D2H );
	
	for( i=0; i<4096; i+=64 ){
		sprintf( stren, "RBuf_%04X", i );
		for( j=0; j<64; j++ ) sprintf( &strva[j*2], "%02X", RBuf[i+j] );
		Ini->PutEntry( "P60DISK", NULL, stren, "%s", strva );
	}
	for( i=0; i<4096; i+=64 ){
		sprintf( stren, "WBuf_%04X", i );
		for( j=0; j<64; j++ ) sprintf( &strva[j*2], "%02X", WBuf[i+j] );
		Ini->PutEntry( "P60DISK", NULL, stren, "%s", strva );
	}
	
	// Cxg
	int eid[] = { EID_INIT1, EID_INIT2, EID_WRDATEX, EID_RDDATEX, EID_GETPAR, 0 };
	i = 0;
	
	while( eid[i] ){
		e.id = eid[i++];
		if( vm->evsc->GetEvinfo( &e ) ){
			sprintf( stren, "Event%08X", e.id );
			Ini->PutEntry( "P60DISK", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
		}
	}
	
	// fBXNC[WIuWFNg
	for( i=0; i<DrvNum; i++ ){
		if( Dimg[i] ){
			char stren[16];
			sprintf( stren, "DISK_%d_FileName", i );
			Ini->PutEntry( "P60DISK", NULL, stren,	"%s", Dimg[i]->GetFileName() );
			sprintf( stren, "DISK_%d_trkno", i );
			Ini->PutEntry( "P60DISK", NULL, stren,	"%d", Dimg[i]->Track() );
			sprintf( stren, "DISK_%d_secno", i );
			Ini->PutEntry( "P60DISK", NULL, stren,	"%d", Dimg[i]->Sector() );
		}
	}
	
	return true;
}

bool DSK66::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16],strva[256];
	int i,j,k;
	
	e.device = this;
	
	if( !Ini ) return false;
	
	// DSK6
	Ini->PutEntry( "P66DISK", NULL, "DrvNum", "%d", DrvNum );
	
	// DSK66
	for( i=0; i<10; i++ ){
		sprintf( stren, "CmdIn_Data_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X", CmdIn.Data[i] );
		sprintf( stren, "CmdOut_Data_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X", CmdOut.Data[i] );
	}
	Ini->PutEntry( "P66DISK", NULL, "CmdIn_Index", "%d", CmdIn.Index );
	Ini->PutEntry( "P66DISK", NULL, "CmdOut_Index", "%d", CmdOut.Index );
	
	// FDC
	for( i=0; i<4; i++ ){
		sprintf( stren, "fdc_SeekSta_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "%d",		(int)fdc.SeekSta[i] );
		sprintf( stren, "fdc_NCN_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X",	fdc.NCN[i] );
		sprintf( stren, "fdc_PCN_%d", i );
		Ini->PutEntry( "P66DISK", NULL, stren, "0x%02X",	fdc.PCN[i] );
	}
	Ini->PutEntry( "P66DISK", NULL, "fdc_SRT",		"0x%02X",	fdc.SRT );
	Ini->PutEntry( "P66DISK", NULL, "fdc_HUT",		"0x%02X",	fdc.HUT );
	Ini->PutEntry( "P66DISK", NULL, "fdc_HLT",		"0x%02X",	fdc.HLT );
	Ini->PutEntry( "P66DISK", NULL, "fdc_ND",		"%s",		fdc.ND ? "Yes" : "No" );
	Ini->PutEntry( "P66DISK", NULL, "fdc_MT",		"0x%02X",	fdc.MT );
	Ini->PutEntry( "P66DISK", NULL, "fdc_MF",		"0x%02X",	fdc.MF );
	Ini->PutEntry( "P66DISK", NULL, "fdc_SK",		"0x%02X",	fdc.SK );
	Ini->PutEntry( "P66DISK", NULL, "fdc_HD",		"0x%02X",	fdc.HD );
	Ini->PutEntry( "P66DISK", NULL, "fdc_US",		"0x%02X",	fdc.US );
	Ini->PutEntry( "P66DISK", NULL, "fdc_C",		"0x%02X",	fdc.C );
	Ini->PutEntry( "P66DISK", NULL, "fdc_H",		"0x%02X",	fdc.H );
	Ini->PutEntry( "P66DISK", NULL, "fdc_R",		"0x%02X",	fdc.R );
	Ini->PutEntry( "P66DISK", NULL, "fdc_N",		"0x%02X",	fdc.N );
	Ini->PutEntry( "P66DISK", NULL, "fdc_EOT",		"0x%02X",	fdc.EOT );
	Ini->PutEntry( "P66DISK", NULL, "fdc_GPL",		"0x%02X",	fdc.GPL );
	Ini->PutEntry( "P66DISK", NULL, "fdc_DTL",		"0x%02X",	fdc.DTL );
	Ini->PutEntry( "P66DISK", NULL, "fdc_D",		"0x%02X",	fdc.D );
	Ini->PutEntry( "P66DISK", NULL, "fdc_SC",		"0x%02X",	fdc.SC );
	Ini->PutEntry( "P66DISK", NULL, "fdc_st0",		"0x%02X",	fdc.st0 );
	Ini->PutEntry( "P66DISK", NULL, "fdc_st1",		"0x%02X",	fdc.st1 );
	Ini->PutEntry( "P66DISK", NULL, "fdc_st2",		"0x%02X",	fdc.st2 );
	Ini->PutEntry( "P66DISK", NULL, "fdc_st3",		"0x%02X",	fdc.st3 );
	Ini->PutEntry( "P66DISK", NULL, "fdc_status",	"0x%02X",	fdc.status );
	Ini->PutEntry( "P66DISK", NULL, "fdc_intr",		"%s",		fdc.intr ? "Yes" : "No" );
	
	// FDCI
	Ini->PutEntry( "P66DISK", NULL, "SendBytes",	"%d",		SendBytes );
	Ini->PutEntry( "P66DISK", NULL, "DIO",			"%s",		DIO   ? "Yes" : "No" );
	Ini->PutEntry( "P66DISK", NULL, "B2Dir",		"%s",		B2Dir ? "Yes" : "No" );
	
	for( i=0; i<4; i++ ){
		for( j=0; j<256; j+=64 ){
			sprintf( stren, "FDDBuf_%d_%02X", i, j );
			for( k=0; k<64; k++ ) sprintf( &strva[k*2], "%02X", FDDBuf[i*256+j+k] );
			Ini->PutEntry( "P66DISK", NULL, stren, "%s", strva );
		}
	}
	
	// Cxg
	int eid[] = { EID_SEEK1, EID_SEEK2, EID_SEEK3, EID_SEEK4, EID_EXWAIT, 0 };
	i = 0;
	
	while( eid[i] ){
		e.id = eid[i++];
		if( vm->evsc->GetEvinfo( &e ) ){
			sprintf( stren, "Event%08X", e.id );
			Ini->PutEntry( "P66DISK", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
		}
	}
	
	// fBXNC[WIuWFNg
	for( i=0; i<DrvNum; i++ ){
		if( Dimg[i] ){
			char stren[16];
			sprintf( stren, "DISK_%d_FileName", i );
			Ini->PutEntry( "P66DISK", NULL, stren,	"%s", Dimg[i]->GetFileName() );
			sprintf( stren, "DISK_%d_trkno", i );
			Ini->PutEntry( "P66DISK", NULL, stren,	"%d", Dimg[i]->Track() );
			sprintf( stren, "DISK_%d_secno", i );
			Ini->PutEntry( "P66DISK", NULL, stren,	"%d", Dimg[i]->Sector() );
		}
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
////////////////////////////////////////////////////////////////
bool DSK60::DokoLoad( cIni *Ini )
{
	int st,yn,i,j;
	cSche::evinfo e;
	char stren[16], strva[256];
	char strrs[64];
	
	e.device = this;
	
	if( !Ini ) return false;
	
	// Ƃ肠SA}Eg
	for( i=0; i<DrvNum; i++ ) if( Dimg[i] ) Unmount( i) ;
	
	// DSK6
	Ini->GetInt( "P60DISK", "DrvNum",	&DrvNum,	DrvNum );
	
	// DSK60
	Ini->GetInt( "P60DISK", "mdisk_DAC",		&mdisk.DAC,		mdisk.DAC );
	Ini->GetInt( "P60DISK", "mdisk_RFD",		&mdisk.RFD,		mdisk.RFD );
	Ini->GetInt( "P60DISK", "mdisk_DAV",		&mdisk.DAV,		mdisk.DAV );
	Ini->GetInt( "P60DISK", "mdisk_command",	&mdisk.command,	mdisk.command );
	Ini->GetInt( "P60DISK", "mdisk_step",		&mdisk.step,	mdisk.step );
	Ini->GetInt( "P60DISK", "mdisk_blk",		&mdisk.blk,		mdisk.blk );
	Ini->GetInt( "P60DISK", "mdisk_drv",		&mdisk.drv,		mdisk.drv );
	Ini->GetInt( "P60DISK", "mdisk_trk",		&mdisk.trk,		mdisk.trk );
	Ini->GetInt( "P60DISK", "mdisk_sct",		&mdisk.sct,		mdisk.sct );
	Ini->GetInt( "P60DISK", "mdisk_rsize",		&mdisk.rsize,	mdisk.rsize );
	Ini->GetInt( "P60DISK", "mdisk_wsize",		&mdisk.wsize,	mdisk.wsize );
	Ini->GetInt( "P60DISK", "mdisk_ridx",		&mdisk.ridx,	mdisk.ridx );
	Ini->GetInt( "P60DISK", "mdisk_size",		&mdisk.size,	mdisk.size );
	Ini->GetInt( "P60DISK", "mdisk_retdat",		&st,			mdisk.retdat );	mdisk.retdat = st;
	Ini->GetInt( "P60DISK", "mdisk_busy",		&st,			mdisk.busy );	mdisk.busy = st;
	Ini->GetInt( "P60DISK", "io_D1H",			&st,			io_D1H );		io_D1H = st;
	Ini->GetInt( "P60DISK", "io_D2H",			&st,			io_D2H );		io_D2H = st;
	
	for( i=0; i<4096; i+=64 ){
		sprintf( stren, "RBuf_%04X", i );
		memset( strva, '0', 64*2 );
		if( Ini->GetString( "P60DISK", stren, strva, strva ) ){
			for( j=0; j<64; j++ ){
				char dt[5] = "0x";
				strncpy( &dt[2], &strva[j*2], 2 );
				RBuf[i+j] = strtol( dt, NULL, 16 );
			}
		}
	}
	for( i=0; i<4096; i+=64 ){
		sprintf( stren, "WBuf_%04X", i );
		memset( strva, '0', 64*2 );
		if( Ini->GetString( "P60DISK", stren, strva, strva ) ){
			for( j=0; j<64; j++ ){
				char dt[5] = "0x";
				strncpy( &dt[2], &strva[j*2], 2 );
				WBuf[i+j] = strtol( dt, NULL, 16 );
			}
		}
	}
	
	// Cxg
	int eid[] = { EID_INIT1, EID_INIT2, EID_WRDATEX, EID_RDDATEX, EID_GETPAR, 0 };
	i = 0;
	
	while( eid[i] ){
		e.id = eid[i++];
		sprintf( stren, "Event%08X", e.id );
		if( Ini->GetString( "P60DISK", stren, strrs, "" ) ){
			sscanf( strrs,"%d %d %d %lf", &yn, &e.Period, &e.Clock, &e.nps );
			e.Active = yn ? true : false;
			if( !vm->evsc->SetEvinfo( &e ) ) return false;
		}
	}
	
	// fBXNC[WIuWFNg
	for( i=0; i<DrvNum; i++ ){
		sprintf( stren, "DISK_%d_FileName", i );
		if( Ini->GetString( "P60DISK", stren, strva, "" ) && Mount( i, strva ) ){
			int tr,sc;
			sprintf( stren, "DISK_%d_trkno", i );
			Ini->GetInt( "P60DISK", stren,	&tr,	0 );
			sprintf( stren, "DISK_%d_secno", i );
			Ini->GetInt( "P60DISK", stren,	&sc,	0 );
			Dimg[i]->Seek( tr, sc );
		}
	}
	
	return true;
}

bool DSK66::DokoLoad( cIni *Ini )
{
	int st,yn,i,j,k;
	cSche::evinfo e;
	char stren[16], strva[256];
	char strrs[64];
	
	e.device = this;
	
	if( !Ini ) return false;
	
	// Ƃ肠SA}Eg
	for( i=0; i<DrvNum; i++ ) if( Dimg[i] ) Unmount( i) ;
	
	// DSK6
	Ini->GetInt( "P66DISK", "DrvNum",	&DrvNum,	DrvNum );
	
	// DSK66
	for( i=0; i<10; i++ ){
		sprintf( stren, "CmdIn_Data_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	CmdIn.Data[i] );	CmdIn.Data[i] = st;
		sprintf( stren, "CmdOut_Data_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	CmdOut.Data[i] );	CmdOut.Data[i] = st;
	}
	Ini->GetInt( "P66DISK", "CmdIn_Index",	&CmdIn.Index,	CmdIn.Index );
	Ini->GetInt( "P66DISK", "CmdOut_Index",	&CmdOut.Index,	CmdOut.Index );
	
	// FDC
	for( i=0; i<4; i++ ){
		sprintf( stren, "fdc_NCN_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	fdc.NCN[i] );		fdc.NCN[i] = st;
		sprintf( stren, "fdc_PCN_%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	fdc.PCN[i] );		fdc.PCN[i] = st;
		sprintf( stren, "fdc_SeekSta%d", i );
		Ini->GetInt( "P66DISK", stren,	&st,	fdc.SeekSta[i] );	fdc.SeekSta[i] = (FdcSeek)st;
	}
	Ini->GetInt(   "P66DISK", "fdc_SRT",	&st,		fdc.SRT );		fdc.SRT = st;
	Ini->GetInt(   "P66DISK", "fdc_HUT",	&st,		fdc.HUT );		fdc.HUT = st;
	Ini->GetInt(   "P66DISK", "fdc_HLT",	&st,		fdc.HLT );		fdc.HLT = st;
	Ini->GetTruth( "P66DISK", "fdc_ND",		&fdc.ND,	fdc.ND );
	Ini->GetInt(   "P66DISK", "fdc_MT",		&st,		fdc.MT );		fdc.MT = st;
	Ini->GetInt(   "P66DISK", "fdc_MF",		&st,		fdc.MF );		fdc.MF = st;
	Ini->GetInt(   "P66DISK", "fdc_SK",		&st,		fdc.SK );		fdc.SK = st;
	Ini->GetInt(   "P66DISK", "fdc_HD",		&st,		fdc.HD );		fdc.HD = st;
	Ini->GetInt(   "P66DISK", "fdc_US",		&st,		fdc.US );		fdc.US = st;
	Ini->GetInt(   "P66DISK", "fdc_C",		&st,		fdc.C );		fdc.C = st;
	Ini->GetInt(   "P66DISK", "fdc_H",		&st,		fdc.H );		fdc.H = st;
	Ini->GetInt(   "P66DISK", "fdc_R",		&st,		fdc.R );		fdc.R = st;
	Ini->GetInt(   "P66DISK", "fdc_N",		&st,		fdc.N );		fdc.N = st;
	Ini->GetInt(   "P66DISK", "fdc_EOT",	&st,		fdc.EOT );		fdc.EOT = st;
	Ini->GetInt(   "P66DISK", "fdc_GPL",	&st,		fdc.GPL );		fdc.GPL = st;
	Ini->GetInt(   "P66DISK", "fdc_DTL",	&st,		fdc.DTL );		fdc.DTL = st;
	Ini->GetInt(   "P66DISK", "fdc_D",		&st,		fdc.D );		fdc.D = st;
	Ini->GetInt(   "P66DISK", "fdc_SC",		&st,		fdc.SC );		fdc.SC = st;
	Ini->GetInt(   "P66DISK", "fdc_st0",	&st,		fdc.st0 );		fdc.st0 = st;
	Ini->GetInt(   "P66DISK", "fdc_st1",	&st,		fdc.st1 );		fdc.st1 = st;
	Ini->GetInt(   "P66DISK", "fdc_st2",	&st,		fdc.st2 );		fdc.st2 = st;
	Ini->GetInt(   "P66DISK", "fdc_st3",	&st,		fdc.st3 );		fdc.st3 = st;
	Ini->GetInt(   "P66DISK", "fdc_status",	&st,		fdc.status );	fdc.status = st;
	Ini->GetTruth( "P66DISK", "fdc_intr",	&fdc.intr,	fdc.intr );
	
	// FDCI
	Ini->GetInt(   "P66DISK", "SendBytes",	&SendBytes,	SendBytes );
	Ini->GetTruth( "P66DISK", "DIO",		&DIO,		DIO );
	Ini->GetTruth( "P66DISK", "B2Dir",		&B2Dir,		B2Dir );
	
	for( i=0; i<4; i++ ){
		for( j=0; j<256; j+=64 ){
			sprintf( stren, "FDDBuf_%d_%02X", i, j );
			memset( strva, '0', 64*2 );
			Ini->GetString( "P66DISK", stren, strva, strva );
			for( k=0; k<64; k++ ){
				char dt[5] = "0x";
				strncpy( dt, &strva[k*2], 2 );
				FDDBuf[i*256+j+k] = strtol( dt, NULL, 16 );
			}
		}
	}
	
	// Cxg
	int eid[] = { EID_SEEK1, EID_SEEK2, EID_SEEK3, EID_SEEK4, EID_EXWAIT, 0 };
	i = 0;
	
	while( eid[i] ){
		e.id = eid[i++];
		sprintf( stren, "Event%08X", e.id );
		if( Ini->GetString( "P66DISK", stren, strrs, "" ) ){
			sscanf( strrs,"%d %d %d %lf", &yn, &e.Period, &e.Clock, &e.nps );
			e.Active = yn ? true : false;
			if( !vm->evsc->SetEvinfo( &e ) ) return false;
		}
	}
	
	// fBXNC[WIuWFNg
	for( i=0; i<DrvNum; i++ ){
		sprintf( stren, "DISK_%d_FileName", i );
		if( Ini->GetString( "P66DISK", stren, strva, "" ) && Mount( i, strva ) ){
			int tr,sc;
			sprintf( stren, "DISK_%d_trkno", i );
			Ini->GetInt( "P66DISK", stren,	&tr,	0 );
			sprintf( stren, "DISK_%d_secno", i );
			Ini->GetInt( "P66DISK", stren,	&sc,	0 );
			Dimg[i]->Seek( tr, sc );
		}
	}
	
	return true;
}





////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor DSK60::descriptor = {
	DSK60::indef, DSK60::outdef
};

const Device::OutFuncPtr DSK60::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &DSK60::OutD1H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK60::OutD2H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK60::OutD3H )
};

const Device::InFuncPtr DSK60::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &DSK60::InD0H ),
	STATIC_CAST( Device::InFuncPtr, &DSK60::InD1H ),
	STATIC_CAST( Device::InFuncPtr, &DSK60::InD2H )
};


const Device::Descriptor DSK66::descriptor = {
	DSK66::indef, DSK66::outdef
};

const Device::OutFuncPtr DSK66::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutB1H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutB3H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD0H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD1H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD2H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD3H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD6H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutD8H ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutDAH ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutDDH ),
	STATIC_CAST( Device::OutFuncPtr, &DSK66::OutDEH )
};

const Device::InFuncPtr DSK66::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &DSK66::InB2H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InD0H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InD1H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InD2H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InD3H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InD4H ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InDCH ),
	STATIC_CAST( Device::InFuncPtr, &DSK66::InDDH )
};
