#ifndef DISK_H_INCLUDED
#define DISK_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "d88.h"
#include "ini.h"

#include "p6device.h"

// őhCuڑ
#define	MAXDRV	4

// R}h
// ۂɂ PC-80S31 ̃R}hǑ̓H
enum FddCommand
{
	INIT				= 0x00,
	WRITE_DATA			= 0x01,
	READ_DATA			= 0x02,
	SEND_DATA			= 0x03,
	COPY				= 0x04,
	FORMAT				= 0x05,
	SEND_RESULT_STATUS	= 0x06,
	SEND_DRIVE_STATUS	= 0x07,
	TRANSMIT			= 0x11,
	RECEIVE				= 0x12,
	LOAD				= 0x14,
	SAVE				= 0x15,
	
	IDLE				= 0xff,	// ҂̏
	EndofFdcCmd
};

// ~jtbs[fBXN e
struct DISK60 {
	int DAC;			// Data Accepted	:f[^M
	int RFD;			// Ready For Data	:f[^M
	int DAV;			// Data Valid		:f[^M
	
	int command;		// 󂯎R}h
	int step;			// p[^͑҂Xe[^X
	
	int blk;			// ]ubN
	int drv;			// hCuԍ-1
	int trk;			// gbNԍ
	int sct;			// ZN^ԍ
	
	int rsize;			// Ǎ݃obt@̃f[^
	int wsize;			// ݃obt@̃f[^
	int ridx;
	
	int size;			// oCg
	
	BYTE retdat;		// port D0H Ԃl
	
	BYTE busy;			// hCuBUSY 1:hCu1 2:hCu2
	
	DISK60() :
		DAC(0), RFD(0), DAV(0),
		command(IDLE), step(0),
		blk(0), drv(0), trk(0), sct(0),
		size(0),
		retdat(0xff), busy(0) {}
};


enum FdcPhase {
	IDLEP = 0,
	C_PHASE,
	E_PHASE,
	R_PHASE
};

enum FdcSeek{
	SK_STOP = 0,	// V[NȂ
	SK_SEEK,		// V[N
	SK_END			// V[N
};

struct PD765 {
BYTE command;		// R}h
FdcPhase phase;		// Phase (C/E/R)
int step;			// Phasȅ菇

	BYTE SRT;			// Step Rate Time
	BYTE HUT;			// Head Unloaded Time
	BYTE HLT;			// Head Load Time
	bool ND;			// Non DMA Mode  true:Non DMA false:DMA
	
	FdcSeek SeekSta[4];	// V[N
	BYTE NCN[4];		// New Cylinder Number
	BYTE PCN[4];		// Present Cylinder Number
	
	
	BYTE MT;			// Multi-track
	BYTE MF;			// MFM/FM Mode
	BYTE SK;			// Skip
	BYTE HD;			// Head
	BYTE US;			// Unit Select
	
	BYTE C;				// Cylinder Number
	BYTE H;				// Head Address
	BYTE R;				// Record
	BYTE N;				// Number
	BYTE EOT;			// End of Track
	BYTE GPL;			// Gap Length
	BYTE DTL;			// Data length
	
	BYTE D;				// Format Data
	BYTE SC;			// Sector
	
	BYTE st0;			// ST0
	BYTE st1;			// ST1
	BYTE st2;			// ST2
	BYTE st3;			// ST3
	
	BYTE status;		// Status
	bool intr;			// FDCݔtO
	
		PD765() :
		command(0), phase(R_PHASE), step(0),
		SRT(32), HUT(0), HLT(0), ND(false),
		MT(0), MF(0), SK(0), HD(0), US(0), C(0), H(0), R(0), N(0),
		EOT(0), GPL(0), DTL(0),
		st0(0), st1(0), st2(0), st3(0), status(0)
		{
			INITARRAY( SeekSta, SK_STOP );
			INITARRAY( NCN, 0 );
			INITARRAY( PCN, 0 );
		}
};


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSK6 : public P6DEVICE, public IDoko {
protected:
	int DrvNum;							// hCu
	char FilePath[MAXDRV][PATH_MAX];	// t@CpX
	cD88 *Dimg[MAXDRV];					// fBXNC[WIuWFNgւ̃|C^
	bool Sys[MAXDRV];					// VXefBXNtO
	
	bool SetWait( int, int );			// EFCgݒ
	
public:
	DSK6( VM6 *, const P6ID& );			// RXgN^
	virtual ~DSK6();					// fXgN^
	
	virtual void EventCallback( int, int );	// CxgR[obN֐
	
	virtual bool Init( int ) = 0;		// 
	virtual void Reset() = 0;			// Zbg
	
	bool Mount( int, char * );			// DISK }Eg
	void Unmount( int );				// DISK A}Eg
	
	int GetDrives();					// hCu擾
	
	bool IsMount( int );				// }Egς?
	bool IsSystem( int );				// VXefBXN?
	bool IsProtect( int );				// veNg?
	virtual bool InAccess( int ) = 0;	// ANZX?
	
	const char *GetFile( int );			// t@CpX擾
	const char *GetName( int );			// DISK擾
};


class DSK60 : public DSK6, public Device {
private:
	DISK60 mdisk;			// ~jtbs[fBXNe
	
	BYTE RBuf[4096];		// Ǎ݃obt@
	BYTE WBuf[4096];		// ݃obt@
	
	BYTE io_D1H;
	BYTE io_D2H;
	
	BYTE FddIn();			// DISKjbg̃f[^ 		(port D0H)
	void FddOut( BYTE );	// DISKjbgւ̃R}hCf[^o (port D1H)
	BYTE FddCntIn();		// DISKjbg̐M 		(port D2H)
	void FddCntOut( BYTE );	// DISKjbgւ̐Mo 		(port D3H)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutD1H( int, BYTE );
	void OutD2H( int, BYTE );
	void OutD3H( int, BYTE );
	BYTE InD0H( int );
	BYTE InD1H( int );
	BYTE InD2H( int );
	
public:
	DSK60( VM6 *, const ID& );			// RXgN^
	~DSK60();							// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int );					// 
	void Reset();						// Zbg
	bool InAccess( int );				// ANZX?
	
	// foCXID
	enum IDOut{ outD1H=0, outD2H, outD3H };
	enum IDIn {  inD0H=0,  inD1H,  inD2H };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class DSK66 : public DSK6, public Device {
private:
	struct CmdBuffer {
		BYTE Data[10];
		int Index;
		
		CmdBuffer() : Index(0) { *Data = 0; }
	};
	
	BYTE FDDBuf[1024];					// FDDobt@
	void BufWrite( int, BYTE );			// FDDobt@
	BYTE BufRead( int );				// FDDobt@Ǎ
	
	CmdBuffer CmdIn;					// R}hobt@
	CmdBuffer CmdOut;					// Xe[^Xobt@
	
	// FDC
	PD765 fdc;
	
	// FDCI
	int SendBytes;						// ](256BytesP)
	bool DIO;							// FDDobt@ANZX true: OthCu false: FDDobt@
	bool B2Dir;							// PortB2H ANZXWX^ true: o false: 
	
	void PushStatus( BYTE );			// Xe[^Xobt@Ƀf[^
	BYTE PopStatus();					// Xe[^Xobt@f[^o
	void OutFDC( BYTE );				// FDC ɏ
	BYTE InFDC();						// FDC Ǎ
	void Exec();						// FDC R}hs
	void ReadDiagnostic();				// Read Diagnostic
	void Specify();						// Specify
	void ReadData();					// Read Data
	void WriteData();					// Write Data
	void Recalibrate();					// Recalibrate
	void Seek();						// Seek
	void SenseInterruptStatus();		// Sense Interrupt Status
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB1H( int, BYTE );	// FDCI[hݒ
	void OutB3H( int, BYTE );	// PortB2h̓o͐
	void OutD0H( int, BYTE );	// Buffer
	void OutD1H( int, BYTE );	// Buffer
	void OutD2H( int, BYTE );	// Buffer
	void OutD3H( int, BYTE );	// Buffer
	void OutD6H( int, BYTE );	// FDD[^
	void OutD8H( int, BYTE );	// ݕ⏞ ???
	void OutDAH( int, BYTE );	// ]ʎw
	void OutDDH( int, BYTE );	// FDC f[^WX^
	void OutDEH( int, BYTE );	// ?
	
	BYTE InB2H( int );			// FDC INT
	BYTE InD0H( int );			// Buffer
	BYTE InD1H( int );			// Buffer
	BYTE InD2H( int );			// Buffer
	BYTE InD3H( int );			// Buffer
	BYTE InD4H( int );			// FDD[^̏
	BYTE InDCH( int );			// FDC Xe[^XWX^
	BYTE InDDH( int );			// FDC f[^WX^

public:
	DSK66( VM6 *, const ID& );			// RXgN^
	~DSK66();							// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int );					// 
	void Reset();						// Zbg
	bool InAccess( int );				// ANZX?
	
	// foCXID
	enum IDOut{ outB1H=0, outB3H, outD0H, outD1H, outD2H, outD3H, outD6H, outD8H,
				outDAH,   outDDH, outDEH };
	enum IDIn {  inB2H=0,  inD0H,  inD1H,  inD2H,  inD3H,  inD4H,  inDCH,  inDDH };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// DISK_H_INCLUDED
