#include "pc6001v.h"
#include "graph.h"

#include "log.h"
#include "common.h"
#include "debug.h"
#include "osd.h"
#include "status.h"
#include "vdg.h"

#include "p6el.h"


// ʏEBhETCY
#define	P6WINW		(vm->vdg->Width())
#define	P6WINH		(vm->vdg->Height())

#define	HBBUS		(282-12)	/* 4:3\ʍ */

// tXN[EBhETCY
#define	P6WIFW		(640)
#define	P6WIFH		(480)

#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// fobO[hEBhETCY
#define	P6DEBUGW	(P6WINW+vm->el->regw->Width())
#define	P6DEBUGH	(max(P6WINH,vm->el->regw->Height()+vm->el->memw->Height())+vm->el->monw->Height())
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


// j^[h̓tXN[CXLCC4:3\֎~
// tXN[[h̓Xe[^Xo[\֎~
#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define	DISPMON		(vm->el->cfg->GetMonDisp())
#define	DISPFULL	(!DISPMON  && vm->el->cfg->GetFullScreen())
#define	DISPSCAN	(!DISPMON  && vm->el->cfg->GetScanLine())
#define	DISPNTSC	(!DISPMON  && vm->el->cfg->GetDispNTSC())
#define	DISPSTAT	(!DISPFULL && vm->el->cfg->GetStatDisp())

#else

#define	DISPFULL	(vm->el->cfg->GetFullScreen())
#define	DISPSCAN	(vm->el->cfg->GetScanLine())
#define	DISPNTSC	(vm->el->cfg->GetDispNTSC())
#define	DISPSTAT	(vm->el->cfg->GetStatDisp())

#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //



////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
DSP6::DSP6( VM6 *pvm ) : vm(pvm), Wh(NULL), SBuf(NULL), Pal(NULL),
							Bpp(DEFAULT_COLOR_MODE), SLBr(DEFAULT_SCANLINEBR) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
DSP6::~DSP6( void )
{
	if( SBuf ) delete SBuf;
	if( Wh ) OSD_DestroyWindow( Wh );
}


////////////////////////////////////////////////////////////////
// 
//
// :	bpp		1sNZbit
//			br		XLCPx
//			pal		pbgւ̃|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::Init( int bpp, int br, VPalette *pal )
{
	PRINTD( GRP_LOG, "[GRP][Init]\n" );
	
	Bpp  = bpp;
	SLBr = br;
	Pal  = pal;
	
	// XN[T[tFX쐬
	if( !SetScreenSurface() ) return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// 
//
// :	model	@ 60,62,66
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::SetIcon( int model )
{
	OSD_SetIcon( Wh, model );
}


////////////////////////////////////////////////////////////////
// XN[T[tFX쐬
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::SetScreenSurface( void )
{
	PRINTD( GRP_LOG, "[GRP][SetScreenSurface]\n" );
	
	int x = 0, y = 0;
	bool fsflag = false;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		x      = P6DEBUGW;
		y      = P6DEBUGH;
		fsflag = false;
		
		PRINTD( GRP_LOG, " -> Monitor Mode ( X:%d Y:%d )\n", x, y );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		if( DISPFULL ){	// tXN[?
			// Mac ̃tXN[ 640x480, 800x600, 1024x768 Ɍ炵Bby Windy
			// Ƃ肠ⓚp640x480ɌŒ肵Ă݂
			x      = P6WIFW;
			y      = P6WIFH;
			fsflag = true;
			
			PRINTD( GRP_LOG, " -> FullScreen ( X:%d Y:%d %dbpp)\n", x, y, Bpp );
		}else{
			x      = P6WINW * ( DISPSCAN ? 2 : 1 );
			y      = ( DISPNTSC ? HBBUS : P6WINH ) * ( DISPSCAN ? 2 : 1 ) + ( DISPSTAT ? vm->el->staw->Height() : 0 );
			fsflag = false;
			
			PRINTD( GRP_LOG, " -> Window ( X:%d Y:%d %dbpp )\n", x, y, Bpp );
		}
	}
	
	// XN[T[tFX쐬
	OSD_CreateWindow( &Wh, x, y, Bpp, fsflag );
	if( !Wh ) return false;
	
	PRINTD( GRP_LOG, " -> OK ( %d x %d x %d )\n", OSD_GetWindowWidth( Wh ), OSD_GetWindowHeight( Wh ), OSD_GetWindowBPP( Wh ) );
	
	if( DISPFULL ){	// tXN[̎
		// }EXJ[\
		OSD_ShowCursor( false );
	}else{			// tXN[łȂ
		// }EXJ[\\
		OSD_ShowCursor( true );
		// EBhELvVݒ
		OSD_SetWindowCaption( Wh, vm->el->cfg->GetCaption() );
	}
	
	// XN[T[tFXɃpbgI
	if( OSD_GetWindowBPP( Wh ) == 8 )
		if( !OSD_SetPalette( Wh, Pal ) ) return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// XN[TCYύX
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::ResizeScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][ResizeScreen]\n" );
	
	int x, y;
	
	// EBhETCY`FbN
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		x = P6DEBUGW;
		y = P6DEBUGH;
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		x = ( DISPFULL ? P6WIFW : P6WINW * ( DISPSCAN ? 2 : 1 ) );
		y = ( DISPFULL ? P6WIFH : ( DISPNTSC ? HBBUS : P6WINH ) * ( DISPSCAN ? 2 : 1 ) );
		
		// Xe[^Xo[\?
		if( !DISPFULL && DISPSTAT ) y += vm->el->staw->Height();
	}
	
	// EBhETCYsK؂Ȃ蒼
	if( !Wh || (x != OSD_GetWindowWidth( Wh )) || (y != OSD_GetWindowHeight( Wh )) ){
		if( !SetScreenSurface() ) return false;
		vm->el->staw->Init( OSD_GetWindowWidth( Wh ) );	// Xe[^Xo[
	}else
		// 蒼Ȃꍇ݂͌̃XN[T[tFXNA
		OSD_ClearWindow( Wh );

	
	return true;
}


////////////////////////////////////////////////////////////////
// ʍXV
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::DrawScreen( void )
{
	PRINTD( GRP_LOG, "[GRP][DrawScreen]\n" );
	
	VSurface *BBuf = vm->vdg;		// obNobt@ւ̃|C^擾
	
	if( !Wh || !BBuf ) return;
	
	// XN[T[tFXblit
	PRINTD( GRP_LOG, " -> Blit" );
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	if( DISPMON ){	// j^[h?
		PRINTD( GRP_LOG, " -> Monitor" );
		
		// obNobt@
		OSD_BlitToWindow( Wh, BBuf, 0, 0, Pal );
		
		// j^EBhE
		OSD_BlitToWindow( Wh, vm->el->monw, 0, max( P6WINH, vm->el->regw->Height() + vm->el->memw->Height() ), Pal );
		
		// WX^EBhE
		OSD_BlitToWindow( Wh, vm->el->regw, P6WINW, 0, Pal );
		
		// EBhE
		OSD_BlitToWindow( Wh, vm->el->memw, P6WINW, vm->el->regw->Height(), Pal );
	}else
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	{
		UpdateSubBuf();	// Tuobt@XV
		
		if( DISPFULL ){	// tXN[
			PRINTD( GRP_LOG, " -> FullScreen" );
			if( DISPSCAN ){	// XLC̏ꍇ
				PRINTD( GRP_LOG, "(Scan line)" );
				OSD_BlitToWindow( Wh, SBuf, ( OSD_GetWindowWidth( Wh ) - SBuf->Width() ) / 2, ( OSD_GetWindowHeight( Wh ) - SBuf->Height() ) / 2, Pal );
			}else{
				OSD_BlitToWindow2( Wh, SBuf, ( OSD_GetWindowWidth( Wh ) - SBuf->Width() * 2 ) / 2, ( OSD_GetWindowHeight( Wh ) - SBuf->Height() * 2 ) / 2 );
			}
		}else{			// tXN[łȂ
			PRINTD( GRP_LOG, " -> Window" );
			OSD_BlitToWindow( Wh, SBuf, 0, 0, Pal );
		}
		
		// Xe[^Xo[
		if( DISPSTAT ){
			PRINTD( GRP_LOG, " -> Statusbar" );
			
			// Xe[^Xo[XV
			// XN[T[tFX[Ɉʒu킹blit
			vm->el->staw->Update();
			
			OSD_BlitToWindow( Wh, STATIC_CAST( VSurface *, vm->el->staw ), 0, OSD_GetWindowHeight( Wh ) - vm->el->staw->Height(), Pal );
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	// tbv
	OSD_RenderWindow( Wh );
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenX( void )
{
	return P6WINW * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// LXN[擾
//
// :	Ȃ
// Ԓl:	int		LXN[sNZ
////////////////////////////////////////////////////////////////
int DSP6::ScreenY( void )
{
	return ( DISPNTSC ? HBBUS : P6WINH ) * ( DISPSCAN ? 2 : 1 );
}


////////////////////////////////////////////////////////////////
// Tuobt@擾
//
// :	Ȃ
// Ԓl:	VSurface *	Tuobt@ւ̃|C^
////////////////////////////////////////////////////////////////
VSurface *DSP6::GetSubBuffer( void )
{
	return SBuf;
}


////////////////////////////////////////////////////////////////
// EBhEnh擾
//
// :	Ȃ
// Ԓl:	HWINDOW *	EBhEnh
////////////////////////////////////////////////////////////////
HWINDOW DSP6::GetWindowHandle( void )
{
	return (HWINDOW)Wh;
}


////////////////////////////////////////////////////////////////
// Tuobt@XV
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
#define	RESO43		(8)		/* ԐFvZp\(1CRESO43) */
#define	THRE43		(0)		/* ԐF̂l(傫ΒԐF) */
bool DSP6::UpdateSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][UpdateSubBuf]\n" );
	
	VSurface *BBuf = vm->vdg;
	
	if( !BBuf ) return false;
	
	if( !RefreshSubBuf() ) return false;
	
	if( DISPNTSC ){	// 4:3\L̏ꍇ
		PRINTD( GRP_LOG, " -> 4:3" );
		if( DISPSCAN ){	// XLC̏ꍇ
			PRINTD( GRP_LOG, " -> ScanLine" );
			switch( SBuf->Bpp() ){
			case 8:		// 8bit[h
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->Height(); y+=2 ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					
					DWORD *soff = (DWORD *)BBuf->GetPixels() + BBuf->Pitch()/sizeof(DWORD) * y0;
					DWORD *doff = (DWORD *)SBuf->GetPixels() + SBuf->Pitch()/sizeof(DWORD) * y;
					DWORD *eoff = doff + SBuf->Pitch()/sizeof(DWORD);
					DWORD s, d;
					
					// 8bit̎͒ԐFȂ
					for( int x=0; x<(int)(BBuf->Width()/sizeof(DWORD)); x++ ){
						BYTE b1,b2,b3,b4;
						s = *soff++;
						DWTOB( s, b1, b2, b3, b4 );
						d = BTODW( b4, b4, b3, b3 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
						d = BTODW( b2, b2, b1, b1 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
					}
				}
				break;
				
			case 16:	// 16bit[h
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->Height(); y+=2 ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					int a1 = ( y * BBuf->Height() * RESO43 ) / SBuf->Height() - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y0;
					DWORD *doff = (DWORD *)SBuf->GetPixels() + ( SBuf->Pitch() * y ) / sizeof(DWORD);
					DWORD *eoff = doff + SBuf->Pitch() / sizeof(DWORD);
					
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->Width(); x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->Pitch());
							
							BYTE r = ( Pal->colors[d1].r * a2 + Pal->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( Pal->colors[d1].g * a2 + Pal->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( Pal->colors[d1].b * a2 + Pal->colors[d2].b * a1 ) / RESO43;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}else{
						for( int x=0; x<(int)BBuf->Width(); x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = Pal->colors[d1].r;
							BYTE g = Pal->colors[d1].g;
							BYTE b = Pal->colors[d1].b;
							
							DWORD dd = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							dd |= dd << 16;
							*(doff++) = dd;
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							DWORD ed = ( (DWORD)( r & 0xf8 ) << 8 ) | ( (DWORD)( g & 0xfc ) << 3 ) | ( (DWORD)( b & 0xf8 ) >> 3 );
							ed |= ed << 16;
							*(eoff++) = ed;
						}
					}
				}
				break;
				
			case 24:	// 24bit[h
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->Height(); y+=2 ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					int a1 = ( y * BBuf->Height() * RESO43 ) / SBuf->Height() - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y0;
					BYTE *doff = (BYTE *)SBuf->GetPixels() + SBuf->Pitch() * y;
					BYTE *eoff = doff + SBuf->Pitch();
					
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<(int)BBuf->Width(); x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->Pitch());
							
							BYTE r = ( Pal->colors[d1].r * a2 + Pal->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( Pal->colors[d1].g * a2 + Pal->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( Pal->colors[d1].b * a2 + Pal->colors[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}else{
						for( int x=0; x<(int)BBuf->Width(); x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = Pal->colors[d1].r;
							BYTE g = Pal->colors[d1].g;
							BYTE b = Pal->colors[d1].b;
							
							PUT3BYTE( b, g, r, doff );
							PUT3BYTE( b, g, r, doff );
							
							r = ( r * SLBr ) / 100;
							g = ( g * SLBr ) / 100;
							b = ( b * SLBr ) / 100;
							
							PUT3BYTE( b, g, r, eoff );
							PUT3BYTE( b, g, r, eoff );
						}
					}
				}
			}
		}else{			// XLCȂ̏ꍇ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			switch( SBuf->Bpp() ){
			case 8:		// 8bit[h
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<SBuf->Height(); y++ ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y0;
					BYTE *doff = (BYTE *)SBuf->GetPixels() + SBuf->Pitch() * y;
					
					// 8bit̎͒ԐFȂ
					memcpy( doff, soff, SBuf->Pitch() );
				}
				break;
				
			case 16:	// 16bit[h
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<SBuf->Height(); y++ ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					int a1 = ( y * BBuf->Height() * RESO43 ) / SBuf->Height() - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->GetPixels() +   BBuf->Pitch() * y0;
					WORD *doff = (WORD *)SBuf->GetPixels() + ( SBuf->Pitch() * y ) / sizeof(WORD);
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->Pitch(); x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->Pitch());
							WORD dd = ( (WORD)( ( ( Pal->colors[d1].r * a2 + Pal->colors[d2].r * a1 ) / RESO43 ) & 0xf8 ) << 8 ) |
									  ( (WORD)( ( ( Pal->colors[d1].g * a2 + Pal->colors[d2].g * a1 ) / RESO43 ) & 0xfc ) << 3 ) |
									  ( (WORD)( ( ( Pal->colors[d1].b * a2 + Pal->colors[d2].b * a1 ) / RESO43 ) & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}else{
						for( int x=0; x<BBuf->Pitch(); x++ ){
							BYTE d1 = *(soff++);
							WORD dd = ( (WORD)( Pal->colors[d1].r & 0xf8 ) << 8 ) |
									  ( (WORD)( Pal->colors[d1].g & 0xfc ) << 3 ) |
									  ( (WORD)( Pal->colors[d1].b & 0xf8 ) >> 3 );
							*(doff++) = dd;
						}
					}
				}
				break;
				
			case 24:	// 24bit[h
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<SBuf->Height(); y++ ){
					int y0 = ( y * BBuf->Height() ) / SBuf->Height();
					int a1 = ( y * BBuf->Height() * RESO43 ) / SBuf->Height() - y0 * RESO43;
					int a2 = RESO43 - a1;
					
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y0;
					BYTE *doff = (BYTE *)SBuf->GetPixels() + SBuf->Pitch() * y;
					
					// l?
					if( a1 > THRE43 && a2 > THRE43 ){
						for( int x=0; x<BBuf->Pitch(); x++ ){
							BYTE d1 = *(soff);
							BYTE d2 = *((soff++)+BBuf->Pitch());
							
							BYTE r = ( Pal->colors[d1].r * a2 + Pal->colors[d2].r * a1 ) / RESO43;
							BYTE g = ( Pal->colors[d1].g * a2 + Pal->colors[d2].g * a1 ) / RESO43;
							BYTE b = ( Pal->colors[d1].b * a2 + Pal->colors[d2].b * a1 ) / RESO43;
							
							PUT3BYTE( b, g, r, doff );
						}
					}else{
						for( int x=0; x<BBuf->Pitch(); x++ ){
							BYTE d1 = *(soff++);
							
							BYTE r = Pal->colors[d1].r;
							BYTE g = Pal->colors[d1].g;
							BYTE b = Pal->colors[d1].b;
							
							PUT3BYTE( b, g, r, doff );
						}
					}
				}
			}
		}
	}else{			// 4:3\̏ꍇ
		PRINTD( GRP_LOG, " -> No 4:3(8bit)" );
		if( DISPSCAN ){	// XLC̏ꍇ
			PRINTD( GRP_LOG, " -> ScanLine" );
			switch( SBuf->Bpp() ){
			case 8:		// 8bit[h
				PRINTD( GRP_LOG, " -> 8bit" );
				for( int y=0; y<BBuf->Height(); y++ ){
					DWORD *soff = (DWORD *)BBuf->GetPixels() + BBuf->Pitch()/sizeof(DWORD) * y;
					DWORD *doff = (DWORD *)SBuf->GetPixels() + SBuf->Pitch()/sizeof(DWORD) * y*2;
					DWORD *eoff = doff + SBuf->Pitch()/sizeof(DWORD);
					DWORD s, d;
					
					for( int x=0; x<(int)(BBuf->Width()/sizeof(DWORD)); x++ ){
						BYTE b1,b2,b3,b4;
						s = *soff++;
						DWTOB( s, b1, b2, b3, b4 );
						d = BTODW( b4, b4, b3, b3 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
						d = BTODW( b2, b2, b1, b1 );
						*doff++ = d;
						*eoff++ = d|0x80808080;
					}
				}
				break;
				
			case 16:	// 16bit[h
				PRINTD( GRP_LOG, " -> 16bit" );
				for( int y=0; y<BBuf->Height(); y++ ){
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y;
					WORD *doff = (WORD *)SBuf->GetPixels() + SBuf->Pitch()/sizeof(WORD) * y*2;
					WORD *eoff = doff + SBuf->Pitch()/sizeof(WORD);
					
					for( int x=0; x<BBuf->Width(); x++ ){
						BYTE r = Pal->colors[*(soff)].r;
						BYTE g = Pal->colors[*(soff)].g;
						BYTE b = Pal->colors[*(soff)].b;
						
						WORD dd = ( (WORD)( r & 0xf8 ) << 8 ) |
								  ( (WORD)( g & 0xfc ) << 3 ) |
								  ( (WORD)( b & 0xf8 ) >> 3 );
						*(doff++) = dd;
						*(doff++) = dd;
						
						r = ( r * SLBr ) / 100;
						g = ( g * SLBr ) / 100;
						b = ( b * SLBr ) / 100;
						
						WORD ed = ( (WORD)( r & 0xf8 ) << 8 ) |
								  ( (WORD)( g & 0xfc ) << 3 ) |
								  ( (WORD)( b & 0xf8 ) >> 3 );
						*(eoff++) = ed;
						*(eoff++) = ed;
						
						soff++;
					}
				}
				break;
				
			case 24:	// 24bit[h
				PRINTD( GRP_LOG, " -> 24bit" );
				for( int y=0; y<BBuf->Height(); y++ ){
					BYTE *soff = (BYTE *)BBuf->GetPixels() + BBuf->Pitch() * y;
					BYTE *doff = (BYTE *)SBuf->GetPixels() + SBuf->Pitch() * y*2;
					BYTE *eoff = doff + SBuf->Pitch();
					
					for( int x=0; x<BBuf->Width(); x++ ){
						BYTE r = Pal->colors[*(soff)].r;
						BYTE g = Pal->colors[*(soff)].g;
						BYTE b = Pal->colors[*(soff)].b;
						
						PUT3BYTE( b, g, r, doff );
						PUT3BYTE( b, g, r, doff );
						
						r = ( r * SLBr ) / 100;
						g = ( g * SLBr ) / 100;
						b = ( b * SLBr ) / 100;
						
						PUT3BYTE( b, g, r, eoff );
						PUT3BYTE( b, g, r, eoff );
						
						soff++;
					}
				}
			}
		}else{			// XLCȂ̏ꍇ
			PRINTD( GRP_LOG, " -> No ScanLine" );
			// ̂܂܃Rs[
			BBuf->Blit( NULL, SBuf, NULL );
		}
	}
	
	PRINTD( GRP_LOG, " -> OK\n" );
	
	
	return true;
}


////////////////////////////////////////////////////////////////
// Tuobt@tbV
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool DSP6::RefreshSubBuf( void )
{
	PRINTD( GRP_LOG, "[GRP][RefreshSubBuf]\n" );
	
	if( SBuf ){
		if( SBuf->Width() == ScreenX() && SBuf->Height() == ScreenY() ){
			// TCYςĂȂOK
			PRINTD( GRP_LOG, " X:%d Y:%d -> OK\n", SBuf->Width(), SBuf->Height() );
			return true;
		}else{
			// Tuobt@U폜
			delete SBuf;
			SBuf = NULL;
		}
	}
	
	// Tuobt@쐬
	PRINTD( GRP_LOG, " Create SubBuffer X:%d Y:%d BPP:%d\n", ScreenX(), ScreenY(), Bpp );
	SBuf = new VSurface;
	if( !SBuf ) return false;
	
	if( !SBuf->InitSurface( ScreenX(), ScreenY(), Bpp ) ){
		delete SBuf;
		SBuf = NULL;
		return false;
	}
	
	// pbgݒ
	if( Bpp == 8 ) SBuf->SetPalette( Pal->colors );
	
	return true;
}


////////////////////////////////////////////////////////////////
// XibvVbg
//
// :	path	XN[Vbgi[pX
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void DSP6::SnapShot( char *path )
{
	PRINTD( GRP_LOG, "[GRP][SnapShot]\n" );
	
	char img_file[PATH_MAX];
	char img_name[PATH_MAX] = "P6V";
	int Index = 0;
	
	// XibvVbgi[tH_Ȃ΃G[
	if( !OSD_FileExist( path ) ) return;
	
	// XibvVbgt@C߂
	do{
		sprintf( img_file, "%s%s%03d.%s", path, img_name, ++Index, IMG_EXT );
	}while( OSD_FileExist( img_file ) || (Index > 999) );
	
	// AԂLȂ摜t@Cۑ
	if( !(Index > 999) ) SaveImg( img_file, SBuf, NULL );
}


// [] http://www.joochan.net/rgb-convert.html
// RGB <-> YIQ

// Y =  0.2989 * R + 0.5866 * G + 0.1145 * B
// I =  0.5959 * R - 0.2750 * G - 0.3210 * B
// Q =  0.2065 * R - 0.4969 * G + 0.2904 * B

// R = Y + 0.9489 * I + 0.6561 * Q
// G = Y - 0.2645 * I - 0.6847 * Q
// B = Y - 1.1270 * I + 1.8050 * Q
