#ifndef INI_H_INCLUDED
#define INI_H_INCLUDED

#include "typedef.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cNode {
public:
	enum NodeType{ NODE_NONE, NODE_COMMENT, NODE_SECTION, NODE_ENTRY };
	
private:
	cNode *PrevNode, *NextNode;
	
public:
	cNode( cNode * );			// RXgN^
	~cNode();					// fXgN^
	
	cNode *AddNode();			// m[hǉ
	
	void SetMember( NodeType, const char * );
	
	NodeType NodeID;	// Node ID
	char *Comment;		// Comments
	char *Section;		// Sections
	char *Entry;		// Entries
	char *Value;
	
	cNode *GetPrevNode(){ return PrevNode; }
	cNode *GetNextNode(){ return NextNode; }
	void SetPrevNode( cNode *node ){ PrevNode = node; }
	void SetNextNode( cNode *node ){ NextNode = node; }
	
};

class cIni {
protected:
	cNode *IniNode;				// 擪m[hւ̃|C^
	char FileName[PATH_MAX];	// t@C
	
	bool Ready;
	
public:
	cIni();						// RXgN^
	virtual ~cIni();			// fXgN^
	
	bool Init( char * );		// 
	
	bool IsReady(){ return Ready; }
	
	bool Write();															// 
	bool GetString( const char *, const char *, char *, const char * );		// Ǎ
	bool GetInt( const char *, const char *, int *, const int );			// lǍ
	bool GetTruth( const char *, const char *, bool *, const bool );		// YesNoǍ
	bool PutEntry( const char *, const char *, const char *, const char *, ... );	// Ggǉ
	
};



// ǂłSAVEpC^[tFCX
struct IDoko
{
	virtual bool DokoLoad( cIni * ) = 0;
	virtual bool DokoSave( cIni * ) = 0;
};

#endif	// INI_H_INCLUDED
