#ifndef INTR_H_INCLUDED
#define INTR_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"

#include "p6device.h"

// ݗvtO
//  0 RS232S M 
//  1 L[3
//  2 \
//  3 ^C}
//  4 CMT READ 
//  5 \
//  6 \
//  7 L[1 1
//  8 L[1 2
//  9 CMT ERROR 
// 10 L[2
// 11 Q[pL[
// 12 8049(L1,2,4-11)
#define	IREQ_SIO	(0x0001)
#define	IREQ_KEY3	(0x0002)
#define	IREQ_TIMER	(0x0008)
#define	IREQ_CMT_R	(0x0010)
#define	IREQ_KEY1	(0x0080)
#define	IREQ_KEY1_2	(0x0100)
#define	IREQ_CMT_E	(0x0200)
#define	IREQ_KEY2	(0x0400)
#define	IREQ_JOY	(0x0800)
#define	IREQ_8049	(0x1000)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class INT6 : public P6DEVICE, public IDoko {
protected:
	DWORD IntrFlag;			// ݗvtO
	
	bool TimerIntrEnable;	// ^C}݋tO
	BYTE TimerAddr;			// ^C}݃AhX
	BYTE TimerCntUp;		// ^C}݃JEgAbvl
	
	void SetTimerIntrHz( BYTE );			// ^C}ݎgݒ
	virtual bool IsTimerIntrEnable();		// ^C}݋`FbN
	
public:
	INT6( VM6 *, const P6ID& );				// RXgN^
	virtual ~INT6();						// fXgN^
	
	void EventCallback( int, int );			// CxgR[obN֐
	
	virtual void Reset() = 0;				// Zbg
	
	int	IntrCheck();						// ݃`FbN
	
	void ReqIntr( DWORD );					// ݗv
	void CancelIntr( DWORD );				// ݓP
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class INT60 : public INT6, public Device {
private:
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	
public:
	INT60( VM6 *, const ID& );				// RXgN^
	~INT60();								// fXgN^
	
	void Reset();							// Zbg
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
};


class INT62 : public INT6, public Device {
private:
	bool TimerIntrEnable2;	// ^C}݋tO(PortF3H mk2ȍ~)
	bool Int1IntrEnable;	// INT1݋tO
	bool Int2IntrEnable;	// INT2݋tO
	bool Int1AddrOutput;	// INT1݃AhXo̓tO
	bool Int2AddrOutput;	// INT2݃AhXo̓tO
	
	BYTE Int1Addr;			// INT1݃AhX
	BYTE Int2Addr;			// INT2݃AhX
	
	bool IsTimerIntrEnable();				// ^C}݋`FbN
	void SetIntrEnable( BYTE );				// ݋tOݒ
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	void OutF3H( int, BYTE );
	void OutF4H( int, BYTE );
	void OutF5H( int, BYTE );
	void OutF6H( int, BYTE );
	void OutF7H( int, BYTE );
	BYTE InF3H( int );
	BYTE InF4H( int );
	BYTE InF5H( int );
	BYTE InF6H( int );
	BYTE InF7H( int );
	
public:
	INT62( VM6 *, const ID& );				// RXgN^
	~INT62();								// fXgN^
	
	void Reset();							// Zbg
	
	// foCXID
	enum IDOut{ outB0H=0, outF3H, outF4H, outF5H, outF6H, outF7H };
	enum IDIn {  inF3H=0,  inF4H,  inF5H,  inF6H,  inF7H };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// INTR_H_INCLUDED
