#ifndef KEYBOARD_H_INCLUDED
#define KEYBOARD_H_INCLUDED

#include "typedef.h"
#include "ini.h"
#include "keydef.h"

#include "p6device.h"


// L[{[hCWP[^
#define	KI_KANA		(1)
#define	KI_KKANA	(2)
#define	KI_CAPS		(4)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class KEY6 : public P6DEVICE, public IDoko {
protected:
	P6KEYsym K6Table[KVC_LAST];		// zL[R[h -> P6L[R[h ϊe[u
	BYTE MatTable[KP6_LAST];		// P6L[R[h -> }gNX ϊe[u
	
	// L[ tO
	bool ON_SHIFT;	// SHIFT
	bool ON_GRAPH;	// GRAPH
	bool ON_KANA;	// 
	bool ON_KKANA;	// J^Ji
	bool ON_CTRL;	// CTRL
	bool ON_STOP;	// STOP
	bool ON_CAPS;	// CAPS
	
	BYTE P6Matrix[16*2];		// L[}gNX (O: 㔼:O)
	BYTE P6Mtrx[16*2];			// L[}gNXۑp
								//  2byte̓WCXeBbN̏ԕۑp

public:
	KEY6( VM6 *, const P6ID& );			// RXgN^
	virtual ~KEY6();					// fXgN^
	
	bool Init( int );					// 
	
	void UpdateMatrixKey( int, bool );	// L[}gNXXV(L[)
	void UpdateMatrixJoy( BYTE, BYTE );	// L[}gNXXV(WCXeBbN)
	bool ScanMatrix();					// L[}gNXXL
	int GetMatrixSize();				// L[}gNXTCY擾
	BYTE *GetMatrix();					// L[}gNX|C^擾
	BYTE *GetMatrix2();					// L[}gNX|C^(ۑp)擾
	
	BYTE GetKeyJoy();					// J[\L[Ԏ擾
	BYTE GetKeyIndicator();				// L[{[hCWP[^Ԏ擾
	
	void SetVKeySymbols( VKeyConv * );	// zL[R[h -> P6L[R[h ݒ
	
	BYTE GetJoy( int );					// WCXeBbNԎ擾
	
	void ChangeKana();					// p<->Ȑ؊
	void ChangeKKana();					// <->Ji؊
	
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class KEY60 : public KEY6 {
public:
	KEY60( VM6 *, const P6ID& );		// RXgN^
	~KEY60();							// fXgN^
};


#endif	// KEYBOARD_H_INCLUDED
