#ifndef MEMORY_H_INCLUDED
#define MEMORY_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"


// ubN
#define MAXRMB	(16)
#define MAXWMB	(16)

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// ubNNX
class MemBlock {
protected:
	char Name[33];				// ubN
	BYTE *MB;					// ubNւ̃|C^
	int RWait;					// ANZXEFCg(Ǎ)
	int WWait;					// ANZXEFCg()
	bool WPt;					// CgveNgtO
	
public:
	MemBlock();									// RXgN^
	~MemBlock();								// fXgN^
	
	void SetMemory( const char *, BYTE *, int, int );	// ubNݒ
	void SetWait( int, int );					// ANZXEFCgݒ
	int GetWait();								// ANZXEFCg擾
	void SetProtect( bool );					// CgveNgݒ
	bool GetProtect();							// CgveNg擾
	
	char *GetName(){ return Name; }				// ubN擾
	
	BYTE Read( WORD, int * = NULL );			// [h
	void Write( WORD, BYTE, int * = NULL );		// Cg
};


class MEM6 : public IDoko {
protected:
	// \
	typedef struct{
		const char *FileName;	// t@C
		DWORD Size;				// TCY
		DWORD Crc;				// CRC32
		BYTE Init;				// f[^
		int WaitR;				// ANZXEFCg(Read)
		int WaitW;				// ANZXEFCg(Write)
	} MEMINFO;
	
	// 
	static const MEMINFO IEXTROM;
	static const MEMINFO IEMPTROM;
	static const MEMINFO IEMPTRAM;
	static const MEMINFO IEXTRAM;
	
	bool CGBank;				// CG ROM BANK true:L false:
	bool UseExtRom;				// gROM     true:L false:
	bool UseExtRam;				// gRAM     true:L false:
	
	BYTE *MainRom;				// BASIC ROM	60:16KB 62,66:32KB
	BYTE *ExtRom;				// g ROM		60:16KB 62,66:16KB
	BYTE *CGRom1;				// CG ROM1		60: 4KB 62,66: 8KB
	BYTE *IntRam;				//  RAM		60:16KB 62,66:64KB
	BYTE *ExtRam;				// O RAM		60:16KB 62,66:16KB
	BYTE *EmptyRom;				// ROM	60: 8KB 62,66: 8KB
	BYTE *EmptyRam;				// RAM	60: 8KB 62,66: 8KB
	
	MemBlock RomB[MAXRMB];		// ROMubN
	MemBlock RamB[MAXWMB];		// RAMubN
	
	MemBlock *Rm_blk[8];		// [hubN|C^(8KB*8)
	MemBlock *Wm_blk[8];		// CgubN|C^(8KB*8)
	
	BYTE ram_sel[4];			// RAM,ORAM Ip(16KB*4)
	
	char FilePath[PATH_MAX];	// gROMt@CtpX
	int M1Wait;					// M1EFCg
	bool EnableChkCRC;			// CRC`FbNL?
	
	
	// m̃J[gbW ------------------------------------------
	static const MEMINFO ISOLRAM;	// RAM
	bool UseSol;					// true:L false:
	int SolBank;					// ROMoN(0-15)
	void SetSolBank( BYTE );		// ROMoNݒ
	// -------------------------------------------------------------
	
	
	bool AllocMemory( BYTE **, const MEMINFO *, char * );	// mۂROMt@CǍ
	bool InitCommon( bool, bool );	// ʕ
	
public:
	MEM6( bool );							// RXgN^
	virtual ~MEM6();						// fXgN^
	
	virtual bool Init( char *, bool, bool ) = 0;	// 
	virtual void Patch();					// pb`
	virtual void Reset();					// Zbg
	
	BYTE Fetch( WORD, int * = NULL );		// tFb`(M1)
	BYTE Read( WORD, int * = NULL );		// [h
	void Write( WORD, BYTE, int * = NULL );	// Cg
	
	bool MountExtRom( char * );				// gROM }Eg
	void UnmountExtRom();					// gROM A}Eg
	char *GetFile();						// gROMt@CpX擾
	
	// 8255o͊֘A֐
	virtual void SetCGBank( bool );			// CG ROM BANK ؂ւ
	
	// ڃANZX֐
	virtual BYTE ReadMainRom( WORD );
	virtual BYTE ReadMainRam( WORD );
	virtual BYTE ReadExtRom ( WORD );
	virtual BYTE ReadCGrom0 ( WORD );
	virtual BYTE ReadCGrom1 ( WORD );
	virtual BYTE ReadCGrom2 ( WORD );
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	virtual char *GetReadMemBlk( int );
	virtual char *GetWriteMemBlk( int );
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
};


class MEM60 : public MEM6, public Device {
private:
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM0;
	static const MEMINFO ICGROM1;
	static const MEMINFO IINTRAM;
	
	BYTE *CGRom0;		// CG ROM0		60: 1KB 62,66: -KB
	
	void SetMB_60();					// ubNݒ(60̂)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void Out7FH( int, BYTE );
	
public:
	MEM60( const ID&, bool );			// RXgN^
	~MEM60();							// fXgN^
	
	bool Init( char *, bool, bool );	// 
	void Patch();						// pb`
	void Reset();						// Zbg
	
	// ڃANZX֐
	BYTE ReadMainRam( WORD );
	BYTE ReadCGrom0( WORD );
	
	// foCXID
	enum IDOut{ out7FH=0 };
	enum IDIn {};
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class MEM62 : public MEM6, public Device {
protected:
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM1;
	static const MEMINFO ICGROM2;
	static const MEMINFO IKANJI;
	static const MEMINFO IVOICE;
	static const MEMINFO IINTRAM;
	
	BYTE *CGRom2;		// CG ROM2		60: -KB 62,66: 8KB
	BYTE *KanjiRom;		//  ROM		60: -KB 62,66:32KB
	BYTE *VoiceRom;		//  ROM	60: -KB 62,66:16KB
	
	bool cgrom;			// CG ROM Ip true:N60[h false:N60m[h
	bool kj_rom;		// ROM,ROM Ip true:ROM false:ROM
	bool kj_LR;			// ROM EIp true:E false:
	
	bool cgenable;		// CG ROMANZXtO true:ANZX false:ANZXs
	BYTE cgaddr;		// CG ROMAhX A13,14,15
	
	BYTE Rf0;			// Rg[WX^
	BYTE Rf1;			// Rg[WX^
	BYTE Rf2;			// Rg[WX^
	
	void SetMB_R( BYTE, BYTE );			// [h̃ubNw(62,66̂)
	void SetMB_W( BYTE );				// Cg̃ubNw(62,66̂)
	void SetWait( BYTE );				// ANZXEFCgݒ
	BYTE GetWait();						// ANZXEFCg擾
	
	void SetCGrom( BYTE );				// CG ROM AhXݒ(62,66̂)
	void SelectCGrom( int );			// CG ROM I(62,66̂)
	void SelectKanjiRom( BYTE );		// ROM  ROM ؂ւ(62,66̂)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void Out7FH( int, BYTE );
	void OutC1H( int, BYTE );
	void OutC2H( int, BYTE );
	void OutC3H( int, BYTE );
	void OutF0H( int, BYTE );
	void OutF1H( int, BYTE );
	void OutF2H( int, BYTE );
	void OutF3H( int, BYTE );
	void OutF8H( int, BYTE );
	
	BYTE InF0H( int );
	BYTE InF1H( int );
	BYTE InF2H( int );
	BYTE InF3H( int );
	
public:
	MEM62( const ID&, bool );			// RXgN^
	virtual ~MEM62();					// fXgN^
	
	virtual bool Init( char *, bool, bool );	// 
	void Patch();						// pb`
	void Reset();						// Zbg
	
	// 8255o͊֘A֐
	void SetCGBank( bool );				// CG ROM BANK ؂ւ
	
	// ڃANZX֐
	BYTE ReadMainRom( WORD );
	BYTE ReadMainRam( WORD );
	BYTE ReadCGrom2( WORD );
	BYTE ReadKanjiRom( WORD );
	BYTE ReadVoiceRom( WORD );
	
	// foCXID
	enum IDOut{ out7FH=0, outC1H, outC2H, outC3H, outF0H,  outF1H, outF2H, outF3H, outF8H };
	enum IDIn {                                    inF0H=0, inF1H,  inF2H,  inF3H         };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class MEM66 : public MEM62 {
private:
	// 
	static const MEMINFO IMAINROM;
	static const MEMINFO ICGROM1;
	static const MEMINFO ICGROM2;
	static const MEMINFO IKANJI;
	static const MEMINFO IVOICE;
	static const MEMINFO IINTRAM;
	
	void SelectKanjiRom( BYTE );		// ROM  ROM ؂ւ(62,66̂)
	
public:
	MEM66( const ID&, bool );			// RXgN^
	~MEM66();							// fXgN^
	
	bool Init( char *, bool, bool );	// 
	void Patch();						// pb`
};


#endif	// MEMORY_H_INCLUDED
