#include "log.h"
#include "movie.h"
#include "common.h"


// [Ql] MSDN
// AVI t@C tH[}bg
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/directx9_c/directx/htm/avifileformat.asp
// AVI t@C tH[}bg DV f[^(A[JCuRec)
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/jpdx8_c/ds/filtdev/DV_Data_AVI_File_Format.asp

// 16bit[hɂẴ
// SDL R:G:B=5:6:5 炵̂̃tH[}bgQuickTimeŏ肭ĐłȂ悤Ȃ̂
// R:G:B=5:5:5 ƂĂ݂B

#define	CIDVIDS		(CTODW( 'v', 'i', 'd', 's' ))
#define	CIDAUDS		(CTODW( 'a', 'u', 'd', 's' ))
#define	CIDRLE		(CTODW( 'R', 'L', 'E', ' ' ))
#define	CIDDIB		(CTODW( 'D', 'I', 'B', ' ' ))
#define	CID00DC		(CTODW( '0', '0', 'd', 'c' ))
#define	CID00DB		(CTODW( '0', '0', 'd', 'b' ))
#define	CID01WB		(CTODW( '0', '1', 'w', 'b' ))


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
AVI6::AVI6( void ) : vfp(NULL), ABPP(8), AVIRLE(true), PosMOVI(0),
						RiffSize(0), MoviSize(0), anum(0) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
AVI6::~AVI6( void )
{
	if( IsAVI() ) StopAVI();
}


////////////////////////////////////////////////////////////////
// ewb_o
////////////////////////////////////////////////////////////////
void AVI6::putBMPINFOHEADER6( BMPINFOHEADER6 *p )
{
	FPUTDWORD( p->biSize,			vfp );
	FPUTDWORD( p->biWidth,			vfp );	// LONG
	FPUTDWORD( p->biHeight,			vfp );	// LONG
	FPUTWORD(  p->biPlanes,			vfp );
	FPUTWORD(  p->biBitCount,		vfp );
	FPUTDWORD( p->biCompression,	vfp );
	FPUTDWORD( p->biSizeImage,		vfp );
	FPUTDWORD( p->biXPelsPerMeter,	vfp );	// LONG
	FPUTDWORD( p->biYPelsPerMeter,	vfp );	// LONG
	FPUTDWORD( p->biClrUsed,		vfp );
	FPUTDWORD( p->biClrImportant,	vfp );
}

void AVI6::putMAINAVIHEADER6( MAINAVIHEADER6 *p )
{
	FPUTDWORD( p->dwMicroSecPerFrame,		vfp );
	FPUTDWORD( p->dwMaxBytesPerSec,			vfp );
	FPUTDWORD( p->dwReserved1,				vfp );
	FPUTDWORD( p->dwFlags,					vfp );
	FPUTDWORD( p->dwTotalFrames,			vfp );
	FPUTDWORD( p->dwInitialFrames,			vfp );
	FPUTDWORD( p->dwStreams,				vfp );
	FPUTDWORD( p->dwSuggestedBufferSize,	vfp );
	FPUTDWORD( p->dwWidth,					vfp );
	FPUTDWORD( p->dwHeight,					vfp );
	fwrite( (DWORD *)&p->dwReserved ,sizeof(DWORD), 4, vfp );
}

void AVI6::putAVISTRMHEADER6( AVISTRMHEADER6 *p )
{
	FPUTDWORD( p->fccType,					vfp );
	FPUTDWORD( p->fccHandler,				vfp );
	FPUTDWORD( p->dwFlags,					vfp );
	FPUTDWORD( p->dwPriority,				vfp );
	FPUTDWORD( p->dwInitialFrames,			vfp );
	FPUTDWORD( p->dwScale,					vfp );
	FPUTDWORD( p->dwRate,					vfp );
	FPUTDWORD( p->dwStart,					vfp );
	FPUTDWORD( p->dwLength,					vfp );
	FPUTDWORD( p->dwSuggestedBufferSize,	vfp );
	FPUTDWORD( p->dwQuality,				vfp );
	FPUTDWORD( p->dwSampleSize,				vfp );
	
	FPUTDWORD( p->rcFrame.left,		vfp );	// LONG
	FPUTDWORD( p->rcFrame.top,		vfp );	// LONG
	FPUTDWORD( p->rcFrame.right,	vfp );	// LONG
	FPUTDWORD( p->rcFrame.bottom,	vfp );	// LONG
}

// AVIINDEXENTRY
void AVI6::putAVIINDEXENTRY6( AVIINDEXENTRY6 *p )
{
	FPUTDWORD( p->ckid,				vfp );
	FPUTDWORD( p->dwFlags,			vfp );
	FPUTDWORD( p->dwChunkOffset,	vfp );
	FPUTDWORD( p->dwChunkLength,	vfp );
} 

// WAVEFORMATEX
void AVI6::putWAVEFORMATEX6( WAVEFORMATEX6 *p )
{
	FPUTWORD( p->wFormatTag,		vfp );
	FPUTWORD( p->nChannels,			vfp );
	FPUTDWORD(p->nSamplesPerSec,	vfp );
	FPUTDWORD(p->nAvgBytesPerSec,	vfp );
	FPUTWORD( p->nBlockAlign,		vfp );
	FPUTWORD( p->wBitsPerSample,	vfp );
	FPUTWORD( p->cbSize,			vfp );
	
	FPUTWORD( 0,            		vfp );
}




////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool AVI6::Init( void )
{
	PRINTD( GRP_LOG, "[MOVIE][Init]\n" );
	
	if( vfp ) fclose( vfp );
	vfp = NULL;
	
	ZeroMemory( &vmh, sizeof(MAINAVIHEADER6) );
	ZeroMemory( &vsh, sizeof(AVISTRMHEADER6) );
	ZeroMemory( &ash, sizeof(AVISTRMHEADER6) );
	ZeroMemory( &vbf, sizeof(BMPINFOHEADER6) );
	ZeroMemory( &pal, sizeof(RGBPAL6)*256 );
	ZeroMemory( &awf, sizeof(WAVEFORMATEX6) );
	
	ABPP     = 8;
	AVIRLE   = true;
	
	PosMOVI  = 0;
	
	RiffSize = 0;
	MoviSize = 0;
	
	return true;
}


////////////////////////////////////////////////////////////////
// rfILv`Jn
//
// :	filename	o̓t@C
//			sbuf		Tuobt@ւ̃|C^
//			vrate		t[[g(fps)
//			arate		TvO[g(Hz)
//			rle			true:RLEg false:RLEgȂ
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool AVI6::StartAVI( char *filename, VSurface *sbuf, int vrate, int arate, bool rle )
{
	Init();
	
	vfp = FOPENEN( filename, "w+b" );
	if( !vfp ) return false;
	
	switch( sbuf->Bpp() ){
	case 24: ABPP = 24; AVIRLE = false; break;
	case 16: ABPP = 16; AVIRLE = false; break;
	default: ABPP =  8; AVIRLE = rle;
	}
	
	// AVICwb_[̐ݒ
	// t[Ԃ̊Ԋu}CNbPʂŎw肷B̒l̓t@C̑Ŝ̃^C~OB
	vmh.dwMicroSecPerFrame = 1000000 / vrate;
	// t@C̊TZőf[^[gw肷B̒l,Cwb_[уXg[wb_[`NɊ܂܂
	// ̃p[^ɏ] AVIV[PX\邽߂,VXeȂ΂ȂȂb̃oCgB
	// (Ƃ肠)
	vmh.dwMaxBytesPerSec = 0;
	// t@Cɑ΂tO܂ށBȉ̃tO`ĂB
	//  AVIF_HASINDEX AVI	t@C̏IɃCfbNX܂ 'idx1'`N邱ƂB
	//						ǍDȃptH[}X̂߂ɂ,ׂĂ AVIt@CCfbNX܂ޕKvB
	//  AVIF_MUSTUSEINDEX	f[^̃v[e[V̏肷邽߂,t@C̃`N̕Iȏł͂Ȃ
	//						CfbNXgp邱ƂBƂ,găt[̃Xg쐬ĕҏW邱ƂłB
	//  AVIF_ISINTERLEAVED	AVIt@CC^[[uĂ邱ƂB
	//  AVIF_WASCAPTUREFILE	AVIt@C,A^CrfĨLv`pɓʂɊ蓖Ăꂽt@Cł邱ƂB
	//						AvP[V,̃tOݒ肳ꂽt@CI[o[ChO,[U[Ɍx𔭂KvB
	//						,[U[̃t@CftOgĂ\łB
	//  AVIF_COPYRIGHTED	AVIt@Cɒ쌠̂f[^у\tgEFA܂܂Ă邱ƂB
	//						̃tOgpĂꍇ,\tgEFA̓f[^̕ׂł͂ȂB
	vmh.dwFlags = 0x00000110;	// AVIF_HASINDEX | AVIF_ISINTERLEAVED
	// t@C̃f[^̃t[̑w肷B
	// ()
	vmh.dwTotalFrames = 0;
	// C^[[uꂽt@C̊Jnt[w肷BC^[[uꂽt@CȊOł,[w肷B
	// C^[[uꂽt@C쐬ꍇ,t@C AVIV[PX̊Jnt[Oɂt[
	// ̃oɎw肷B̃o̓eɊւڍׂɂĂ
	// wVideo for Windows Programmer's Guidex́uSpecial Information for Interleaved FilesvQƂ邱ƁB
	vmh.dwInitialFrames = 0;
	// t@C̃Xg[w肷BƂ,I[fBIƃrfI܂ރt@Cɂ 2̃Xg[B
	vmh.dwStreams = 2;
	// t@Cǂݎ邽߂̃obt@TCYw肷Bʂ,̃TCY̓t@C̍ő̃`Ni[̂
	// \ȑ傫ɂB[ɐݒ肵,lɐݒ肵ꍇ,Đ\tgEFA͍ĐɃ
	// Ċ蓖ĂȂ΂Ȃ炸,ptH[}XቺBC^[[uꂽt@C̏ꍇ,obt@TCY̓`Nł͂Ȃ
	// R[hŜǂݎ̂ɏ\ȑ傫łȂ΂ȂȂB
	// (Ƃ肠1t[)
	vmh.dwSuggestedBufferSize = sbuf->Width() * sbuf->Height() * ( ABPP / 8 );
	// AVIt@C̕sNZPʂŎw肷B
	vmh.dwWidth  = sbuf->Width();
	// AVIt@C̍sNZPʂŎw肷B
	vmh.dwHeight = sbuf->Height();
	
	// AVIXg[wb_[̐ݒ
	// Xg[Ɋ܂܂f[^̃^Cvw肷 FOURCC ܂ށBrfIуI[fBIɑ΂Ĉȉ̕WAVIl`ĂB
	//  'vids'	Xg[ɃrfIf[^܂܂邱ƂBXg[tH[}bg`Nɂ,pbg܂ނƂ\
	//			BITMAPINFO \̂܂܂B
	//  'auds'	Xg[ɃI[fBIf[^܂܂邱ƂBXg[tH[}bg`Nɂ,WAVEFORMATEX
	//			܂ PCMWAVEFORMAT \̂܂܂B
	//  'txts'	Xg[ɃeLXg f[^܂܂邱ƂB
	vsh.fccType = CIDVIDS;
	ash.fccType = CIDAUDS;
	// ̃f[^nh FOURCC ܂ (IvV)Bf[^nh,Xg[ɑ΂ēK؂ȃnhłB
	// I[fBIуrfIXg[̏ꍇ,CXg[\ȃRvbT܂̓fRvbTw肷B
	vsh.fccHandler = ( (ABPP==8) && AVIRLE ) ? CIDRLE  : CIDDIB;
	ash.fccHandler = 0x00000001;	//(PCM)
	// f[^ Xg[ɑ΂tO܂ށB̃tȌʃ[h̃rbg,Xg[Ɋ܂܂f[^̃^CvɌŗLłB
	// ȉ̕WtO`ĂB
	//  AVISF_DISABLED			̃Xg[ftHgŗLɂȂƂB
	//  AVISF_VIDEO_PALCHANGES	̃rfIXg[Ƀpbg̕ύX܂܂邱ƂB̃tO,Đ\tgEFAɑ΂
	//							pbgAj[VKv邱ƂxB
	vsh.dwFlags = 0;
	ash.dwFlags = 0;
	// Xg[ ^Cv̗D揇ʂw肷BƂ,̃I[fBIXg[܂ރt@Cł,D揇ʂ̍łXg[
	// ftHg̃Xg[ɂȂB
	vsh.dwPriority = 0;
	ash.dwPriority = 0;
	// C^[[uꂽt@C,I[fBIf[^rfIt[ǂ̂炢XL[Ă邩w肷B
	// ʏ, 0.75 błBC^[[uꂽt@C쐬ꍇ,t@C AVIV[PX̊Jnt[
	// Oɂt[,̃oɎw肷B̃o̓eɊւڍׂɂĂ,wVideo for Windows Programmer's Guidex
	// uSpecial Information for Interleaved FilesvQƂ邱ƁB
	vsh.dwInitialFrames = 0;
	ash.dwInitialFrames = 0;
	// dwRate ƂƂɎgp,̃Xg[gp^CXP[w肷BdwRate  dwScale Ŋ邱Ƃɂ
	// 1 b̃Tv߂BrfIXg[̏ꍇ,̃[g̓t[[gɓȂB
	// I[fBIXg[̏ꍇ,̃[g nBlockAlign oCg̃I[fBIf[^ɕKvȎԂɑΉB
	//  PCMI[fBȈꍇ̓Tv[gɓȂB
	vsh.dwScale = 10000;
	ash.dwScale = 2;
	// dwScale QƂ邱ƁB
	vsh.dwRate = vsh.dwScale * vrate;
	ash.dwRate = ash.dwScale * arate;
	// AVIt@C̊Jn^Cw肷BPʂ,Ct@Cwb_[ dwRate  dwScale oɂĒ`B
	// ʏ,̓[ł邪,t@CƓɊJnȂXg[ɑ΂Ă,xԂw肷邱ƂłB
	vsh.dwStart = 0;
	ash.dwStart = 0;
	// ̃Xg[̒w肷BPʂ,Xg[̃wb_[ dwRate  dwScale oɂĒ`B
	// ()
	vsh.dwLength = 0;
	ash.dwLength = 0;
	// ̃Xg[ǂݎ邽߂ɕKvȃobt@̑傫w肷Bʏ,Xg[̍ő̃`NɑΉlłB
	// obt@TCYgp邱Ƃ,Đ̌܂Bobt@TCY킩Ȃꍇ,[w肷B
	// (Ƃ肠1t[)
	vsh.dwSuggestedBufferSize = sbuf->Width() * sbuf->Height() * ( ABPP / 8 );
	ash.dwSuggestedBufferSize = arate / vrate * 2;
	// Xg[̃f[^̕ilw肷Bi,0`10,000 ͈̔͂̒lŎBkf[^̏ꍇ,͒ʏ
	// k\tgEFAɓnip[^̒lB-1ɐݒ肵ꍇ,hCo̓ftHg̕ilgpB
	vsh.dwQuality = 0;
	ash.dwQuality = 0;
	// f[^ 1 TṽTCYw肷BTṽTCYωꍇ,[ɐݒ肷B̒l[łȂꍇ
	// t@Cŕ̃f[^Tv 1̃`NɃO[vłB[̏ꍇ,ef[^Tv(rfIt[Ȃ)
	// ͂ꂼʂ̃`NɊ܂܂Ȃ΂ȂȂBrfIXg[̏ꍇ,̒l͒ʏ[ł邪
	// ׂẴrfIt[TCYł,[ȊO̒lɂłBI[fBIXg[̏ꍇ,̒l̓I[fBI
	// Lq WAVEFORMATEX \̂ nBlockAlign oƓłȂ΂ȂȂB
	vsh.dwSampleSize = 0;
	ash.dwSampleSize = 2;
	// AVI Cwb_[\̂ dwWidth  dwHeight oɂĎw肳铮`̃eLXg܂̓rfIXg[
	// ΂]`w肷Bʏ,rcFrame o,̃rfIXg[T|[g邽߂ɎgpB̋`
	// `ɑΉWɐݒ肵,`ŜXVB̃o̒Pʂ̓sNZłB]`̍
	// `̍̑ΎwƂȂB
	vsh.rcFrame.left   = 0;
	vsh.rcFrame.top    = 0;
	vsh.rcFrame.right  = sbuf->Width()  - 1;
	vsh.rcFrame.bottom = sbuf->Height() - 1;
	
	// BMPINFOHEADER6\̂̐ݒ
	// \̂KvƂoCgw肷B
	vbf.biSize = sizeof(BMPINFOHEADER6);
	// rbg}bv̕sNZPʂŎw肷B
	vbf.biWidth  = sbuf->Width();
	// rbg}bv̍sNZPʂŎw肷BbiHeight ̒lłꍇ,rbg}bv̓{gAbvDIB
	// (device-independent bitmap : foCXɈˑȂrbg}bv) ł,_ƂȂBbiHeight ̒lłꍇ
	// rbg}bv̓gbv_EDIB ł,_ƂȂB
	vbf.biHeight = sbuf->Height();
	// ^[Qbg foCXɑ΂ʂ̐w肷B͕K 1 ɐݒ肷B
	vbf.biPlanes = 1;
	// 1 sNZ̃rbgw肷BktH[}bgɂĂ,sNZ̐F𐳂fR[h邽߂ɂ̏񂪕KvłB
	vbf.biBitCount = ABPP;
	// gpĂ,܂͗vĂ鈳k̃^Cvw肷B̈ktH[}bgƐVktH[}bg̗
	// ̃ogpB
	switch( ABPP ){
	case 16:
	case 24: vbf.biCompression = 0; break;	// 0:BI_RGB
	default:
		if( AVIRLE ) vbf.biCompression = 1;	// 1:BI_RLE8
		else         vbf.biCompression = 0; // 0:BI_RGB
	}
	// C[W̃TCYoCgPʂŎw肷B񈳏kRGBrbg}bv̏ꍇ,0 ɐݒłB
	vbf.biSizeImage = sbuf->Width() * sbuf->Height() * ( ABPP / 8 );
	// rbg}bṽ^[QbgfoCX̐𑜓x 1[g̃sNZPʂŎw肷BAvP[V͂̒l
	// gp,\[XO[v̒猻݂̃foCX̓ɍłKrbg}bvI邱ƂłB
	vbf.biXPelsPerMeter = 0;
	// rbg}bṽ^[Qbg foCX̐𑜓x 1[g̃sNZPʂŎw肷B
	vbf.biYPelsPerMeter = 0;
	// J[ e[ũJ[ CfbNX̂,rbg}bvŎۂɎgpCfbNX̐w肷B̒l
	// [̏ꍇ,rbg}bv,biCompression Ŏw肳鈳k[hɑ΂,biBitCount o̒lɑΉőFgpB
	// Mac̏ꍇ256łȂƐFȂ炵B(by c&Windy)
	// ł24bit̎0ɂĂȂƂƍĐȂ݂B
	switch( ABPP ){
	case 24: vbf.biClrUsed =   0; break;
	case 16: vbf.biClrUsed =   0; break;
	default: vbf.biClrUsed = 256;
	}
	// rbg}bv\邽߂ɏdvƂ݂ȂJ[CfbNXw肷B̒l[̏ꍇ,ׂĂ̐FdvƂ݂ȂB
	vbf.biClrImportant = 0;
	
	// pbg擾
	if( ABPP == 8 ){
		for( int i=0; i<sbuf->GetPalette()->ncols; i++ ){
			pal[i].b        = sbuf->GetPalette()->colors[i].b;
			pal[i].g        = sbuf->GetPalette()->colors[i].g;
			pal[i].r        = sbuf->GetPalette()->colors[i].r;
			pal[i].reserved = 0;
		}
	}
	
	// WAVEFORMATEX6\̂̐ݒ
	// I[fBIXg[̃I[fBIg`^Cv`BtH[}bg^O̊SȃXg,Microsoft Visual C++ 
	//  Microsoft iɕt Mmreg.h wb_[ t@CɂB
	awf.wFormatTag = 0x0001;	// WAVE_FORMAT_PCM
	// I[fBIXg[̃`lw肷B1̓m,2̓XeIB
	awf.nChannels = 1;
	// I[fBIXg[̃Tv[ggTv/b (Hz) Ŏw肷BƂ,11,025,22,050,܂ 44,100B
	awf.nSamplesPerSec = arate;
	// σf[^[gw肷BĐ\tgEFA͂̒lgăobt@TCYς邱ƂłB
	awf.nAvgBytesPerSec = arate * 2;
	// f[^̃ubN ACgoCgPʂŎw肷BĐ\tgEFA 1ɏf[^̃oCg
	// nBlockAlign ̐{łȂ΂ȂȂ,nBlockAlign ̒lgpăobt@̃ACgsƂłB
	awf.nBlockAlign = 2;
	// `lf[^Ƃ 1Tṽrbgw肷Be`l̃Tv𑜓x͓łƉ肳B
	// ̃tB[hKvȂꍇ,[ɐݒ肷B
	awf.wBitsPerSample = 16;
	// tH[}bgwb_[̒ǉ̃TCYoCgPʂŎw肷Bɂ,WAVEFORMATEX \̂̃TCY͊܂܂ȂB
	// Ƃ,wFormatTag WAVE_FORMAT_IMA_ADPCM ɑΉ wavetH[}bg̏ꍇ,cbSize 
	// sizeof(IMAADPCMWAVEFORMAT) - sizeof(WAVEFORMATEX) ƂČvZ,ʂ 2ƂȂB
	awf.cbSize = 0;
	
	// wb_`No
	WriteHeader();
	
	// I[fBIobt@쐬
	ABuf.InitBuffer( arate / vrate * 2 );
	// JE^
	anum = 0;
	
	return true;
}


////////////////////////////////////////////////////////////////
// rfILv`~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void AVI6::StopAVI( void )
{
	if( !vfp ) return;
	
	// t[
	vsh.dwLength = vmh.dwTotalFrames;
	ash.dwLength = anum;
	
	// ̎_Ńt@C|C^͖ɂ͂Ô
	fseek( vfp, 0, SEEK_END );
	
	// Movi`ÑTCY擾
	MoviSize = ftell( vfp ) - PosMOVI;
	
	// CfbNX`No
	WriteIndexr();
	
	RiffSize = ftell( vfp ) - 8;
	
	// wb_`Nďo
	WriteHeader();
	
	fclose( vfp );
	vfp = NULL;
}


////////////////////////////////////////////////////////////////
// rfILv`?
//
// :	Ȃ
// Ԓl:	bool	true:Lv` false:Ђ
////////////////////////////////////////////////////////////////
bool AVI6::IsAVI( void )
{
	return vfp ? true : false;
}


////////////////////////////////////////////////////////////////
// AVI1t[o
//
// :	sbuf	T[tFXւ̃|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool AVI6::AVIWriteFrame( VSurface *sbuf )
{
	if( !vfp || !sbuf ) return false;
	
	int xx = min( sbuf->Width(),  vbf.biWidth  );
	int yy = min( sbuf->Height(), vbf.biHeight );
	
	FPUTDWORD( ( (ABPP==8) && AVIRLE ) ? CID00DC : CID00DB, vfp );
	FPUTDWORD( vbf.biSizeImage, vfp );
	
	switch( ABPP ){
	case 8:		// 8bit̏ꍇ
		if( AVIRLE ){	// RLȄꍇ
			long fnum = 0;
			for( int y = yy - 1; y >= 0; y-- ){
				BYTE dat = ((BYTE *)sbuf->GetPixels())[y*sbuf->Pitch()];
				int num = 1;
				for( int x = 1; x < xx; x++ ){
					if( ( ((BYTE *)sbuf->GetPixels())[y*sbuf->Pitch()+x] != dat )||( num == 255 )||( x == xx - 1 ) ){
						FPUTBYTE( num, vfp );
						FPUTBYTE( dat, vfp );
						dat = ((BYTE *)sbuf->GetPixels())[y*sbuf->Pitch()+x];
						num = 1;
						fnum += 2;
					}else
						num++;
				}
				FPUTBYTE( 0, vfp );
				if( y ) FPUTBYTE( 0, vfp );
				else    FPUTBYTE( 1, vfp );
				fnum += 2;
			}
			fseek( vfp, -fnum-4, SEEK_CUR );
			FPUTDWORD( (DWORD)fnum, vfp );
			fseek( vfp, 0, SEEK_END );
		}else{			// x^̏ꍇ
			for( int y = yy - 1; y >= 0; y-- )
				fwrite( (BYTE *)sbuf->GetPixels() + sbuf->Pitch() * y, sizeof(BYTE), xx, vfp );
		}
		break;
		
	case 16:	// 16bit̏ꍇ
		for( int y = yy - 1; y >= 0; y-- ){
			WORD *src = (WORD *)sbuf->GetPixels() + sbuf->Pitch() * y/sizeof(WORD);
			for( int x=0; x < xx; x++ ){
				WORD dat = (((((*src)&sbuf->Rmask())>>sbuf->Rshift())<<sbuf->Rloss())&0xf8) << 7 |
						   (((((*src)&sbuf->Gmask())>>sbuf->Gshift())<<sbuf->Gloss())&0xf8) << 2 |
						   (((((*src)&sbuf->Bmask())>>sbuf->Bshift())<<sbuf->Bloss())&0xf8) >> 3;
				FPUTWORD( dat, vfp );
				src++;
			}
		}
		break;
		
	case 24:	// 24bit̏ꍇ
		for( int y = yy - 1; y >= 0; y-- ){
			BYTE *src = (BYTE *)sbuf->GetPixels() + sbuf->Pitch() * y;
			for( int x=0; x < xx; x++ ){
				BYTE r,g,b;
				GET3BYTE( b, g, r, src );
				FPUTBYTE( b, vfp ); FPUTBYTE( g, vfp ); FPUTBYTE( r, vfp );
			}
		}
	}
	// t[1₷
	vmh.dwTotalFrames++;
	
	// I[fBIo
	if( ABuf.ReadySize() > 0 ){
		anum += ABuf.ReadySize();
		FPUTDWORD( CID01WB, vfp );
		FPUTDWORD( ABuf.ReadySize()*2, vfp );
		while( ABuf.ReadySize() > 0 ){
			short dat = ABuf.Get();
			FPUTWORD( dat, vfp );
		}
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// I[fBIobt@擾
//
// :	Ȃ
// Ԓl:	cRing *		obt@IuWFNgւ̃|C^
////////////////////////////////////////////////////////////////
cRing *AVI6::GetAudioBuffer( void )
{
	return &ABuf;
}


////////////////////////////////////////////////////////////////
// wb_`No
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool AVI6::WriteHeader( void )
{
	if( !vfp ) return false;
	
	DWORD SIZESTRLV	= sizeof(AVISTRMHEADER6) + sizeof(BMPINFOHEADER6) + sizeof(DWORD)*5 + (ABPP==8 ? (sizeof(RGBPAL6)*256) : 0);
	DWORD SIZESTRLA	= sizeof(AVISTRMHEADER6) + sizeof(WAVEFORMATEX6)  + sizeof(DWORD)*5;
	DWORD SIZEHDRL  = SIZESTRLV + SIZESTRLA  + sizeof(MAINAVIHEADER6) + sizeof(DWORD)*7;
	DWORD SIZEJUNK  = 2048 - SIZEHDRL - sizeof(DWORD)*10;
	
	fseek( vfp, 0, SEEK_SET );
	
	fputs( "RIFF", vfp );
	FPUTDWORD( RiffSize, vfp );
		fputs( "AVI ", vfp );
			fputs( "LIST", vfp );
			FPUTDWORD( SIZEHDRL, vfp );
			fputs( "hdrl", vfp );
				fputs( "avih", vfp );
				FPUTDWORD( sizeof(MAINAVIHEADER6), vfp );
				putMAINAVIHEADER6( &vmh );
				
				// rfI
				fputs( "LIST", vfp );
				FPUTDWORD( SIZESTRLV, vfp );
				fputs( "strl", vfp );
					fputs( "strh", vfp );
					FPUTDWORD( sizeof(AVISTRMHEADER6), vfp );
					putAVISTRMHEADER6( &vsh );
					
					fputs( "strf", vfp );
					switch( ABPP ){
					case 8:		// 8bit̏ꍇ
						FPUTDWORD( sizeof(BMPINFOHEADER6) + sizeof(RGBPAL6)*256, vfp );
						putBMPINFOHEADER6( &vbf );
						fwrite( &pal, sizeof(BYTE), sizeof(RGBPAL6)*256, vfp );
						break;
						
					case 16:	// 16bit̏ꍇ
					case 24:	// 24bit̏ꍇ
						FPUTDWORD( sizeof(BMPINFOHEADER6), vfp );
						putBMPINFOHEADER6( &vbf );
					}
					
				// I[fBI
				fputs( "LIST", vfp );
				FPUTDWORD( SIZESTRLA, vfp );
				fputs( "strl", vfp );
					fputs( "strh", vfp );
					FPUTDWORD( sizeof(AVISTRMHEADER6), vfp );
					putAVISTRMHEADER6( &ash );
					
					fputs( "strf", vfp );
					FPUTDWORD( sizeof(WAVEFORMATEX6), vfp );
					putWAVEFORMATEX6( &awf );
				
			fputs( "JUNK", vfp );
			FPUTDWORD( SIZEJUNK, vfp );
			for( DWORD i=0; i<SIZEJUNK; i++ ) FPUTBYTE( 0, vfp );
			
			fputs( "LIST", vfp );
			FPUTDWORD( MoviSize, vfp );
			
			PosMOVI = ftell( vfp );
			
			fputs( "movi", vfp );
	
	fseek( vfp, 0, SEEK_END );
	
	return true;
}


////////////////////////////////////////////////////////////////
// CfbNX`No
//
// :	Ȃ
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool AVI6::WriteIndexr( void )
{
	if( !vfp ) return false;
	
	DWORD frames = vmh.dwTotalFrames * 2;
	
	fseek( vfp, 0, SEEK_END );
	
	// CfbNX`No
	fputs( "idx1", vfp );
	FPUTDWORD( sizeof(AVIINDEXENTRY6) * frames, vfp );
	DWORD ipos = 4;
	for( DWORD i=0; i<frames; i++ ){
		AVIINDEXENTRY6 idx;
		
		fseek( vfp, PosMOVI + ipos, SEEK_SET );
		idx.ckid          = FGETDWORD( vfp );
//		if( idx.ckid == CID01WB ) idx.dwFlags = 0x00000000;
//		else                      idx.dwFlags = 0x00000010;	// AVIIF_KEYFRAME
		idx.dwFlags = 0x00000010;	// AVIIF_KEYFRAME
		idx.dwChunkOffset = ipos;
		idx.dwChunkLength = FGETDWORD( vfp );
		fseek( vfp, 0, SEEK_END );
		putAVIINDEXENTRY6( &idx );
		ipos += idx.dwChunkLength + 8;
	}
	
	return true;
}
