#ifndef P6EL_H_INCLUDED
#define P6EL_H_INCLUDED

#include "typedef.h"
#include "config.h"
#include "joystick.h"
#include "movie.h"
#include "replay.h"
#include "thread.h"
#include "vsurface.h"


#define	FRAMERATE	(VSYNC_HZ/(cfg->GetFrameSkip()+1))


class VM6;
class DSP6;
class SCH6;
class cWndStat;

#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
class cWndReg;
class cWndMem;
class cWndMon;
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// G~[^C[NX
class EL6 : public cThread, public AVI6, public REPLAY {
	
	friend class VM6;
	friend class DSP6;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	friend class cWndMon;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	enum ReturnCode
	{
		Quit = 0,
		Restart,
		Dokoload,
		Replay,
		Error,
		
		EndofReturnCode
	};
	
protected:
	// IuWFNg|C^
	VM6 *vm;					// VM
	CFG6 *cfg;					// ݒIuWFNg
	SCH6 *sche;					// XPW[
	DSP6 *graph;				// ʕ`
	SND6 *snd;					// TEh
	JOY6 *joy;					// WCXeBbN
	
	cWndStat *staw;				// Xe[^Xo[
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	cWndReg *regw;				// WX^EBhE
	cWndMem *memw;				// EBhE
	cWndMon *monw;				// j^EBhE
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	HTIMERID UpDateFPSID;		// FPS\^C}ID
	
	VPalette GPal;				// pbg
	
	
	bool ScreenUpdate();								// ʍXV
	int SoundUpdate( int, cRing * = NULL );				// TEhXV
	static void StreamUpdate( void *, BYTE *, int);		// Xg[XV R[obN֐
	static DWORD UpDateFPS( DWORD, void * );			// FPS\^C} R[obN֐
	bool SetFPSTimer( int );							// FPS\^C}ݒ
	
	int UDFPSCount;				// FPS\^C}JE^
	int FSkipCount;				// t[XLbvJE^
	
	void OnThread( void * );				// Xbh֐
	
	int Emu();								// 1ߎs
	int EmuVSYNC();							// 1ʕs
	void Wait();							// Wait
	
	bool CheckFuncKey( int, bool, bool );	// e@\L[`FbN
	
	// L[͏\
	struct AKEY{
		char *Buffer;			// L[obt@|C^
		int Num;				// c蕶
		int Wait;				// ҂񐔃JE^
		bool Relay;				// [XCb`OFF҂tO
		int Seek;
		
		AKEY() : Buffer(NULL), Num(0), Wait(0), Relay(false), Seek(0) {}
	};
	AKEY ak;					// L[͏
	
	char GetAutoKey();			// L[1擾
	
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void Exec( int );						// wXe[gs
	bool ToggleMonitor();					// j^[hؑւ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	
public:
	EL6();									// RXgN^
	~EL6();									// fXgN^
	
	bool Init( const CFG6 * );				// 
	
	bool Start();							// Jn
	void Stop();							// ~
	
	
	ReturnCode EventLoop();					// Cxg[v
	
	void ShowPopupMenu( int, int );			// |bvAbvj[\
	
	bool TapeMount( char * );				// TAPE }Eg
	void TapeUnmount();						// TAPE A}Eg
	bool DiskMount( int, char * );			// DISK }Eg
	void DiskUnmount( int );				// DISK A}Eg
	
	bool ReplayStartRec( char * );			// vCۑJn
	void ReplayStopRec();					// vCۑ~
	void ReplayStartPlay( char * );			// vCĐJn
	void ReplayStopPlay();					// vCĐ~
	
	
	bool IsAutoKey();						// L[͎s?
	bool SetAutoKey( char *, int );			// L[͕ݒ
	bool SetAutoKeyFile( char * );			// L[͕ݒ(t@C)
	
	void Notify( int, int );				// ωʒm(int)
	void Notify( int, char * );				// ωʒm(char *)
	
	// ------------------------------------------
	bool DokoDemoSave( char * );	// ǂłSAVE
	bool DokoDemoLoad( char * );	// ǂłLOAD
	int GetDokoModel( char * );		// ǂłLOADt@C@햼Ǎ
	// ------------------------------------------
};


#endif		// P6EL_H_INCLUDED
