#ifndef P6T2_H_INCLUDED
#define P6T2_H_INCLUDED

#include "typedef.h"
#include "ini.h"


// P6T ubN
struct P6TBLKINFO {
	int STime;				// ̎(ms)
	int PTime;				// ҁ[̎(ms)
	int Offset;				// x^C[W擪̃ItZbg
	int DNum;				// f[^TCY
	
	P6TBLKINFO() : STime(0), PTime(0), Offset(0), DNum(0) {}
};


// DATAubNNX
class cP6DATA {
private:
	P6TBLKINFO Info;					// P6T ubN
	BYTE *Data;							// f[^ւ̃|C^
	
	cP6DATA *next;						// DATAubNւ̃|C^
	cP6DATA *before;					// ODATAubNւ̃|C^
	
	cP6DATA *TopBlock();				// 擪ubNւ̃|C^Ԃ
	cP6DATA *LastBlock();				// ubNւ̃|C^Ԃ
	
public:
	cP6DATA();							// RXgN^
	~cP6DATA();							// fXgN^
	
	cP6DATA *Next()  { return next; }	// ̃ubNւ̃|C^Ԃ
	cP6DATA *Before(){ return before; }	// ÕubNւ̃|C^Ԃ
	
	int SetData( FILE *, int );			// f[^Zbg
	void SetPeriod( int, int );			// ,ҁ[ԃZbg
	
	void GetInfo( P6TBLKINFO * );		// P6T ubN擾
	int GetSize(){ return Info.DNum; }	// DATAubNTCY擾
	
	BYTE Read( int );					// 1ByteǍ
	
	cP6DATA *New();						// VKDATAubNǉ
	cP6DATA *Clone();					// Rs[쐬
	cP6DATA *Clones();					// SRs[쐬
	
	int Writefd( FILE * );				// t@Cɏ(f[^)
};


// PARTNX
class cP6PART {
private:
	BYTE ID;								// IDԍ
	char Name[17];							// f[^(16+'00H')
	WORD Baud;								// {[[g(600/1200)
	cP6DATA *Data;							// 擪DATAubNւ̃|C^
	
	cP6PART *next;							// PARTւ̃|C^
	cP6PART *before;						// OPARTւ̃|C^
	
	cP6PART *TopPart();						// 擪PARTւ̃|C^Ԃ
	cP6PART *LastPart();					// PARTւ̃|C^Ԃ
	
	BYTE Renumber();						// IDԍio[
	
public:
	cP6PART();								// RXgN^
	~cP6PART();								// fXgN^
	
	cP6PART *Next()  { return next; }		// PARTւ̃|C^Ԃ
	cP6PART *Before(){ return before; }		// OPARTւ̃|C^Ԃ
	cP6PART *Part( int );					// CӂPARTւ̃|C^Ԃ
	
	cP6PART *New();							// VKPARTǉ
	cP6PART *Link( cP6PART * );				// PARTA
	cP6PART *Clone();						// Rs[쐬
	
	cP6DATA *FirstData(){ return Data; }	// 擪DATAubNւ̃|C^擾
	BYTE GetID()   { return ID; }			// IDԍ擾
	const char *GetName(){ return Name; }	// f[^擾
	WORD GetBaud() { return Baud; }			// {[[g擾
	
	cP6DATA *NewBlock();					// VKDATAubNǉ
	
	int GetBlocks();						// SDATAubN擾
	int GetSize();							// PARTTCY擾
	
	int SetName( const char * );			// f[^ݒ
	void SetBaud( int baud ){ Baud = baud; }	// {[[gݒ
	
	bool Readf( FILE * );					// t@CSPARTǍ
	int Writefd( FILE * );					// t@Cɏ(f[^)
	bool Writeff( FILE * );					// t@Cɏ(tb^)
};


// P6TNX
class cP6T : public IDoko {
private:
	char Name[17];							// f[^(16+'00H')
	BYTE Version;							// o[W
	
	bool Start;								// I[gX^[gtO
	BYTE BASIC;								// BASIC[h(PC-6001̏ꍇ͖Ӗ)
	BYTE Page;								// y[W
	WORD ASKey;								// I[gX^[gR}hTCY
	WORD EHead;								// gTCY(64KB܂)
	
	char *ask;								// I[gX^[gR}hi[̈ւ̃|C^
	char *exh;								// gi[̈ւ̃|C^
	
	cP6PART *Part;							// 擪PARTւ̃|C^
	
	int Boost;								// {[[g{(W1)
	
	// Ǎ݊֌W[N
	cP6PART *rpart;							// ݂̓ǍPART
	cP6DATA *rdata;							// ݂̓ǍDATAubN
	int rpt;								// ݂̓Ǎ݃|C^(DATAubN)
	int swait;								// ̑҂
	int pwait;								// ҁ[̑҂
	
	bool ReadP6T( const char * );			// P6TǍ
	bool ConvP6T( const char * );			// x^P6TɕϊēǍ
	
public:
	cP6T();									// RXgN^
	virtual ~cP6T();						// fXgN^
	
	int GetBlocks();						// SDATAubN擾
	int GetParts();							// SPART擾
	
	cP6PART *GetPart( int num ){ return Part->Part(num); }	// CPARTւ̃|C^擾
	
	int SetName( const char * );			// f[^ݒ
	char *GetName(){ return Name; }			//         擾
	bool GetStart(){ return Start; }		// I[gX^[gtO擾
	BYTE GetBASIC(){ return BASIC; }		// BASIC[h擾
	BYTE GetPage() { return Page; }			// y[W擾
	
	int GetSize();							// x^C[WTCY擾
	
	char *GetAutoStartStr(){ return ask; }	// I[gX^[g擾
	WORD GetAutoStartLen(){ return ASKey; }	// I[gX^[g擾
	
	BYTE ReadOne();							// 1Ǎ
	
	bool IsSWaiting();						// ҂?
	bool IsPWaiting();						// ҁ[҂?
	
	bool Readf( char * );					// t@CǍ
	bool Writef( char * );					// t@Cɏ
	
	int GetCount();							// TAPEJE^擾
	void SetCount( int );					//             ݒ
	
	void Reset();							// Zbg(Ǎ݊֌W[N)
	
	void SetBoost( int );					// {[[g{ݒ
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};



#endif	// P6T2_H_INCLUDED
