#ifndef P6VM_H_INCLUDED
#define P6VM_H_INCLUDED

#include "typedef.h"


class EL6;

class CPU6;
class SUB6;
class IO6;
class MEM6;
class VDG6;
class INT6;
class KEY6;
class DSK6;
class CMTL;
class CMTS;
class PSG6;
class PIO6;
class VCE6;

class BPoint;
class cSche;
class CFG6;


// {z}VNX
class VM6 {
	
	friend class EL6;
	friend class DSP6;
	
	friend class VDG6;
	friend class VDG60;
	friend class VDG62;
	friend class SUB6;
	friend class SUB60;
	friend class SUB62;
	friend class PIO6;
	friend class CPU6;
	friend class PSG6;
	friend class INT6;
	friend class VCE6;
	friend class CMTL;
	friend class DSK6;
	friend class DSK60;
	friend class DSK66;
	friend class KEY6;
	friend class cWndStat;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	friend class cWndReg;
	friend class cWndMem;
	friend class cWndMon;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
protected:
	int clock;					// CPUNbN
	
	// IuWFNg|C^
	EL6 *el;					// G~[^C
	
	cSche *evsc;				// CxgXPW[
	IO6 *iom;					// I/O(Z80)
	IO6 *ios;					// I/O(SUB CPU)
	INT6 *intr;					// 
	CPU6 *cpum;					// CPU
	SUB6 *cpus;					// SUB CPU
	MEM6 *mem;					// 
	VDG6 *vdg;					// VDG
	PSG6 *psg;					// PSG
	VCE6 *voice;				// 
	PIO6 *pio;					// 8255
	KEY6 *key;					// L[
	CMTL *cmtl;					// CMT
	CMTS *cmts;					// CMT(SAVE)
	DSK6 *disk;					// DISK
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	BPoint *bp;					// u[N|Cg
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	bool InitCommon( CFG6 * );				// ʕ
	
public:
	VM6( EL6 * );							// RXgN^
	virtual ~VM6();							// fXgN^
	
	virtual bool Init( CFG6 * ) = 0;		// 
	
	void Reset();							// Zbg
	int Emu();								// 1ߎs
	int GetCPUClock();						// CPUNbN擾
};

// PC-6001 z}VNX
class VM60 : public VM6 {
public:
	VM60( EL6 * );							// RXgN^
	~VM60();								// fXgN^
	
	bool Init( CFG6 * );					// 
};

// PC-6001mk2 z}VNX
class VM62 : public VM6 {
public:
	VM62( EL6 * );							// RXgN^
	~VM62();								// fXgN^
	
	bool Init( CFG6 * );					// 
};

// PC-6601 z}VNX
class VM66 : public VM6 {
public:
	VM66( EL6 * );							// RXgN^
	~VM66();								// fXgN^
	
	bool Init( CFG6 * );					// 
};

#endif		// P6VM_H_INCLUDED
