#ifndef SCHEDULE_H_INCLUDED
#define SCHEDULE_H_INCLUDED

#include "typedef.h"

#include "device.h"
#include "ini.h"
#include "p6device.h"
#include "thread.h"


// őCxg
#define	MAXEVENT	(32)

// CxgX^CtO
// bit0: JԂw
#define	EV_ONETIME	(0x00)	/* ^C */
#define	EV_LOOP		(0x01)	/* [v */
// bit1,2: wP
#define	EV_HZ		(0x00)	/* Hz */
#define	EV_US		(0x02)	/* us */
#define	EV_MS		(0x04)	/* ms */
#define	EV_STATE	(0x08)	/* CPUXe[g */


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cSche : public IDoko {
public:
	// Cxg\
	struct evinfo {
		P6DEVICE* device;	// CxgfoCXIuWFNg|C^
		int id;				// CxgID
		bool Active;		// CxgLtO true:L false:~
		int Period;			// 1̃NbN
		int Clock;			// cNbN
		double nps;			// Cxgg(Hz)
		
		evinfo () : device(NULL), id(0), Active(false), Period(0), Clock(0), nps(0) {}
	};
	
protected:
	evinfo ev[MAXEVENT];	// Cxg
	
	bool VSYNC;				// VSYNCtO true:VSYNCɒB false:BĂȂ
	
	int MasterClock;		// }X^NbN({IɂCPUXe[g/bɂȂ͂)
	int NextEvent;			// ̃Cxg܂ł̃NbN
	int SaveClock;			// NbN𗭂ߍ
	
	evinfo *Find( P6DEVICE *, int );			// Cxg
	void SetMasterClock( int );					// }X^NbNݒ
	
public:
	cSche( int );								// RXgN^
	virtual ~cSche();							// fXgN^
	
	bool Add( P6DEVICE *, int, double, int );	// Cxgǉ
	bool Del( P6DEVICE *, int );				// Cxg폜
	
	bool SetHz( P6DEVICE *, int, double );		// Cxggݒ
	
	void Update( int );							// CxgXV
	void Reset( P6DEVICE *, int, double=0 );	// wCxgZbg
	
	int Rest( P6DEVICE *, int );				// Cxg܂ł̎cNbN߂
	double Scale( P6DEVICE *, int );			// Cxg̐is߂
	
	bool GetEvinfo( evinfo * );					// Cxg擾
	bool SetEvinfo( evinfo * );					// Cxgݒ
	
	int GetMasterClock();						// }X^[NbN擾
	
	bool IsVSYNC();								// VSYNCɒB?
	void OnVSYNC();								// VSYNCʒm
	void ReVSYNC();								// VSYNCtOLZ
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

class SCH6 : public cThread, public cSemaphore {
protected:
	bool WaitEnable;		// WaitLtO
	int EnableScrUpdate;	// ʍXVtO
	
	// xvZp
	int MasterClock;		// }X^NbN
	DWORD WRClock;			// NbNۑ(v)
	DWORD WRClockTmp;		// NbNۑ(v)
	
	void OnThread( void * );					// Xbh֐
	
public:
	SCH6( int );								// RXgN^
	virtual ~SCH6();							// fXgN^
	
//	void CalcCpuState();						// ʂ̕\ԂɉCPUXe[gvZ
	
	bool Start();								// Jn
	void Stop();								// ~
	
	bool GetWaitEnable();						// WaitLtO擾
	void SetWaitEnable( bool );					// WaitLtOݒ
	
	void VWait();								// VSYNC Wait
	void WaitReset();							// Wait
	
	void Update( int );							// CxgXV
	int GetRatio();								// sx擾
	
	bool IsScreenUpdate();						// ʍXV}?
};

#endif	// SCHEDULE_H_INCLUDED
