#include <new>
#include <memory.h>

#include "pc6001v.h"
#include "log.h"
#include "sound.h"
#include "error.h"
#include "osd.h"



// obt@TCY̔{
#define	MULTI		(2)
//   Iɂ̓TCYMULTI{邪ΊOIɂ͓{̂悤ɐU
//   ǂݏ͑S̈ɑ΂čsȂ邪TCY擾͓{
//   ܂I[o[t[h~X|XۂĂ...͂

////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cRing::cRing( void ) : Buffer(NULL), Size(0), Wpt(0), Rpt(0), Num(0) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cRing::~cRing( void )
{
	if( Buffer ) delete [] Buffer;
}


////////////////////////////////////////////////////////////////
// obt@
//
// :	size		Tv
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool cRing::InitBuffer( int size )
{
	PRINTD( SND_LOG, "[cRing][Init] Size:%d\n", size );
	
	if( Buffer ) delete [] Buffer;
	
	Size = size * MULTI;	// ۂ̃obt@TCYMULTI{
	Wpt = Rpt = Num = 0;
	
	try{
		Buffer = new int[Size];
		memset( Buffer, 0, Size );
	}
	// new Ɏsꍇ
	catch( std::bad_alloc ){
		Error::SetError( Error::MemAllocFailed );
		return false;
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// Ǎ
//
// :	Ȃ
// Ԓl:	int		f[^
////////////////////////////////////////////////////////////////
int cRing::Get( void )
{
	if( Num ){
		cCritical::Lock();
		int data = Buffer[Rpt++];
		if( Rpt == Size ) Rpt = 0;
		Num--;
		cCritical::UnLock();
		return data;
	}else{
		return 0;
	}
}


////////////////////////////////////////////////////////////////
// 
//
// :	data		f[^
// Ԓl:	bool		true: false:s(obt@ς)
////////////////////////////////////////////////////////////////
bool cRing::Put( int data )
{
	if( Num < Size ){
		cCritical::Lock();
		Buffer[Wpt++] = data;
		if( Wpt == Size ) Wpt = 0;
		Num++;
		cCritical::UnLock();
		return true;
	}else
		return false;
}


////////////////////////////////////////////////////////////////
// ǃf[^擾
//
// :	Ȃ
// Ԓl:	int			ǃTv
////////////////////////////////////////////////////////////////
int cRing::ReadySize( void )
{
	return Num;
}


////////////////////////////////////////////////////////////////
// cobt@擾
//
// :	Ȃ
// Ԓl:	int			cobt@Tv
////////////////////////////////////////////////////////////////
int cRing::FreeSize( void )
{
	return Size - Num;
}


////////////////////////////////////////////////////////////////
// obt@TCY擾
//
// :	Ȃ
// Ԓl:	int			Sobt@Tv
////////////////////////////////////////////////////////////////
int cRing::GetSize( void )
{
	return Size;
}




////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
SndDev::SndDev( void ) : SampleRate(DEFAULT_SAMPLE_RATE),
							Volume(0), LPF_Mem(0), LPF_fc(0) {}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
SndDev::~SndDev( void ){}


////////////////////////////////////////////////////////////////
// 
// :	rate	TvO[g
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool SndDev::Init( int rate )
{
	SampleRate = rate;
	
	return true;
}


////////////////////////////////////////////////////////////////
// [pXtB^ JbgItgݒ
//
// :	fc		JbgItg
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SndDev::SetLPF( int fc )
{
	LPF_fc = fc;
}


////////////////////////////////////////////////////////////////
// [pXtB^
//
// [Ql] ̃fBW^tB^
// http://kmkz.jp/mtm/mag/lab/digitalfilter.htm
//
// :	src		f[^
// Ԓl:	int		tB^Kp̃f[^
////////////////////////////////////////////////////////////////
int SndDev::LPF( int src )
{
	int lpf_k = LPF_fc ? (int)((2.0*M_PI*(double)LPF_fc*(double)0x8000)/(double)SampleRate) : 0x8000;
	
	LPF_Mem += ( ( src - LPF_Mem ) * lpf_k ) / 0x8000;
	return LPF_Mem;
}


////////////////////////////////////////////////////////////////
// Ǎ(I[o[Ch)
//
// :	Ȃ
// Ԓl:	int		f[^
////////////////////////////////////////////////////////////////
int SndDev::Get( void )
{
	return LPF( this->cRing::Get() );
}


////////////////////////////////////////////////////////////////
// TvO[gݒ
//
// :	rate	TvO[g
//			size	obt@TCY
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool SndDev::SetSampleRate( int rate, int size )
{
	if( SampleRate == rate ) return false;
	
	SampleRate = rate;
	
	if( !InitBuffer( size ) ) return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// ʐݒ
//
// :	vol		(0-100)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SndDev::SetVolume( int vol )
{
	Volume = min( max( vol, 0 ), 100 );
}


////////////////////////////////////////////////////////////////
// Xg[XV
//
// :	samples	VTv
// Ԓl:	int		XVTv
////////////////////////////////////////////////////////////////
int SndDev::SoundUpdate( int samples )
{
	return 0;
}




////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
SND6::SND6( void ) : Volume(DEFAULT_MASTERVOL), SampleRate(DEFAULT_SAMPLE_RATE), BSize(SOUND_BUFFER_SIZE),
						CbFunc(NULL), CbData(NULL)
{
	INITARRAY( RB, NULL );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
SND6::~SND6( void )
{
	Pause();
	// I[fBIfoCX
	OSD_CloseAudio();
}


////////////////////////////////////////////////////////////////
// 
//
// :	cbdata		R[obN֐ɓnf[^
//			callback	R[obN֐ւ̃|C^
//			rate		TvO[g
//			size		obt@TCY({)
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool SND6::Init( void *cbdata, void (*callback)(void *, BYTE *, int ), int rate, int size )
{
	PRINTD( SND_LOG, "[SND6][Init]\n" );
	
	for( int i=0; i<MAXSTREAM; i++ ) RB[i] = NULL;
	
	// obt@TCY(Tv)
	int samples = rate * size / VSYNC_HZ;
	
	// obt@
	if( !this->cRing::InitBuffer( samples ) ) return false;
	
	// I[fBIfoCXJ
	if( !OSD_OpenAudio( cbdata, callback, rate, samples ) ) return false;
	
	CbData     = cbdata;
	CbFunc     = callback;
	SampleRate = rate;
	BSize      = size;
	
	PRINTD( SND_LOG, " SampleRate : %d\n", rate );
	PRINTD( SND_LOG, " BufferSize : %d\n", samples );
	
	return true;
}


////////////////////////////////////////////////////////////////
// Xg[ڑ
//
// :	SndDev *	obt@|C^
// Ԓl:	bool		true: false:s
////////////////////////////////////////////////////////////////
bool SND6::ConnectStream( SndDev *buf )
{
	PRINTD( SND_LOG, "[SND6][ConnectStream]\n" );
	
	if( !buf ) return false;
	
	// obt@TCY(Tv)
	int samples = SampleRate * BSize / VSYNC_HZ;
	
	for( int i=0; i<MAXSTREAM; i++ ){
		if( !RB[i] ){
			// obt@
			if( !buf->InitBuffer( samples ) ) return false;
			RB[i] = buf;
			return true;
		}
	}
	
	return false;
}


////////////////////////////////////////////////////////////////
// Đ
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SND6::Play( void )
{
	PRINTD( SND_LOG, "[SND6][Play]\n" );
	
	OSD_StartAudio();
}


////////////////////////////////////////////////////////////////
// ~
//
// :	Ȃ
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SND6::Pause( void )
{
	PRINTD( SND_LOG, "[SND6][Pause]\n" );
	
	OSD_StopAudio();
}


////////////////////////////////////////////////////////////////
// TvO[gݒ
//
// :	rate	TvO[g
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool SND6::SetSampleRate( int rate )
{
//	if( SampleRate == rate ) return false;
	
	SampleRate = rate;
	
	bool pflag = OSD_AudioPlaying();
	OSD_CloseAudio();
	
	// obt@TCY(Tv)
	int samples = rate * BSize / VSYNC_HZ;
	
	// obt@
	if( !this->cRing::InitBuffer( samples ) ) return false;
	
	for( int i=0; i<MAXSTREAM; i++ )
		if( RB[i] && !RB[i]->SetSampleRate( rate, samples ) ) return false;
	
	// I[fBIfoCXJ
	if( !OSD_OpenAudio( CbData, CbFunc, rate, samples ) ) return false;
	if( pflag ) Play();
	
	return true;
}


////////////////////////////////////////////////////////////////
// TvO[g擾
//
// :	Ȃ
// Ԓl:	int		TvO[g
////////////////////////////////////////////////////////////////
int SND6::GetSampleRate( void )
{
	return SampleRate;
}


////////////////////////////////////////////////////////////////
// }X^[ʐݒ
//
// :	vol		(0-100)
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SND6::SetVolume( int vol )
{
	Volume = min( max( vol, 0 ), 100 );
}


////////////////////////////////////////////////////////////////
// TEhOXV֐
//
// :	samples		Tv
//			exbuf		Oobt@|C^
// Ԓl:	int			XVTv
////////////////////////////////////////////////////////////////
int SND6::PreUpdate( int samples, cRing *exbuf )
{
	int exsam = 0;
	
	PRINTD( SND_LOG,"PreUpdate %d %d %d \n", RB[0]->ReadySize(), RB[1]->ReadySize(), RB[2]->ReadySize() );
	
	for( int i=0; i<MAXSTREAM; i++ )
		if( RB[i] ) exsam = min( max( exsam, RB[i]->ReadySize() ), samples );
	
	for( int i=0; i<exsam; i++ ){
		int dat = 0;
		for( int j=0; j<MAXSTREAM; j++ )
			if( RB[j] ) dat += RB[j]->Get();
		
		dat = ( dat * Volume ) / 100;
		dat = min( max( dat, INT16_MIN ), INT16_MAX );
		
		this->cRing::Put( (int16_t)dat );
		// Oobt@݂Ώ
		if( exbuf ) exbuf->Put( (int16_t)dat );
	}
	
	return exsam;
}


////////////////////////////////////////////////////////////////
// TEhXV֐
//
// :	stream		Xg[݃obt@ւ̃|C^
//			samples		Tv
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void SND6::Update( BYTE *stream, int samples )
{
	int16_t *str = (int16_t *)stream;
	
	PRINTD( SND_LOG, "[SND6][Update] Stream:%p Samples:%d / %d\n", stream, samples, this->cRing::ReadySize() );
	
	for( int i=0; i<samples; i++ ){
		*(str++) = (int16_t)this->cRing::Get();
	}
}
