#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "p6t2.h"
#include "sound.h"
#include "p6device.h"


// f[^̎
#define PG_P	(0x0000)
#define PG_S	(0x0100)
#define PG_D	(0x0200)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class CMTL : public P6DEVICE, public Device, public SndDev, public IDoko {
private:
	char FilePath[PATH_MAX];	// TAPEt@CtpX
	cP6T *p6t;
	bool Relay;					// [̏
	
	bool Boost;					// BoostUpg? true:g false:gȂ
	int MaxBoost60;				// BoostUp ő{(N60[h)
	int MaxBoost62;				// BoostUp ő{(N60m/N66[h)
	
	bool Remote( bool );			// [g(PLAY,STOP)
	WORD CmtRead();					// CMT 1Ǎ
	int GetSinCurve( int );			// sing擾
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	
public:
	CMTL( VM6 *, const ID& );		// RXgN^
	virtual ~CMTL();				// fXgN^
	
	void EventCallback( int, int );	// CxgR[obN֐
	
	bool Init( int );				// 
	void Reset();					// Zbg
	
	void SetAutoStart( int );		// I[gX^[gݒ
	
	bool Mount( char * );			// TAPE }Eg
	void Unmount();					// TAPE A}Eg
	
	WORD Update();					// Xg[XV(1byte)
	int SoundUpdate( int );			// Xg[XV
	
	bool IsMount();					// }Egς?
	bool IsAutoStart();				// I[gX^[g?
	
	char *GetFile();				// t@CpX擾
	char *GetName();				// TAPE擾
	DWORD GetSize();				// x^C[WTCY擾
	int GetCount();					// JE^擾
	bool IsRelay();					// [̏Ԏ擾
	
	void SetBoost( bool );			// BoostUpݒ
	void SetMaxBoost( int, int );	// BoostUpő{ݒ
	bool IsBoostUp();				// BoostUpԎ擾
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	bool DokoSave( cIni * );		// ǂłSAVE
	bool DokoLoad( cIni * );		// ǂłLOAD
	// ------------------------------------------
};


class CMTS : public P6DEVICE {
private:
	char FilePath[PATH_MAX];		// TAPEt@CtpX
	
	FILE *fp;						// FILE |C^
	int Baud;						// {[[g
	
public:
	CMTS( VM6 *, const P6ID& );		// RXgN^
	~CMTS();						// fXgN^
	
	bool Init( char * );			// 
	
	bool Mount();					// TAPE }Eg
	void Unmount();					// TAPE A}Eg
	
	void SetBaud( int );			// {[[gݒ
	
	void CmtWrite( BYTE );			// CMT 1
};


#endif	// TAPE_H_INCLUDED
