#include <string.h>

#include "p6el.h"




#include "pc6001v.h"
#include "log.h"
#include "voice.h"
#include "osd.h"
#include "schedule.h"


// CxgID
#define	EID_FRAME	(1)



////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
VCE6::VCE6( VM6 *vm, const ID& id ) : P6DEVICE(vm,id), Device(id),
	io_E0H(0), io_E2H(0), io_E3H(0), VStat(D7752E_IDL),
	IVLen(0), IVBuf(NULL), IVPos(0), Pnum(0), Fnum(0), PReady(false), Fbuf(NULL)
{
	INITARRAY( FilePath, '\0' );
	INITARRAY( ParaBuf, 0 );
	SndDev::Volume = DEFAULT_VOICEVOL;
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
VCE6::~VCE6()
{
	FreeVoice();
	if( Fbuf ) delete [] Fbuf;
}


////////////////////////////////////////////////////////////////
// CxgR[obN֐
//
// :	id		CxgID
//			clock	NbN
// Ԓl:	Ȃ
////////////////////////////////////////////////////////////////
void VCE6::EventCallback( int id, int clock )
{
	PRINTD( VOI_LOG, "[VOICE][EventCallback] -> " );
	
	switch( id ){
	case EID_FRAME:	// 1t[
		if( VStat & D7752E_EXT ){	// O唭
			PRINTD( VOI_LOG, "(EXT)\n" );
			if( PReady ){	// p[^ZbgĂ?
				// t[=0ȂΏI
				if( !(ParaBuf[0]>>3) )
					AbortVoice();
				else{
					// 1t[̃Tv
					cD7752::Synth(	ParaBuf, Fbuf );
					
					// TvO[gϊăobt@ɏ
					UpConvert();
					
					// t[̃p[^󂯕t
					PReady = false;
					VStat |= D7752E_REQ;
				}
			}else{			// ĂȂ΃G[
				AbortVoice();		// ~
				VStat = D7752E_ERR;	// Xe[^XG[ɃZbg
			}
		}else{						// 唭
			PRINTD( VOI_LOG, "(INT) " );
			// 1t[̃Tvobt@ɏ
			int num = min( IVLen - IVPos, cD7752::GetFrameSize() * SndDev::SampleRate / 10000 );
			PRINTD( VOI_LOG, "%d/%d\n", num, IVPos );
			while( num-- )
				SndDev::cRing::Put( ( IVBuf[IVPos++] * SndDev::Volume ) / 100 );
			if( IVPos >= IVLen ){	// Ō܂Ŕ甭I
				AbortVoice();
			}
		}
		
		break;
	}
}


////////////////////////////////////////////////////////////////
// [hZbg
////////////////////////////////////////////////////////////////
void VCE6::VSetMode( BYTE mode )
{
	PRINTD( VOI_LOG, "[VOICE][VSetMode]    %02X %dms", mode, (((mode>>2)&1)+1)*10 );
	PRINTD( VOI_LOG, " %s\n", mode&1 && mode&2 ? "X" : mode&1 ? "SLOW" : mode&2 ? "FAST" : "NORMAL" );
	
	// Jn
	cD7752::Start( mode );
	
	// Xe[^XNA
	VStat = D7752E_IDL;
}


////////////////////////////////////////////////////////////////
// R}hZbg
////////////////////////////////////////////////////////////////
void VCE6::VSetCommand( BYTE comm )
{
	PRINTD( VOI_LOG, "[VOICE][VSetCommand] %02X\n", comm );
	
	// Ȃ~߂
	AbortVoice();
	
	switch( comm ){
	case 0x00:		// IR}h ----------
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
		// WAVt@CǍ
		if( !LoadVoice( comm ) ) break;
		
		// Xe[^XĐ[hɃZbg
		VStat = D7752E_BSY;
		
		// t[CxgZbg
		vm->evsc->Add( this, EID_FRAME, 10000.0/(double)cD7752::GetFrameSize(), EV_LOOP|EV_HZ );
		
		break;
		
	case 0xfe:		// OIR}h ----------
		// t[obt@m
		Fbuf = new D7752_SAMPLE[cD7752::GetFrameSize()];
		if( !Fbuf ) break;
		
		// Xe[^XOĐ[hɃZbgCp[^tJn
		VStat = D7752E_BSY | D7752E_EXT | D7752E_REQ;
		
		// t[CxgZbg
		vm->evsc->Add( this, EID_FRAME, 10000.0/(double)cD7752::GetFrameSize(), EV_LOOP|EV_HZ );
		
		break;
		
	case 0xff:		// XgbvR}h ----------
		break;
		
	default:		// R}h  ----------
		VStat = D7752E_ERR;	// zg?
		break;
	}
}


////////////////////////////////////////////////////////////////
// p[^]
////////////////////////////////////////////////////////////////
void VCE6::VSetData( BYTE data )
{
	PRINTD( VOI_LOG, "[VOICE][VSetData]    %02X\n", data );
	
	// Đ̂݃f[^󂯕t
	if(	(VStat & D7752E_BSY)&&(VStat & D7752E_REQ) ){
		if( Fnum == 0 || Pnum ){	// ŏ̃t[?
			// ŏ̃p[^JԂݒ
			if( Pnum == 0 ) Fnum = data>>3;
			// p[^obt@ɕۑ
			ParaBuf[Pnum++] = data;
			// 1t[̃p[^܂甭
			if( Pnum == 7 ){
				VStat &= ~D7752E_REQ;
				Pnum = 0;
				if( Fnum > 0 ) Fnum--;
				PReady = true;
			}
		}else{						// JԂt[?
			// p[^obt@ɕۑ
			// PD7752̎dlɍ킹
			for( int i=1; i<6; i++ ) ParaBuf[i] = 0;
			ParaBuf[6] = data;
			VStat &= ~D7752E_REQ;
			Pnum = 0;
			Fnum--;
			PReady = true;
		}
	}
}


////////////////////////////////////////////////////////////////
// Xe[^XWX^擾
////////////////////////////////////////////////////////////////
int VCE6::VGetStatus( void )
{
	return VStat;
}


////////////////////////////////////////////////////////////////
// ~
////////////////////////////////////////////////////////////////
void VCE6::AbortVoice( void )
{
	PRINTD( VOI_LOG, "[VOICE][AbortVoice]\n" );
	
	// t[Cxg~
	vm->evsc->Del( this, EID_FRAME );
	
	// c̃p[^̓LZ
	Pnum = Fnum = 0;
	PReady = false;
	
	// t[obt@J
	if( Fbuf ){
		delete [] Fbuf;
		Fbuf = NULL;
	}
	
	// WAVJ
	FreeVoice();
	
	VStat &= ~D7752E_BSY;
}


////////////////////////////////////////////////////////////////
// TvO[gϊ
////////////////////////////////////////////////////////////////
void VCE6::UpConvert( void )
{
	PRINTD( VOI_LOG, "[VOICE][UpConvert]\n" );
	
	// 10kHz -> ۂɍĐTvO[gɕϊ̃Tv
	int samples = cD7752::GetFrameSize() * SndDev::SampleRate / 10000;
	PRINTD( VOI_LOG, "UpConvert %d \n", samples );
	
	for( int i=0; i<samples; i++ ){
		int dat = Fbuf[i * cD7752::GetFrameSize() / samples] * 4;	// * 4  16bit<-14bit ̂
//		SndDev::cRing::Put( ( dat * SndDev::Volume ) / 100 );
		SndDev::cRing::Put( ( dat * SndDev::Volume * 2 ) / 100 );		// o̓xႢ̂łƂ肠2{
	}
	PRINTD( VOI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// WAVǍ
////////////////////////////////////////////////////////////////
bool VCE6::LoadVoice( int index )
{
	PRINTD( VOI_LOG, "[VOICE][LoadVoice]  No.%d -> ", index );
	
	DWORD len;		// f[^TCY
	BYTE *buf;		// f[^obt@
	int freq;		// f[^TvO[g
	
	// WAVt@CǍ
	char filepath[PATH_MAX];
	sprintf( filepath, "%sf4%d.wav", FilePath, index );
	
	PRINTD( VOI_LOG, "%s ->", filepath );
	
	if( !OSD_LoadWAV( filepath, &buf, &len, &freq ) ){
		PRINTD( VOI_LOG, "Error!\n" );
		return false;
	}
	
	PRINTD( VOI_LOG, "OK\n" );
	
	// xϊ̃TCYvZăobt@m
	// x4̎,1t[̃Tv160
	IVLen = (int)( (double)SndDev::SampleRate * (double)(len/2) / (double)freq
					* (double)cD7752::GetFrameSize() / (double)160 );
	
	PRINTD( VOI_LOG, "Len:%d/%d ->", IVLen, (int)len );
	
	IVBuf = new int[IVLen];
	if( !IVBuf ){
		OSD_FreeWAV( buf );
		IVLen = 0;
		return false;
	}
	
	// xϊ
	// PȂԈȂ̂Ńsb`ςĂ܂̂
	// FFTg?
	signed short *sbuf = (signed short *)buf;
	for( int i=0; i<IVLen; i++ ){
		IVBuf[i] = sbuf[(int)(( (double)i * (double)(len/2) ) / (double)IVLen)];
	}
	
	// WAVJ
	OSD_FreeWAV( buf );
	
	// Ǎ݃|C^
	IVPos = 0;
	
	return true;
}


////////////////////////////////////////////////////////////////
// WAVJ
////////////////////////////////////////////////////////////////
void VCE6::FreeVoice( void )
{
	if( IVBuf ){
		delete [] IVBuf;
		IVBuf = NULL;
		IVLen = IVPos= 0;
	}
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
bool VCE6::Init( int srate, char *path )
{
	PRINTD( VOI_LOG, "[VOICE][Init] BufferSize:" );
	
	// WAVEt@Ci[pXۑ
	strncpy( FilePath, path, PATH_MAX );
	
	PRINTD( VOI_LOG, ":%d\n", SndDev::cRing::GetSize() );
	
	return SndDev::Init( srate );
}


////////////////////////////////////////////////////////////////
// Zbg
////////////////////////////////////////////////////////////////
void VCE6::Reset( void )
{
	AbortVoice();
	VStat = D7752E_IDL;
}


////////////////////////////////////////////////////////////////
// Xg[XV
//
// :	samples	XVTv(-1:cobt@S 0:NbN)
// Ԓl:	int		XVTv
////////////////////////////////////////////////////////////////
int VCE6::SoundUpdate( int samples )
{
	PRINTD( VOI_LOG, "[VOICE][SoundUpdate] Samples: %d(%d)", samples, SndDev::cRing::FreeSize() );
	
	int length = 0;
	
	if( samples == 0 ){
		// Ƃ
	}else if( samples > 0 ) length = min( samples - SndDev::cRing::ReadySize(), SndDev::cRing::FreeSize() );
	else                    length = SndDev::cRing::FreeSize();
	
	PRINTD( VOI_LOG, " -> %d\n", length );
	
	if( !length ) return 0;
	
	
	for( int i=0; i<length; i++ ){
		// obt@ɏ
		SndDev::cRing::Put( 0 );	// 蔲
	}
	
	return length;
}


////////////////////////////////////////////////////////////////
// I/OANZX֐
////////////////////////////////////////////////////////////////
inline void VCE6::OutE0H( int, BYTE data ){ VSetData( data ); }
inline void VCE6::OutE2H( int, BYTE data ){ VSetMode( data ); }
inline void VCE6::OutE3H( int, BYTE data ){ VSetCommand( data ); }
inline BYTE VCE6::InE0H( int ){ return VGetStatus(); }
inline BYTE VCE6::InE2H( int ){ return io_E2H; }
inline BYTE VCE6::InE3H( int ){ return io_E3H; }


////////////////////////////////////////////////////////////////
// ǂłSAVE
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool VCE6::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return false;
	
	Ini->PutEntry( "VOICE", NULL, "io_E0H",		"0x%02X",	io_E0H );
	Ini->PutEntry( "VOICE", NULL, "io_E2H",		"0x%02X",	io_E2H );
	Ini->PutEntry( "VOICE", NULL, "io_E3H",		"0x%02X",	io_E3H );
	Ini->PutEntry( "VOICE", NULL, "VStat",		"%d",		VStat );
	
	// ֌W
//	int IVLen;						// Tv
//	int *IVBuf;						// f[^obt@
//	int IVPos;						// Ǎ݃|C^
	
	Ini->PutEntry( "VOICE", NULL, "ParaBuf0",	"0x%02X",	ParaBuf[0] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf1",	"0x%02X",	ParaBuf[1] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf2",	"0x%02X",	ParaBuf[2] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf3",	"0x%02X",	ParaBuf[3] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf4",	"0x%02X",	ParaBuf[4] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf5",	"0x%02X",	ParaBuf[5] );
	Ini->PutEntry( "VOICE", NULL, "ParaBuf6",	"0x%02X",	ParaBuf[6] );
	Ini->PutEntry( "VOICE", NULL, "Pnum",		"%d",		Pnum );
	Ini->PutEntry( "VOICE", NULL, "Fnum",		"%d",		Fnum );
	Ini->PutEntry( "VOICE", NULL, "PReady",		"%s",		PReady ? "Yes" : "No" );
	
//	D7752_SAMPLE *Fbuf;				// t[obt@|C^(10kHz 1t[)
	
	// Cxg
	e.id = EID_FRAME;
	if( vm->evsc->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "VOICE", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
// ǂłLOAD
//
// :	Ini		INIIuWFNg|C^
// Ԓl:	bool	true: false:s
////////////////////////////////////////////////////////////////
bool VCE6::DokoLoad( cIni *Ini )
{
	int st;
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return false;
	
	Ini->GetInt(   "VOICE", "io_E0H",		&st,		io_E0H );	io_E0H = st;
	Ini->GetInt(   "VOICE", "io_E2H",		&st,		io_E2H );	io_E2H = st;
	Ini->GetInt(   "VOICE", "io_E3H",		&st,		io_E3H );	io_E3H = st;
	Ini->GetInt(   "VOICE", "VStat",		&VStat,		VStat );
	
	// ֌W(Ƃ肠)
	FreeVoice();
	
	Ini->GetInt(   "VOICE", "ParaBuf0",		&st,		ParaBuf[0] );	ParaBuf[0] = st;
	Ini->GetInt(   "VOICE", "ParaBuf1",		&st,		ParaBuf[1] );	ParaBuf[1] = st;
	Ini->GetInt(   "VOICE", "ParaBuf2",		&st,		ParaBuf[2] );	ParaBuf[2] = st;
	Ini->GetInt(   "VOICE", "ParaBuf3",		&st,		ParaBuf[3] );	ParaBuf[3] = st;
	Ini->GetInt(   "VOICE", "ParaBuf4",		&st,		ParaBuf[4] );	ParaBuf[4] = st;
	Ini->GetInt(   "VOICE", "ParaBuf5",		&st,		ParaBuf[5] );	ParaBuf[5] = st;
	Ini->GetInt(   "VOICE", "ParaBuf6",		&st,		ParaBuf[6] );	ParaBuf[6] = st;
	Ini->GetInt(   "VOICE", "Pnum",			&Pnum,		Pnum );
	Ini->GetInt(   "VOICE", "Fnum",			&Fnum,		Fnum );
	Ini->GetTruth( "VOICE", "PReady",		&PReady,	PReady );
	
//	D7752_SAMPLE *Fbuf;				// t[obt@|C^(10kHz 1t[)
	
	// Cxg
	e.id = EID_FRAME;
	if( vm->evsc->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "VOICE", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	return true;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor VCE6::descriptor = {
	VCE6::indef, VCE6::outdef
};

const Device::OutFuncPtr VCE6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE0H ),
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE2H ),
	STATIC_CAST( Device::OutFuncPtr, &VCE6::OutE3H )
};

const Device::InFuncPtr VCE6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE0H ),
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE2H ),
	STATIC_CAST( Device::InFuncPtr, &VCE6::InE3H )
};
