#ifndef VOICE_H_INCLUDED
#define VOICE_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "sound.h"
#include "p6device.h"
#include "device/pd7752.h"

// [OUT]
//  E0H : p[^]
//  E1H : ?
//  E2H : [hZbg : 0 0 0 0 F S1 S0
//			F     : ̓t[ 0: 10ms/t[
//									 1: 20ms/t[
//			S1,S0 : xBIT     00: NORMAL SPEED
//									01: SLOW SPEED
//									10: FAST SPEED
//									11: ֎~

//  E3H : R}hZbg
//		EIR}h : 0  0 P5 P4 P3 P2 P1 P0
//			P5-P0 : Irbg(0-63)
//		EXgbvR}h   : 1  1  1  1  1  1  1  1
//		EOIR}h : 1  1  1  1  1  1  1  0
//

// [IN]
//  E0H : Xe[^XWX^ : BSY REQ ~INT/EXT ERR 0 0 0 0
//			BSY      :  1: 0:~
//			REQ      : p[^ 1:͗v 0:֎~
//			~INT/EXT : bZ[Wf[^ 1:O 0:
//			ERR      : G[tO 1:G[ 0:G[Ȃ
//  E1H : ?
//  E2H : PortE2ɏ񂾒l?
//  E3H : PortE3ɏ񂾒l?


// ^C~OɊւ鋓
// [{̃XybN]
// ER}hs1t[ڂ̃p[^͊܂2msȓ(NORMAL SPEED)
//   y^zR}hsREQ܂ł̎Ԃ?
// Et[ōŏREQSp[^͂܂3/4t[Ԉȓ
//   yl@z͊甭܂ł1/4t[ԈȓŊmɏ?
//   y^zREQ܂ł̎Ԃ?
//
// [XybN]
// ER}hs1t[ڂ̃p[^͊܂1t[Ԉȓ
// E1t[Ԍoߎ_Ŕ(1t[̃Tv)CREQ=1
// E玟t[̃p[^͊܂1t[Ԉȓ


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class VCE6 : public P6DEVICE, public Device, public cD7752, public SndDev, public IDoko {
private:
	char FilePath[PATH_MAX];		// WAVEt@Ci[pX
	
	BYTE io_E0H;
	BYTE io_E2H;
	BYTE io_E3H;
	
	int VStat;						// Xe[^X
	
	// ֌W
	int IVLen;						// Tv
	int *IVBuf;						// f[^obt@
	int IVPos;						// Ǎ݃|C^
	
	// p[^obt@(1t[̃p[^7)
	BYTE ParaBuf[7];				// p[^obt@
	int	Pnum;						// p[^
	int Fnum;						// JԂt[
	bool PReady;					// p[^Zbg
	
	D7752_SAMPLE *Fbuf;				// t[obt@|C^(10kHz 1t[)
	
	void VSetMode( BYTE );			// [hZbg
	void VSetCommand( BYTE );		// R}hZbg
	void VSetData( BYTE );			// p[^]
	int VGetStatus();				// Xe[^XWX^擾
	void AbortVoice();				// ~
	void UpConvert();				// TvO[gϊ
	bool LoadVoice( int );			// WAVǍ
	void FreeVoice();				// WAVJ
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutE0H( int, BYTE );
	void OutE2H( int, BYTE );
	void OutE3H( int, BYTE );
	BYTE InE0H( int );
	BYTE InE2H( int );
	BYTE InE3H( int );
	
public:
	VCE6( VM6 *, const ID& );		// RXgN^
	~VCE6();						// fXgN^
	
	void EventCallback( int, int );	// CxgR[obN֐
	
	bool Init( int, char * );		// 
	void Reset( void );				// Zbg
	
	int SoundUpdate( int );			// Xg[XV
	
	// foCXID
	enum IDOut{ outE0H=0, outE2H, outE3H };
	enum IDIn {  inE0H=0,  inE2H,  inE3H };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// VOICE_H_INCLUDED
