#ifndef VSURFACE_H_INCLUDED
#define VSURFACE_H_INCLUDED


// T[tFX̎dl
//  F[x8,16,24bit
//  8bit̎̂݃pbg
//  1C̃TCY4byte(DWORD)̔{Ƃ
//  őTCY65536x65536


struct COLOR24 {
	BYTE r;
	BYTE g;
	BYTE b;
	BYTE reserved;
};

// `̈\
struct VRect{
	int x, y;		// `̈W
	int w, h;		// `̈TCY
	
	VRect() : x(0), y(0), w(0), h(0) {}
};

struct VPalette{
	int ncols;
	COLOR24 *colors;
	
	VPalette() : ncols(0), colors(NULL) {}
};


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class VSurface {
protected:
	int w, h;					// ,
	int bpp;					// 1sNZbyte
	int pitch;					// 1Cbyte
	void *pixels;				// sNZf[^ւ̃|C^
	
	VRect rect;					// `̈
	VPalette *palette;			// pbg(8bpp̂)
	
	DWORD rmask, gmask, bmask;	// }XN
	int rshift, gshift, bshift;	// EVtg
	int rloss, gloss, bloss;	// Vtg
	
public:
	VSurface();									// RXgN^
	virtual ~VSurface();						// fXgN^
	
	virtual bool InitSurface( int, int, int );	// (T[tFXTCYw)
	void SetRect( int, int, int, int );			// `̈ݒ
	VRect *GetRect();							// `̈擾
	int SetPalette( COLOR24 *, int = 256 );		// pbgݒ
	VPalette *GetPalette();						// pbg擾
	
	void SetMask( DWORD, DWORD, DWORD );		// J[}XNݒ
	DWORD Rmask();								// R}XN擾
	DWORD Gmask();								// G}XN擾
	DWORD Bmask();								// B}XN擾
	int Rshift();								// REVtg擾
	int Gshift();								// GEVtg擾
	int Bshift();								// BEVtg擾
	int Rloss();								// RVtg擾
	int Gloss();								// GVtg擾
	int Bloss();								// BVtg擾
	
	int Width();								// 擾
	int Height();								// 擾
	int Bpp();									// 1sNZbyte擾
	int Pitch();								// 1Cbyte擾
	void *GetPixels();							// sNZf[^ւ̃|C^擾
	
	void PSet( int, int, DWORD );				// _`
	DWORD PGet( int, int );						// F擾
	void Fill( DWORD, VRect * = NULL );			// `̈hԂ
	void Blit( VRect *, VSurface *, VRect * );	// ]
};


#endif	// VSURFACE_H_INCLUDED
